2024-12-31  kyang2014  <kyang2014@users.noreply.github.com>

	Merge pull request #268 from OPENDAP/hyrax-1497
	HYRAX-1497, Provide an option to use UTF-8 encoding …

2024-12-31  myang6  <myang6@hdfgroup.org>

	HYRAX-1497, clean up code and follow clang-format

2024-12-30  myang6  <myang6@hdfgroup.org>

	HYRAX-1497, first version to provide an option to use UTF-8 
	encoding for the unescaped Unicode characters in DAP4.

2024-12-05  Kodi Neumiller  <kneumiller@opendap.org>

	Merge pull request #262 from OPENDAP/DmrppArray_uint
	Changed buf2val_ll to return int64_t.

2024-12-02  Kodi Neumiller  <kneumiller@mtech.edu>

	Added the "if" check back for BigArrayTest

2024-11-25  James Gallagher  <jgallagher@opendap.org>

	Changed code so derrived classes won't trigger compiler 
	warnings (#265)

2024-11-14  Kodi Neumiller  <kneumiller@mtech.edu>

	Turned on BigArrayTest all the time

2024-11-13  Kodi Neumiller  <kneumiller@mtech.edu>

	removed the cast to unsigned int

2024-11-12  James Gallagher  <jgallagher@opendap.org>

	Update/refactoring for MarshallerThread - lingering int <-> streamsiz… (#264)
	Update/refactoring for MarshallerThread - lingering int <-> streamsize issues.
	Fixed initialization if MarshallerThread.
	Some warnings also fixed

2024-11-07  The Robot Travis  <54914793+travis-ci-opendap@users.noreply.github.com>
	    ndp-opendap  <ndp@opendap.org>
	    James Gallagher  <jgallagher@opendap.org>

	Xsputn (#250)
	Changed byte counts in MarshallerThread from int to std::streamsize
	---------

2024-11-07  Orion Poplawski  <orion@nwra.com>

	Add #include <cstdint> ofor uint*_t types (#258)

2024-11-07  Kodi Neumiller  <kneumiller@mtech.edu>

	Changed buf2val_ll to return int64_t.

2024-09-10  kyang2014  <kyang2014@users.noreply.github.com>

	Merge pull request #257 from OPENDAP/hyrax-1427
	Hyrax 1427

2024-09-09  myang6  <myang6@hdfgroup.org>

	HYRAX-1427, ensure the clang format

	Merge branch 'master' into hyrax-1427

	HYRAX-1427, fixed the issue when the number of coverage of some 
	variables is not equal to the number of dimensions

2024-09-04  Nathan Potter  <ndp@opendap.org>

	Trying to quell the undefined-behavior errors (#256)
	Trying to quell the undfeined-behavior errors from the address sanitizer.
	Fixing etag and LMT values for test.opendap.org/test-304.html

2024-08-20  James Gallagher  <jgallagher@opendap.org>

	Updated comments.
	[skip ci]

2024-07-17  James Gallagher  <jgallagher@opendap.org>

	Updated pre-commit README with TL;DR section
	[skip-ci]

	Added a README about the pre-commit scripts and GitHub action.
	[skip-ci]

	Pre commit 1 (#254)
	Added a pre-commit config that will (re)format source code
	This change will use the clang-format program to reformat C++ source code
	to a particular standard. I will add a README describing the process and any
	steps needed for local configuration.

2024-06-25  James Gallagher  <jgallagher@opendap.org>

	Update grammar files to remove the deprecation warnings. (#253)

2024-06-10  James Gallagher  <jgallagher@opendap.org>

	Switched to the rocky8 Docker image for RPM builds (#252)
	Switched to the rocky8 Docker image for RPM builds
	Added CPPFLAGS and LDFLAGS to build-rpm.sh
	These are needed for RHEL8. Previously they were set in the
	docker container used for the centos-stream8 build but are
	not set (apparently) in the rocky8 container I made.

2024-03-15  James Gallagher  <jgallagher@opendap.org>

	Add undefined and ODR checks to the ASAN options (#249)
	Remove ODR flag since it is not part of gcc's ASAN
	Added -fsanitize=undefined  to two more Makefile.am files

	Merge branch 'master' of https://github.com/OPENDAP/libdap4

	Refactored SignalHandler (a singleton) (#247)
	Refactored SignalHandler (a singleton): Now uses the Meyers pattern.

2024-03-11  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of https://github.com/OPENDAP/libdap4

2024-03-08  James Gallagher  <jgallagher@opendap.org>

	Merged a PR from a fork - seemed to have issues in the final stage of CI/CD
	The master branch build failed with a note about local and remote repos
	not being in sync. This push to master should have fixed that.

	Removed hyrax-deps from build and added -fsanitize=undefined to asan (#245)
	Removed hyrax-deps from build and added -fsanitize=undefined to the ASAN 
	options

2024-03-08  Eli Schwartz  <eschwartz93@gmail.com>

	configure: avoid broken bashisms (#243)
	configure scripts are run with /bin/sh, and must use /bin/sh syntax rather 
	than bashisms.
	<<< is a bash specific syntax. Refrain from using it. Instead simply
	echo into a pipe, which does the same thing.

2024-02-26  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of https://github.com/OPENDAP/libdap4

	D4ce unit tests (#242)
	Replaced C-style assert() statements with exceptions and tests.
	I also wrote some unit tests for the D4ConstriantEvaluator class. It's not a 
	complete set of tests, but I demonstrate the use of a 'mock' class in unit testing.

2024-02-23  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of https://github.com/OPENDAP/libdap4

	D4ce assert refactor (#241)
	Removed use of assert(). Other refactorings added for C++14.
	Refactor D4FunctionEvaluator
	Added #include <memory> to D4FunctionEvaluator.cc
	More refactoring - change unsigned long long to int64_t
	Refactor to reduce complexity of mark_array_variable in D4ConstraintEvaluator
	Another refactor; reduce method complexity.

2024-02-22  James Gallagher  <jgallagher@opendap.org>

	Merge remote-tracking branch 'origin/master'

2024-02-06  James Gallagher  <jgallagher@opendap.org>

	Struct tm init fix (#240)
	Ensure 'struct tm' instances are initialized

2024-01-29  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of https://github.com/OPENDAP/libdap4

2023-11-30  kyang2014  <kyang2014@users.noreply.github.com>

	Merge pull request #234 from OPENDAP/hyrax-1247
	HYRAX-1247, adding two methods in DMR.h to handle direct IO.

2023-11-30  myang6  <myang6@hdfgroup.org>

	HYRAX-1247, adding two methods in DMR.h to handle direct IO. Also
	revise one similar method in Array.h

2023-11-07  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of https://github.com/OPENDAP/libdap4

	Added the clion-source-discovery target to Makefile.am
	[skip ci]

2023-10-31  myang6  <myang6@hdfgroup.org>

	Merge branch 'direct_chunk_io'

	Add comments for the new method.

2023-10-31  kyang2014  <kyang2014@users.noreply.github.com>

	Merge pull request #232 from OPENDAP/direct_chunk_io
	add a public method to allocate the data buffer

2023-10-16  myang6  <myang6@hdfgroup.org>

	add a public method to allocate the data buffer with the number of
	bytes, this is necessary to support direct chunk IO

2023-09-26  Bo Anderson  <mail@boanderson.me>

	Fix handling of libtirpc pkg-config files with -L flags (#228)

2023-09-26  Dan Horák  <dan@danny.cz>

	add missing include (#227)
	With GCC 13 the <cstdint> header isn't included thru other headers any
	more, thus include it explictly. Otherwise uint8_t or uint32_t type
	remain undefined in Vector.cc.
	Fixes: https://github.com/OPENDAP/libdap4/issues/226

2023-09-14  James Gallagher  <jgallagher@opendap.org>

	Fixed a bug where the copy ctor for D4Maps failed to correctly set the parent Array.
	This broke the object memory cache added to the DMR++ code in Hyrax.

2023-09-08  kyang2014  <kyang2014@users.noreply.github.com>

	Merge pull request #229 from OPENDAP/hyrax-1155
	Hyrax 1155

2023-09-07  myang6  <myang6@hdfgroup.org>

	HYRAX-1155, add comments to source code

	Adding direct io offset

2023-09-06  myang6  <myang6@hdfgroup.org>

	HYRAX-1155, add var chunk info to Array

2023-05-24  kyang2014  <kyang2014@users.noreply.github.com>

	Merge pull request #225 from OPENDAP/hyrax-1049
	Hyrax 1049

2023-05-21  Muqun Yang  <myang6@hdfgroup.org>

	 HYRAX-1049, reduce code smell

	 HYRAX-1049, clean up the code

	HYRAX-1049, ensure the group name doesn't include '/' in the routine
	that checks the variables

2023-05-19  Muqun Yang  <myang6@hdfgroup.org>

	HYRAX-1049, add code to fix the DAP4 coverage finding issues. Not compiled/tested.

2023-05-07  James Gallagher  <jgallagher@opendap.org>

	Trigger a build against the latest hyrax-dependencies

2023-05-04  James Gallagher  <jgallagher@opendap.org>

	Updated README for hyrax-deps build

2023-04-13  kyang2014  <kyang2014@users.noreply.github.com>

	Merge pull request #224 from OPENDAP/hyrax-974
	HYRAX-974, add a API to set a variable. Code needs to be cleaned up.

2023-04-13  myang6  <myang6@hdfgroup.org>

	 HYRAX-974, add another sanity check for index

	HYRAX-974, add comments for the set_var_index API.

2023-04-11  myang6  <myang6@hdfgroup.org>

	HYRAX-974, add a API to set a variable. Code needs to be cleaned up.

2023-03-13  kyang2014  <kyang2014@users.noreply.github.com>

	Merge pull request #222 from OPENDAP/hyrax-968
	Hyrax 968

2023-03-13  myang6  <myang6@hdfgroup.org>

	HYRAX-968, add a comment for the possible future optimization.

2023-03-10  myang6  <myang6@hdfgroup.org>

	HYRAX-968, reduce a code smell and add some comments/code-clean-up.

2023-03-09  Muqun Yang  <myang6@hdfgroup.org>

	HYRAX-968, use a new way to remove the additional maps.

2023-03-09  myang6  <myang6@hdfgroup.org>

	HYRAX-968, check the code to remove extra maps in the local constraint.

2023-01-30  James Gallagher  <jgallagher@opendap.org>

	Use C++14, fallback to 11. Fixed --enable-asan, too. (#220)
	Use C++14, fallback to 11. Fixed --enable-asan, too.
	Added an after_script to .travis.yml to upload test results to S3

2023-01-27  James Gallagher  <jgallagher@opendap.org>
	    Orion Poplawski  <orion@nwra.com>

	Add missing cstdint include for uint32_t (#219)
	Add missing cstdint include for uint32_t

2023-01-27  James Gallagher  <jgallagher@opendap.org>

	Removed the CentOS 7 build (#218)
	Removed the CentOS 7 build

2023-01-23  kyang2014  <kyang2014@users.noreply.github.com>

	Merge pull request #217 from OPENDAP/hyrax-913
	Hyrax 913 - large array size for fileout netcdf

2023-01-23  myang6  <myang6@hdfgroup.org>

	HYRAX-913, add override to a few methods to avoid the compiling warnings.

2023-01-19  myang6  <myang6@hdfgroup.org>

	HYRAX-913, need to obtain the big array size with dimension_size_ll()

2023-01-18  Nathan Potter  <ndp@opendap.org>

	Dap4 attr handling (#216)
	* Adding DAP2 attribute assement methods entry::is_dap4_type() and 
	  AttrTable::has_dap4_types()
	* Completed DDS::is_dap4_projected() implementation.
	* Added unit test for a dap4 typed global attribute in the DDS

2023-01-17  kyang2014  <kyang2014@users.noreply.github.com>

	Merge pull request #214 from OPENDAP/hyrax-868
	Hyrax 868 - the large-array size support

2023-01-17  myang6  <myang6@hdfgroup.org>

	HYRAX-868, change code according to Jame's suggestions.

	remove a comment

	HYRAX-868, change the big array unit test function names to make them more meaningful

2023-01-13  myang6  <myang6@hdfgroup.org>

	HYRAX-868, fix some code smells and a few inconsistent issues detected by sonar cloud

	HYRAX-868, remove some debugging info and fix an issue to use vector
	reference to set values of a large array.

2023-01-12  myang6  <myang6@hdfgroup.org>

	HYRAX-868, Make TestArray use the large array size handling methods.

2023-01-09  myang6  <myang6@hdfgroup.org>

	Merge branch 'master' into hyrax-868

	HYRAX-868, use the large size APIs in the DAP4 expression constraint
	code. Also add a few DBG lines.

2023-01-07  Nathan Potter  <ndp@opendap.org>

	Moving the functionality of is_dap4_projected() into libdap4 (#213)
	* Moving the functionality of is_dap4_projected() into libdap4
	* Adding is_dap4_projected() to DAP types.
	* Dropping DDS tests
	* Updaing CMakeLists.txt
	* Fixed tests but needs behavioral review.
	* Smell the flowers
	* Added attribute checking and checking os send_p()
	* Implemented is_da4_projected() with a vector<string> as the return value parameter
	* Removed is_dap4_projected() implementations with vector<BaseType *> as it's returned value parameter
	* Dropped old implementations of is_dap4_type() and has_dap4_types()
	* Added test for dap4 attributes in the root group
	* Comments
	* Fixed PR concerns
	* Updated is_dap4_projected in Array and Vector ot correctly handle COnstructor prototypes
	* Fixed IsDap4ProjectedTest memory leaks. Questions remain tho...
	* More test cleanup
	* Fixed lifecycle of array prototype variables.
	* Added const tag to an array variable loop
	* Updated code comments

2023-01-06  myang6  <myang6@hdfgroup.org>

	HYRAX-868, add more APIS for large array

2023-01-03  myang6  <myang6@hdfgroup.org>

	HYRAX-868, start handling data capacity

2022-12-30  myang6  <myang6@hdfgroup.org>

	HYRAX-868, add 64-bit support for value() and set_value()

2022-12-29  myang6  <myang6@hdfgroup.org>

	HYRAX-868, add contraint methods and unit-tests for large array support.

2022-12-28  myang6  <myang6@hdfgroup.org>

	Merge branch 'master' into hyrax-868

2022-12-07  Nathan Potter  <ndp@opendap.org>

	Fixing changes to ETag. Made test code more flexible. (#212)
	Fixing changes to ETag. Made test code more flexible.
	Added .gitallowed for test stuff

2022-12-05  myang6  <myang6@hdfgroup.org>

	HYRAX-868, make the simple big array val2buf, buf2val ,value,
	set_value unit-tests pass. More discussion is needed on the full and
	robust support.

2022-12-02  kyang2014  <kyang2014@users.noreply.github.com>

	Merge pull request #211 from OPENDAP/hyrax-879
	HYRAX-879, mostly use override to replace virtual for the virtual fun…

2022-12-01  myang6  <myang6@hdfgroup.org>

	HYRAX-879, remove 2 code smells>

	HYRAX-879, mostly use override to replace virtual for the virtual
	functions in the derived classes.

2022-11-14  kyang2014  <kyang2014@users.noreply.github.com>

	Merge pull request #210 from OPENDAP/BigArrayUTest
	Big array unit test

2022-11-14  myang6  <myang6@hdfgroup.org>

	HYRAX-863, remove two #if 0 #endif blocks and one unused variable.

2022-11-14  Muqun Yang  <myang6@hdfgroup.org>

	Merge branch 'master' into BigArrayUTest

	HYRAX-863, adding the Big Array Test.

2022-11-14  kyang2014  <kyang2014@users.noreply.github.com>

	Merge pull request #209 from OPENDAP/hyrax-865-new
	HYRAX-865, Fix the memory leaks in the DDX parser.

2022-11-14  Muqun Yang  <myang6@hdfgroup.org>

	Add the unit tests for big array handling. Three tests are added: 1)
	DAP4 val2buf and buf2val 2) DAP4 val2buf and value() 3) DAP2 set_value
	and value().

2022-11-11  Muqun Yang  <myang6@hdfgroup.org>

	HYRAX-863, add first test template for the big array test.

2022-11-11  myang6  <myang6@hdfgroup.org>

	intermediate debugging stage

	Merge branch 'master' into BigArrayUTest

2022-11-10  Muqun Yang  <myang6@hdfgroup.org>

	HYRAX-865, first cut to fix the memory leaks in the DDX parser.

2022-11-08  kyang2014  <kyang2014@users.noreply.github.com>

	Merge pull request #208 from OPENDAP/hyrax-864
	Hyrax 864

2022-11-08  Muqun Yang  <myang6@hdfgroup.org>

	HYRAX-864, revert back the change in del_attr_table() of AttrTable class. Explicitly release resources held by the Attribute table.

2022-11-04  Kent Yang  <myang6@hdfgroup.org>

	HYRAX-864, use unique ptr for some tests if possible.

2022-11-03  Muqun Yang  <myang6@hdfgroup.org>

	HYRAX-864, fixing unit-test memory leaks. delete_attr_table() has bugs that cause memory leaks.

2022-11-03  Kent Yang  <myang6@hdfgroup.org>

	HYRAX-864, the intermediate debugging stage.

2022-11-02  myang6  <myang6@hdfgroup.org>

	HYRAX-863, trim the original ArrayTest code a bit

	Adding an optional BigArray unit test to see if libdap can handle >4GB array. This check-in is only a skeleton. The BigArraytest is the same as the array test.

2022-10-14  James Gallagher  <jgallagher@opendap.org>

	Refactor sizes (#207)
	Provide a new API for getting variable sizes and DDS/DMR 'response' sizes
	This new API provides the size information using 64-bit integers, so that
	we can support larger data arrays. The specific additions to the API are:
	- Added BaseType::length_ll() and set_length_ll()
	- Added width_ll()
	- Updated the DMR::response_size_kb() to use width_ll()
	- Updated the DDS::get_response_kb() to use the width_ll()
	The length_ll() and width_ll() methods return signed int64_t which makes
	integration with the BES handler code easier (since -1 is used as a sentinel
	value). The response size methods return uint64_t.

2022-10-03  Dan Horák  <dan@danny.cz>

	add missing big endian baselines (#196)

2022-09-22  kyang2014  <kyang2014@users.noreply.github.com>

	Merge pull request #206 from OPENDAP/hyrax-804
	Hyrax 804

2022-09-22  myang6  <myang6@hdfgroup.org>

	HYRAX-804, add a section of code based on James' sugeestion. However, it failed a few tests. So leave a #if 0 for future investigation.

	HYRAX-804, pass the utf8 flag when internally transforming between DAP2 and DAP4 objects.

2022-09-20  myang6  <myang6@hdfgroup.org>

	HYRAX-804, add a flag for utf8 string escaping for both DAP2 and DAP4.

2022-09-19  James Gallagher  <jgallagher@opendap.org>

	D4map fix v1 (#205)
	The D4Maps have two modes of creation - one when the Array is being built by, e.g.,
	a handler and one when an Array is part of a deep copy operation. In the first case
	it's easy to know the pointer to the Array that is the source of the Map's values.
	However, during a deep copy, it's not possible to know this because the source Array
	cannot be accessed since the parent Array _does not yet exist_. In this case a
	second ctor is used that stores the FQN of the Map's source Array. This FQN can be
	read from the Map that is being copied. When the Map is then used (the whole dataset
	must exist), the FQN can be used to find the actual source Array object.
	Added a ctor that supports backward compat with code in the BES
	Added test for d4map-fix-v1 and verified that it fails on the master branch

2022-09-13  Dan Holloway  <d.holloway@opendap.org>

	Merge pull request #204 from OPENDAP/dap4-grid-functions
	Dap4 grid functions

2022-09-12  dh-opendap  <dholloway@opendap.org>

	Merging master branch (as of 9/12/2022) in dap4-grid-functions Merge
	branch 'master' into dap4-grid-functions

2022-09-07  ndp-opendap  <ndp@opendap.org>

	More tagging phaffing

	Adding tagging step to Travis build

2022-09-02  Nathan Potter  <ndp@opendap.org>

	Added methods that allow more monkeying around with arrays (#203)

2022-09-02  James Gallagher  <jgallagher@opendap.org>

	Refactor sizes (#193)
	Added BaseType::;ength_ll() and set_length_ll()
	Moved the implementation of length() and set_length() to Vector.h
	Modified the BaseType::intern_data() for DAP2 so that it cannot be called with DAP4 types.
	More changes - see Hyrax-790
	Added #include <typeinfo> to Vector.cc
	Also added support for 'master' --> 'main' for the default branch.
## -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
##  libdap4-3.20.11-32
##  hyrax-1.16.8-25
##

2022-09-01  ndp-opendap  <ndp@opendap.org>
	
	Refining commit message format
	
	Reformatted automated commit message forBES build trigger.
	
2022-08-31  James Gallagher  <jgallagher@opendap.org>
	
	Undo the change to Str::print_val() (#200)
	Undo the change to Str::print_val()
	
	Added test-deploy to libdap4 (#202)
	
2022-08-30  James Gallagher  <jgallagher@opendap.org>
	
	Fixed how Str variables are printed. (#199)
	Fixed how Str variables are printed.
	String variables were printed using the Attribute escaping 
	code. This lead to odd
	behavior when that code was updated to correct years-long 
	issues that we had been
	papering over. I added new code to Str.cc to escape the Str and 
	Url class' values.
	Note that this is really only used by things like getdap & 
	getdap4 and in test code.
	
2022-08-25  kyang2014  <kyang2014@users.noreply.github.com>
	
	Merge pull request #198 from OPENDAP/hyrax-708-esc-das
	Hyrax 708 esc das
	
2022-08-25  myang6  <myang6@hdfgroup.org>
	
	reduce several sonar cloud smells
	
	HYRAX-708, 1) Unescape the special characters when parsing DAS 
	from a file. 2) Update tests. 3) Make DmrRoundTrip and DmrToDap2 tests 
	temporarily no-op. Will re-visit them later.
	
2022-08-23  myang6  <myang6@hdfgroup.org>
	
	HYRAX-708, update the das baseline files to reflect the 
	escaping of the special characters for string attributes.
	
2022-08-22  James Gallagher  <jgallagher@opendap.org>
	
	Addedd comment about D4Group dims()
	[skip ci]
	
2022-08-22  myang6  <myang6@hdfgroup.org>
	
	Merge branch 'master' into hyrax-708-esc-das
	
	HYRAX-708, update the escaping functions for DAP4 XML, DAP2 XML 
	AND DAS. Temporarily turn off two DAS tests that contain the special 
	characters.
	
2022-08-17  ndp-opendap  <ndp@opendap.org>
	
	Updating trtavis-ci-opendap github credentials
	
2022-08-12  myang6  <myang6@hdfgroup.org>
	
	Merge branch 'master' into hyrax-708-esc-das
	
2022-08-08  James Gallagher  <jgallagher@opendap.org>
	
	Modify D4Group::find_var() so it can find D4Groups (#194)
	Modify D4Group::find_var() so it can find D4Groups
	When a path in a CE specifies a Group, we should be returning 
	all the
	variables in that Group. Right now libdap just throws an 
	exception. Once
	find_var() returns the BaseType* to the Group, we should be set 
	to mark
	all of the Group's variables as part of the projection.
	Added print_val and print_decl methods to D4Group.
	This will make it easy(ier) to add tests for the new 'all vars
	in a group' feature/fix.
	Added tests for the 'Group projection' feature/fix
	Now projection works for Groups and nested groups both and 
	without
	member variables. That is, for normal groups (ones with child
	variables) naming the group in a CE results in all the 
	variables in
	that group and its child groups being included in the response. 
	For
	Groups that only contain attributes, naming the group in the CE 
	will
	cause that group to be included in the dap (i.e., data) 
	response. This
	dubious behavior is ... well, dubious. But modulo the 
	correctness of
	attributes in the face of a constraint, it does work.
	See DMRTest 243 - 249 plus some of the D4GroupTest unit tests.
	
2022-07-21  ndp-opendap  <ndp@opendap.org>
	
	Updating build offset for TravisCI
	
	Preparing release 3.20.11, Hyrax-1.16.8
 
#	
# -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
# libdap version 3.20.11
#

2022-07-19  ndp-opendap  <ndp@opendap.org>

	Fixed bug in computation of request_size_kb()

2022-07-09  Nathan Potter  <ndp@opendap.org>

	Fixing type issue in HTTPCache.cc (#192)

2022-07-01  ndp-opendap  <ndp@opendap.org>

	Adding DOI to README.md [skip ci]

	Updating LIBDAP_TRAVIS_BUILD_OFFSET to 1018 for re;ease 3.20.10

	Preparing release 3.20.10, Hyrax-1.16.6

#	
# -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
# libdap version 3.20.10
#

2022-06-27  James Gallagher  <jgallagher@opendap.org>

	Rhel 8 tirpc (#191)
	Added a test for the correct configuration of tirpc on rhel 8
	Added more messages to OX_RHEL8_TIRPC macro

2022-06-20  James Gallagher  <jgallagher@opendap.org>

	Replaced instances of &vector[0] with vector.data() (#190)
	There are two cases where the pattern was used with strings
	where .data() won't work and is not needed (working with char[]
	and whre &char[0] will always work).

2022-06-14  ndp-opendap  <ndp@opendap.org>

	Trigger TravisCI

2022-05-24  James Gallagher  <jgallagher@opendap.org>

	Removed extra header (#189)

2022-05-09  James Gallagher  <jgallagher@opendap.org>

	Fix Constructor::read() (#188)
	Fix Constructor::read()

2022-04-27  James Gallagher  <jgallagher@opendap.org>

	Constructor refactor (#187)
	Constructor refactor

2022-04-26  James Gallagher  <jgallagher@opendap.org>

	Fixed some warnings about bind2nd(), etc. (#186)
	Fixed some warnings about bind2nd(), etc.

2022-03-10  James Gallagher  <jgallagher@opendap.org>

	Edit to README - trigger a travis build

2022-03-09  James Gallagher  <jgallagher@opendap.org>

	Fix for for the last merge that only shows up in the bes (#185)
	The ServerFunctionList was flagged by sonarscan but my fix contained a logic flaw.
	The libdap tests didn't uncover that, but tests in the BES did. This fixes the logic flaw.

	a small set of improvements (#184)

2022-03-08  James Gallagher  <jgallagher@opendap.org>

	Fixed memory issues in the client-side cache in libdap (#183)
	Fixed memory issues in the client-side cache in libdap

2022-03-04  James Gallagher  <jgallagher@opendap.org>

	Unit test improvement (#182)
	Modified unit-tests so they all use a template for main()
	This reduces the code by 52 tests times 40 lines of code or
	about 2k LOC. It also fixes many small errors that crept into
	the tests as various parts were copied incorrectly or mistakenly
	edited.

2022-02-21  James Gallagher  <jgallagher@opendap.org>
	    Kodi N  <kneumiller@opendap.org>
	    James Gallager  <jgallager@opendap.org>

	Leak fixes (#181)
	Fixed an issue in Vector where assignment leaked d_proto.
	If the destination Vector already had an object pointer assigned
	to d_proto then both operator=() and the copy ctor would leak
	that pointer.
	Minor changes to marshT and Array.cc

2022-02-18  James Gallagher  <jgallagher@opendap.org>

	One more version. (#180)

2022-02-18  kyang2014  <kyang2014@users.noreply.github.com>

	Merge pull request #179 from OPENDAP/d4a-erase-lkeak-fix
	Fixed the leak I hope...

2022-02-18  James Gallagher  <jgallagher@opendap.org>

	New new version of erase.
	Also some more hacking for leak detection

2022-02-17  James Gallagher  <jgallagher@opendap.org>

	Added some notes about leak detection in unit-tests/Makefile.am
	I also changed how two of the tests are built, so they link with
	the static archive since this seems to cause the linker to choose
	the locally-built library (where linking dynamically did not).

	Addressed a 'code smell'

	Fixed the leak I hope...

2022-02-16  James Gallagher  <jgallagher@opendap.org>

	Added an erase method to D4Attributes (#178)
	Added an erase method to D4Attributes
	Switched from explicit for-loop to erase(remove_if())
	Added the algorithm header to D4Attributes.cc

	Fixed all the remaining operator=() implementations (#177)

	Removed commented code [skip ci]

	Fixed the issue with operator=() reported by sonar scan (#176)

2022-02-15  James Gallagher  <jgallagher@opendap.org>

	Fix for libdap4 github issue 147:  Grid::get_map_iter() was off by one (#175)
	Fix for libdap4 github issue 147:  Grid::get_map_iter() was off by one
	Added tests for the affected method as well as some related methods in Grid.

2022-02-13  James Gallagher  <jgallagher@opendap.org>

	Dds dmr refactor (#171)
	I refactored DDS and DMR to remove old code and provide better iterator access
	DDS: New way of accessing the 'vars' vector makes range-based for
	loops possible.
	I removed old code that was excluded with the pre processor.
	Old code n configure.ac was removed.
	Now DAP4 builds by default and the only form of the DDX that is supported
	is the 3.2 version
	Added tests for the new DDS::variables() method that returns a const & to vars.

2022-02-11  James Gallagher  <jgallagher@opendap.org>

	Added caching and a wait for the quality gate test (#174)

	Removed excess lines in README.md and triggered a master build

	New way of implementing assignment should avoid slicing (#173)
	* New way of implementing assignment should avoid slicing
	* Comments editing and unused code removed
	[skip ci]

2022-02-10  James Gallagher  <jgallagher@opendap.org>

	Build libdap RPMs on CentOS-Stream8 (#172)
	Build libdap RPMs on CentOS-Stream8
	Removed the github workflows - no sense using their machines

2022-02-04  James Gallagher  <jgallagher@opendap.org>

	Fixed an error in the recent fix for inverted array index values
	In DAP2 we changed array slicing so that [*] means all values of
	the array. In the code, we replace the * with stop value of -1 so that
	syntax like [7:*] can be used to get all the values from i position
	7 to the end of the dimension for a particular array. The stop == -1 was
	breaking the fix I added to test if start is > stop. I hacked a change
	in to special case the -1 vaule of stop. A better approach would be
	to handle this in the parser to read the end value of the dimension,
	but we don't have that information handy in the DAP2 parser (the DAP4
	parser is much better about this sort of thing).

	Fix HYRAX-540 - array index values where start is > stop break the server (#170)
	Fixed ticket https://bugs.earthdata.nasa.gov/browse/HYRAX-540 for DAP2 and DAP4
	Other fixes in this PR:
	The DAP4 ce parser was accepting negative array indices; fixed.
	Removed auto_ptr vestiges
	Fix for parallel clean issue in distclean
	Added tests for the DAP2 and DAP4 fix for inverted index values.
#	
# -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
# libdap version 3.20.9
#

2021-12-17  ndp-opendap  <ndp@opendap.org>

	Merge branch 'master' of https://github.com/OPENDAP/libdap4

	Triggering TravisCI build

2021-12-09  James Gallagher  <jgallagher@opendap.org>

	Reverse the switch to C++11 regex - now a comp time option (#167)

2021-12-03  James Gallagher  <jgallagher@opendap.org>

	Fixed for automake 1.16

	Added rm -rf dods_cache back to Makefile
	Not sure why that's needed, however.

	unit-tests/cache-testsuite cleanup.sh failing again

	Regex fix (#166)
	Reworked Regex class (in GNU/GNURegex.h/.cc)
	Also some other fixes from sonar scan suggestions and
	a fix to getdap4. These should have go in on their own
	branch, but wound up here.
	To improve performance, added 'const' to some of the Regex instances
	so they will be constructed (and the regex compiled) only once.

2021-11-24  James Gallagher  <jgallagher@opendap.org>

	build_btp_args() fix

	Removed code smells (#165)

2021-11-23  James Gallagher  <jgallagher@opendap.org>

	Dump auto ptr (#164)
	Time to remove the old auto_ptr code
	Also removed bind2nd and ptr_fun from D4Group and
	replaced it with a lambda. In C++-17, bind2nd goes away.
	Also includes a fix for distcheck on automake 1.16

	Removed unsupported options from getdap4, replaced GetOpt with getopt (#163)
	Also reformatted the help.

2021-11-04  Nathan Potter  <ndp@opendap.org>

	Added build number to configure call in libdap.spec.in (#161)

2021-11-01  ndp-opendap  <ndp@opendap.org>

	Restoring previous TravisCI stage order

2021-10-29  ndp-opendap  <ndp@opendap.org>

	Merge branch 'master' of https://github.com/OPENDAP/libdap4

	This might be the one... looks like sonar s working for real."

	This might be the one...

	More with sonar scan coverage issues

	More with sonar scan coverage issues

	More with sonar scan coverage issues

	More with sonar scan coverage issues

	More with sonar scan coverage issues

	Returned CI to mominal stage order.

	Working on getting the coverage files into the sonar system

	Working on getting the coverage files into the sonar system

	Trying to ammend sonar properties

	Trying to ammend sonar properties

	Trying to ammend sonar properties

	Trying to ammend sonar properties

	Trying to ammend sonar properties

2021-10-28  ndp-opendap  <ndp@opendap.org>

	Debugging scan stage

	Enable scan stage

	Enable scan stage

	Reenabling full build

	Switched libdap_version() to CVER. release-buildnum

	Probing Package_Version

	Debugging RPM build.

2021-10-27  James Gallagher  <jgallagher@opendap.org>

	new credentials (#159)
	New encrypted credentials for AWS

	Moved the [[deprecated]] annotations into the doxygen comments (#160)
	Moved the [[deprecated]] annotations into the doxygen comments
	Adding C++-14 features to our code makes for many warnings
	which hides errors.
	Add login for docker hub

2021-10-20  The-Robot-Travis  <npotter@opendap.org>

	Removed [[deprecated ...]] from headers - it's fine in the .cc files
	[skip ci]

2021-09-17  James Gallagher  <jgallagher@opendap.org>

	Spelling fixes in configure.ac
	[skip ci]

2021-09-16  dh-opendap  <dholloway@opendap.org>

	skip ci

2021-09-15  dh-opendap  <dholloway@opendap.org>

	Updated on 2021-09-15
	
# libdap version 3.20.9

2021-08-18  ndp-opendap  <ndp@opendap.org>

	Merge branch 'master' of https://github.com/OPENDAP/libdap4

	Added travis-ci-opendap token

2021-08-12  James Gallagher  <jgallagher@opendap.org>

	Modified Error so that it is more in line with C++11 (#158)
	This is a test for similar changes that we should make in the BES

	Co-authored-by: The-Robot-Travis <npotter@opendap.org>

2021-07-22  The-Robot-Travis  <npotter@opendap.org>

	Removed generated grammar files from CMakeLists.txt
	[skip ci]

	Make CMakeLists.txt use dirs conditionally
	[skip ci]

2021-06-22  ndp-opendap  <ndp@opendap.org>

	Disambiguation of the pooorly overloaded set_response_limit() methods in DDS and DMR to set_response_limit_kb()

2021-06-21  Nathan Potter  <ndp@opendap.org>

	Added (shallow) unit64_t request size computations and max_request_size state. (#156)
	* Added (shallow) Int64 request computations and max_regquest_size state.

	* Added include for <cstdint> as needed.

	* Added -std=c++11 / -std=gnu++11 as reasonable,

	* TWeking -std=c+11 flag production

	* More with the CXX11_FLAG fiddles

	* More with the CXX11_FLAG fiddles

	* More with the CXX11_FLAG fiddles

	* More with the CXX11_FLAG fiddles

	* More with the CXX11_FLAG fiddles

	* More with the CXX11_FLAG fiddles

	* - Changed the internal representation of max response size
	  to uint64_t and confined the overflow to just the
	  (deprecated) functions

	* Docs updated

	* Small errors fixed.

	* COnst and comments

	* Dropping const reference and adding comments.

2021-06-21  James Gallagher  <jgallagher@opendap.org>

	Add support for includes prefixed with 'libdap' (#157)
	Add support for includes prefixed with 'libdap'

	This fix enables code like #include <libdap/Array.h> which
	will fix the issue where Array.h clashes with C++-11's 'array.h'
	that differs in case only (and triggers warnings in IDEs
	making using them tedious. It will also pave the way for code
	that uses two different libraries' headers.

	Co-authored-by: The-Robot-Travis <npotter@opendap.org>

2021-05-20  James Gallagher  <jgallagher@opendap.org>

	Actions test (#153)
	Update the main.yml workflow.

	* Use multi-repo checkout@v2 action
	* Bump Ubuntu version to 20.04, added apt-get packages needed for Ubuntu 20
	* A better way to handle changes in the dependencies: use the hashFiles() function. This
	way any change in the dependencies version will trigger a rebuild.
	* All but the main workflow now in 'unused' folder. We need to get the hyrax-deps, libdap4,
	bes, hyrax-docker chain sorted before we start using the pipeline for real.

2021-05-18  James Gallagher  <jgallagher@opendap.org>

	Switch to bionic (#155)
	Fix failed distcheck target

	Merge branch 'master' of https://github.com/OPENDAP/libdap4

	trigger a test build

2021-05-14  ndp-opendap  <ndp@opendap.org>

	Added the built files libdap.spec and libdap_VERSION to .gitignore

2021-05-08  The-Robot-Travis  <npotter@opendap.org>

	Trying to fix libdap4 trigger of BES build.

	Triggering CI build.

2021-05-07  Nathan Potter  <ndp@opendap.org>

	This adds a -S switch that when used (#154)
	in conjunction with the -d (print DMR) switch will
	compute the size of the data reoresented by the DMR and print out that value.

	Co-authored-by: The-Robot-Travis <npotter@opendap.org>

2021-05-06  The-Robot-Travis  <npotter@opendap.org>

	Added a description of the build-number scheme to trigger-bes-build.sh
	[skip ci]

2021-05-05  The-Robot-Travis  <npotter@opendap.org>

	Travis.yml now uses libdap_VERSION

	Updated the trigger_bes_build.sh script

	VERSION is version on OSX and that's an issue for the 11.3.1 compier
	Fixed: VESION.in --> libdap_VERSION.in

2021-03-29  James Gallagher  <jgallagher@opendap.org>

	Only trigger the BES build for master, not for PRs (#152)
	Only trigger the BES build for master, not for PRs

2021-03-24  The-Robot-Travis  <npotter@opendap.org>

	Adding build numer to bes trgger

2021-03-23  James Gallagher  <jgallagher@opendap.org>

	Build number option (#151)
	Modify the build so that the source and rpm distributions include build numbers

	We've adopted a x.y.z-build version/build number scheme. Automate that so that
	the build number part of the version/build number is incremented automatically
	with every build of the master branch. To do this, I added a file name VERSION
	that holds the number, a new option -with-build to the configure script and mods
	to the .travis.yml, build-rpm.sh, and Makefile.am files.

2021-03-12  kyang2014  <kyang2014@users.noreply.github.com>

	HK-726, Don't make DAP4 empty container attribute fail. (#150)
	* HK-726, Don't make DAP4 empty container attribute fail.

	* HK-726, edit the comments to make the github check pass.

2021-03-11  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of https://github.com/opendap/libdap4

	Modified main.yml workflow to use updated $PATH

2021-03-10  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of https://github.com/OPENDAP/libdap4

	Removed special invokation of HttpConnectTest [skip ci]

2021-03-10  The-Robot-Travis  <npotter@opendap.org>

	Again, names

	Fixed incorrect stage name [skip ci]

	Added names to travis stages.

	Adding an after_deploy trigger to build the BES

2021-03-04  ndp-opendap  <ndp@opendap.org>

	Rewind

	Merge branch 'master' of https://github.com/opendap/libdap4

	Bump for ci

2021-03-01  James Gallagher  <jgallagher@opendap.org>

	Minor change to the main GH workflow - removed some debugging code.
	Thsi will also serve to force the Travis CI/CD system to build
	new deployments, which we need since hyrax-dependencies has just
	been updated.

2021-02-23  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #149 from OPENDAP/HK-724
	Hk 724

2021-02-23  Kent Yang  <myang6@hdfgroup.org>

	Merge branch 'HK-724' of https://github.com/opendap/libdap4 into HK-724

	The memory for the string object allocated by build_typed_instance in expr.h needs to be released.

2021-02-23  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #148 from OPENDAP/HK-724
	HYRAX-315,HK-724, add a boolean flag that indicates if the DAP4 expre…

	Remvoed Debian package build; added const qualifier back to get_ce_empty().

	Debugging the Travis build - removed const from DMR::get_ce_empty()

2021-02-23  Kent Yang  <myang6@hdfgroup.org>

	Add another empty line. Another try for pull request to make travis check go through

2021-02-22  Kent Yang  <myang6@hdfgroup.org>

	HK-724,HYRAX-316, the check at github somehow doesn't get passed. Add an empty line to see if this is an incident.

	HK-724,HYRAX-316, add a const for get_ce_empty() function.

	HYRAX-315,HK-724, add a boolean flag that indicates if the DAP4 expression constriant is empty in DMR. Add/update relevant methods

2021-01-28  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #146 from OPENDAP/actions-test
	Actions test

	Removed debugging from centos 7 rpm workflow

	Removed som eleftover debugging from the workflows. Added upload of the source distribution.

	Added a seconf 'check' target to run HTTPConnectTest in debug mode
	I'm tracking down an error that has appeared in code that has not
	changed in 16 years and happens only sporadically. The errors may
	be in Travis itself since our GH Action CI builds don't show any
	of these issues. But, it's a poor carpenter that blames tools.

2021-01-27  James Gallagher  <jgallagher@opendap.org>

	Hacked check target.

	Merge pull request #144 from OPENDAP/debug-http-test
	Debug http test

	Force HTTPConnectTGest to build before running check-local

	Why does HTTPConnectTest.cc fail on travis?

	Merge branch 'master' of https://github.com/opendap/libdap4

	Merge pull request #143 from OPENDAP/feature/test-buildout
	Feature/test buildout

	Merge pull request #141 from OPENDAP/configure-coverage-fix
	Added test to --enable-coverage to see if gcov is present.

2021-01-26  blackone-sudo  <ogieeweka007@gmail.com>

	workflow clean up before merge to master

	update source dist package

	update source dist package

2021-01-25  blackone-sudo  <ogieeweka007@gmail.com>

	change s3 cred

	change s3 cred

	change s3 cred

	change s3 cred

	change s3 cred

	change s3 cred

	branch clean up

2021-01-22  blackone-sudo  <ogieeweka007@gmail.com>

	current commit working

2021-01-11  ndp-opendap  <ndp@opendap.org>

	Fixed HttpConnectTest by adding new etag for test-304.html

2020-12-29  ndp-opendap  <ndp@opendap.org>

	Added libdap-3.20.7 DOI to README.md [skip ci]

2020-12-29  James Gallagher  <jgallagher@opendap.org>

	Added test to --enable-coverage to see if gcov is present.

2020-12-29  ndp-opendap  <ndp@opendap.org>

	Changing REVSION and resetting AGE

	Updating for release of libdap-3.20.7

2020-12-18  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of https://github.com/opendap/libdap4

	Fixed a comment on the --emable-coverage configure option
	Also added a gcovr report.
	[skip ci]

	Merge pull request #140 from OPENDAP/code-coverage
	Report now built using gcovr, and a small syntax fix

	Report now built using gcovr, and a small syntax fix
	The gcovr report might show different detatils than the reports
	from sonarscan.

2020-12-16  blackone-sudo  <ogieeweka007@gmail.com>

	Merge branch 'actions-test' of https://github.com/OPENDAP/libdap4 into feature/test-buildout

2020-12-16  James Gallagher  <jgallagher@opendap.org>

	Added caching to the centos 7 docker build

	Syntax error fixed

	Added caching of the bison build

2020-12-15  James Gallagher  <jgallagher@opendap.org>

	Fixed syntax error in the build.yml

	Build the bison dependency

2020-12-01  James Gallagher  <jgallagher@opendap.org>

	Syntax fix

	Try building hyrax-deps and then libdap4

	Fixed name of action build env from 'xenial' to '16.04'

	Switched to ubuntu xenial from latest

	Travis should now package the code
	Added a CMakeLists.txt to keep CLion from complaining.
	Moved the error buffer libcurl call so it's run before
	all of the setopt calls.

	Reorder code to see if that placates sonarscan

	Merge pull request #139 from OPENDAP/curl-init-fix
	Fixed an issue with curl_easy_init

	Fixed an issue with curl_easy_init

	Merge pull request #138 from OPENDAP/enable-coverage
	Enable coverage

	Fixed an issue. Coverage computed and gcovr working. Not SonarScan
	No idea why sonarscan is not working. However, we get a report and
	maybe codecov will come to the rescue.

	Added coverage collection to the scan step
	Not doing anything with the coverage data, however

	Updated to hopefully work on Ubuntu. Works on OSX

	Working on teh odd segmentation fault on Ubuntu

	limit this branch travis build to a scan

	Try Ubuntu focal

	Try Ubuntu bionic

	Drop back to xenail - Maybe this will fix the missing FlexLexer.h issue

	Try turning off virtual memory randomization

	Let's try bionic, using acontainer

	Try gcovr ...

	Try removing the second 'addons' section to squash the missing cppunit bug

	Arrrgh bionic won't work with the flex/bison versions we use

	Coverage working using gcovr to process the gcov files.

	Next step is to get SonarScan to use the gcovr report.

	More work on gcovr - now it's excluding the test code

	Now the gcov reports might be used by sonarscan

	They are copied to a single directory and the sonarscan tool
	is configured to look there for the reports.

	Started adding support for

	Another fix for the coverage files

	Both cp and mv won't copy files on top of other files in the same
	command (so --force and --backup won't help). I suppressed copying
	the stack.hh.gcov, etc., files from the d4_ce and d4_function
	directory. The mv/cp commands were failing and thus so was the build.

	Set the sonar.coverage.jacoco.xmlReportPaths prop to gcov-reports

	Another try at getting the coverage reports to work.

	Remove ls -lR as it doesn't seem to be doing much.

	We have coverage data, but it's not getting into sonarcloud.
	Time for user support.

	Edited travis.yml coverage lines - cleaned up old comments

	Fixed coverage so there's no error?

2020-11-29  James Gallagher  <jgallagher@opendap.org>

	Fix the osx/brew good - no sudo

	Fix the build.yml actions workflow

	Fix to the osx and ubuntu builds using github actions

2020-11-28  James Gallagher  <jgallagher@opendap.org>

	Update to build.yml action

	Change the github actions build file. Include CentOS7.

2020-11-18  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' into enable-coverage
	 Conflicts:
		Makefile.am
		d4_ce/Makefile.am
		d4_function/Makefile.am

	Removed tests and unit-tests from the coverge collection target

2020-11-18  James Gallagher  <jimg@localhost.localdomain>

	Added better 'coverage' target that will recurse
	It's a little rough, but it works OK.

	Added coverage.mk file

2020-11-17  James Gallagher  <jimg@localhost.localdomain>

	Coverage data collected, but no gcov files
	The recursive gcov/coverage rule doesn't work correctly

2020-11-13  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #136 from OPENDAP/sonarscan-test
	If the SonarScan Quality gate fails, fail the PR

	Merge pull request #137 from OPENDAP/distcheck-fix
	fix for distcheck on autoconf 2.69

	fix for distcheck on autoconf 2.69

	If the SonarScan Quality gate fails, fail the PR

	Merge pull request #135 from OPENDAP/d4dimension-size-fix
	Changed the size of a D4Dimension 'size' to unsigned long long

2020-11-12  James Gallagher  <jgallagher@opendap.org>

	Changed the size of a D4Dimension 'size' to unsigned long long
	size_t can vary between 16 and 64 bits, long long has to be
	64 bits.

	Merge pull request #134 from OPENDAP/vector-string-fix
	Fixed the set_vector() method

	Fixed the set_vector() method
	I introduced a fix that was based on a missunderstanding
	of the code. This backs that change out.

2020-11-06  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #132 from OPENDAP/vector-string-fix
	Back-out the bad Vector of string mistake

	Merge branch 'vector-string-fix' of https://github.com/opendap/libdap4 into vector-string-fix

	Back-out the bad Vector of string mistake

	Backout the bad Vector or string mistake

2020-11-02  James Gallagher  <jgallagher@opendap.org>

	Fixed the build-gh-pages.sh script.
	[skip-ci]

	Added new docs

	Merge pull request #130 from OPENDAP/string_vector_bug
	String vector bug

	Merge pull request #129 from OPENDAP/switch-to-xenial
	Changed .travis.yml to use xenial (from trusty)

	Updated this branch. I think it's ready for a merge.

	Merge branch 'master' into string_vector_bug

	Changed .travis.yml to use xenial (from trusty)

2020-10-25  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #121 from OPENDAP/sonarcloud-suggestions
	Sonarcloud suggestions

	Merge pull request #128 from OPENDAP/remove-c6
	Removed the CentOS 6 build from .travis.yml

2020-10-23  James Gallagher  <jgallagher@opendap.org>

	Removed the CentOS 6 build from .travis.yml

2020-09-27  ndp-opendap  <ndp@opendap.org>

	Fixed bug in string handling in Vector

2020-09-23  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #126 from OPENDAP/error-fix
	Fixed an issue in Error

	Fixed an issue in Error
	The what() method was returning a pointer to a temporary object.

2020-08-31  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #125 from OPENDAP/configure-fix
	Complete revert of configure.ac to the old xml config code

	Complete revert of configure.ac to the old xml config code

2020-08-28  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #124 from OPENDAP/configure-fix
	Fix for pkg-config code for libxml2

	Fix for pkg-config code for libxml2

2020-08-26  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' into sonarcloud-suggestions

	Fix for CentOS 6
	Shell scripts with empty 'then' clauses fail with whatever bash
	version is part of CentOS 6.

	Better support for CLion so it can find functions

2020-08-25  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #122 from OPENDAP/xml2-lib-build-fix
	Added better support for libxml2 in configure

	Fix for linux and xml2/configure

	Added better support for libxml2 in configure

2020-07-24  James Gallagher  <jgallagher@opendap.org>

	REmove assert from InternalErr::operator=()

	more fixes

2020-07-23  James Gallagher  <jgallagher@opendap.org>

	Added dtor and op= to D4EnumDef

2020-07-22  James Gallagher  <jgallagher@opendap.org>

	Fixes to enable configure --enable-coverage. Does not work on OSX.

2020-07-15  James Gallagher  <jgallagher@opendap.org>

	added autoreconf

	Create c-cpp.yml

2020-07-07  James Gallagher  <jgallagher@opendap.org>

	Typo in error message.
	[skip ci]

2020-06-30  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #120 from OPENDAP/errors-with-line-nums
	Added file/line info to the libdap::Error class

2020-06-17  James Gallagher  <jgallagher@opendap.org>

	Added file/line info to the libdap::Error class

2020-05-29  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #119 from OPENDAP/chunk-header-fix
	Chunk header fix

	Based on info from Dennis Heimbigner, fixed the DAP4 chunked I/O Stream
	I was sendng the chunk header bytes in host byte-order and not
	network byte order.

2020-05-18  James Gallagher  <jgallagher@opendap.org>

	Comment fix

2020-05-17  James Gallagher  <jgallagher@opendap.org>

	Adopt network byte order for the chunk header

2020-05-06  kyang2014  <kyang2014@users.noreply.github.com>

	Merge pull request #117 from OPENDAP/hk-638
	HK-638, add the buf2val function for 64-bit integer.

2020-05-06  Muqun Yang  <myang6@hdfgroup.org>

	HK-638, add the buf2val function for 64-bit integer.

2020-04-21  ndp-opendap  <ndp@opendap.org>

	Added release DOI to README.md, did some formatting. [skip ci]

	Make release 3.20.6

2020-04-16  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #115 from OPENDAP/error-msg-fix
	Error msg fix

2020-04-15  James Gallagher  <jgallagher@opendap.org>

	Test baselines for ce parser message fixes
	And a few more fixes to the messages.

	Added tests for the DAP4 CE parser error messages

	Added tests for the parser error messages.

2020-04-14  James Gallagher  <jgallagher@opendap.org>

	Additional work on the DAP4 function parser.

	Changes to the CE parser to address a xss attack.

2020-04-04  James Gallagher  <jgallagher@opendap.org>

	Fixed a mistake in an error message in configure.ac
	[skip ci]

2020-02-16  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #113 from OPENDAP/sonarscan-fix
	Fix for travis and sonarscan based on travis support email

2020-02-15  James Gallagher  <jgallagher@opendap.org>

	Fix for travis and sonarscan based on travis support email

2020-02-14  James Gallagher  <jgallagher@opendap.org>

	Fixed CentOS6 pre std=c++0x issues.

	Merge branch 'master' of https://github.com/opendap/libdap4

	Swapped out unique_ptr for auto_ptr because of CentOS6 build fail
	This problem is exacerbated by flex 2.5.35 which fails to build code
	that will compile on C6 using --std=c++0x.

2020-02-13  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #112 from OPENDAP/parser-util-fix
	Switched to faster functions for CE and Attribute value checking.

	Switched to faster functions for CE and Attribute value checking.

	Added README.md to EXTRA_DIST

	Changes that address (I think) issues with the recent rename of README to README.md
	I'm pushing this directly onto master because the CI build on a PR branch
	did not show the issues.

	Merge pull request #111 from OPENDAP/readme-rename
	Renamed README to README.md

2020-02-12  James Gallagher  <jgallagher@opendap.org>

	Added README.md; removed scan from build to test issues with said scan

	Renamed README to README.md
	Also trying to debug the sonarscan issue where travis cannot find
	executable.

	Revert "Merge pull request #109 from OPENDAP/cppunit-build-fix"
	This reverts commit 3f07795a1e6e228802321797728209fce5ee4962, reversing
	changes made to f4672a3fc673ad6e330cad00254bfb813865f8bd.

	Revert "Merge pull request #107 from OPENDAP/cppunit-build-fix"
	This reverts commit 3f07795a1e6e228802321797728209fce5ee4962, reversing
	changes made to f4672a3fc673ad6e330cad00254bfb813865f8bd.

	Merge pull request #109 from OPENDAP/cppunit-build-fix
	This change to configure.ac fixes the build for cppunit 1.14.0

	Merge pull request #108 from OPENDAP/natural_axes
	Natural axes #1

2020-02-11  James Gallagher  <jgallagher@opendap.org>

	Suppres include of unistd.h by the flex sources
	This is an attempt to fix a c++-11 build issue on linux with modern gcc
	versions.

	This change to configure.ac fixes the build for cppunit 1.14.0
	The fix instructs the compiler to use --std=c++-11 or c++-0x which
	enables cpp 1.14.0's use of std::bind.

	Removed geo/Makefile from configure.ac

	Removed geo from SUBDIRS in Makefile.am

	Added #include <memory> for unique_ptr and removed geo includes

	Removed %define api.parser.class from the two DAP4 CE parsers
	This broke bison on Linux

	Merge branch 'master' into natural_axes

	Completed fixes for the DAP2 CE parser refactor.
	I cannot figure out how to make UInt32 the default type for integer
	constants for function arguments. I dropped back to Int32s by default.
	I think this means that if functions are called with args that have
	to be held in UInt32s, those function calls will not work.

2020-02-10  James Gallagher  <jgallagher@opendap.org>

	Fixed broken parse of [*] in an array/grid projection
	The parser was setting the projection to -1:1:-1 when t should have
	set it to 0:1:-1. Also fixed the broken expr-test debug feature.

	ce_expr.yy now handles projections and selections using 'value'
	This code removes the value struct from the ce_expr parser
	and improves processing selection expressions by removing
	unneeded casting operations that were, in some cases, breaking
	valid CEs (because negative values were 'floored' to zero when
	comparing them to a value in an unsigned variable. The old code
	is still present in this commit - wrapped in #if 0 ... #endif.

2020-02-09  James Gallagher  <jgallagher@opendap.org>

	Moved 'value' out of the exprlval union.
	This makes it easier to build correct instances of 'value.'

2020-02-08  ndp-opendap  <ndp@opendap.org>

	Fixed missing centos-* rpms in travis-ci. Renabling fullCI build

	Located and cirrected a copy-pasta problem in travis rules in which BES_BUILD was being test tested and not LIBDAP_BUILD

	Testing RPM build

	Testing RPM build

	Testing RPM build

2020-02-07  James Gallagher  <jgallagher@opendap.org>

	Removed int_list and int_list_list types and functions from the CE parser.
	They are wrapped with #if 0 ... #endif

	New 'slices' code for natural axes subsetting builds and passes existing tests

2020-02-05  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' into natural_axes

2020-02-05  ndp-opendap  <ndp@opendap.org>

	Added DOI to README

	debian changelog

2020-02-04  ndp-opendap  <ndp@opendap.org>

	Updating libdap4 project files for 3.20.5 release.

2020-01-09  ndp-opendap  <ndp@opendap.org>

	updating aws keys for travis

2019-12-13  kyang2014  <kyang2014@users.noreply.github.com>

	Merge pull request #105 from OPENDAP/hk-532
	HK-532, set the parent pointer of vars to NULL when transforming DAP4…

2019-12-12  Muqun Yang  <myang6@hdfgroup.org>

	HK-532, set the parent pointer of vars to NULL when transforming DAP4 to DAP2.

2019-12-06  Sam Lloyd  <slloyd@opendap.org>

	Merge pull request #104 from OPENDAP/HK-50
	Hk 50

2019-12-06  Samuel Lloyd  <slloyd@localhost.localdomain>

	12/6/19 - HK-50 - master merge

2019-12-05  James Gallagher  <jgallagher@opendap.org>

	Removed unneeded include directories
	[skip ci]

	Added local CMakeLists.txt to streamline work with CLion.
	[skip ci]

2019-12-04  slloyd  <slloyd@localhost>

	12/4/19 - HK-50 - (In Progress) returns changed

2019-12-03  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #103 from OPENDAP/HK-459
	11/26/19 - HK-459 - (Awaiting Review) suppressed .yy error messages

2019-11-27  James Gallagher  <jgallagher@opendap.org>

	Prepare for merge

	Set custom condition for ci_test

	Testing 'test deployment'

	Modified ci_test stage

	Reset keys

	Test new AWS keys

2019-11-26  slloyd  <slloyd@localhost>

	11/26/19 - HK-459 - (Awaiting Review) suppressed .yy error messages
	suppressed error messages thrown from libdap4/*.yy files to the standard
	out

2019-11-01  James Gallagher  <jgallagher@opendap.org>

	My update of the Ubuntu container failed; modified the deb-build script.
	The script now loads the awscli code. It would be better to fix the
	docker container, but I don't have easy access to the Dockerfile.

	Updated the ubuntu 14 container so it has the aws cli.

	Modified build-deb.sh to use the aws cli.
	This change was needed because the travis.build bucket is no longer
	public.

2019-10-31  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #102 from OPENDAP/dap4-function-null-args-support
	Added support for null argument lists to the DAP4 function parser.

	Added support for null argument lists to the DAP4 function parser.

2019-10-30  James Gallagher  <jgallagher@opendap.org>

	Fix for the deb-to-package-dir.sh script.

	Merge pull request #101 from OPENDAP/travis
	Travis

	Added srcdist to the travis build

2019-10-29  James Gallagher  <jgallagher@opendap.org>

	More clean up and configured to build on the travis branch

	Clean up the travis.yml

2019-10-01  James Gallagher  <jgallagher@opendap.org>

	Changed scan stage so sonarcloud is an 'object'

2019-09-30  James Gallagher  <jgallagher@opendap.org>

	Changed name-prefix to api.prefix

2019-09-25  James Gallagher  <jgallagher@opendap.org>

	Syntax fixes in travis.yml and a new target in Makefile.am for CLion
	To make CLion work with our code I used the compiledb tool to make
	a data base of built files. I added a target to the Makefile.am to
	support that.
	[skip ci]

2019-09-08  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #99 from OPENDAP/dmr-test-fix
	Dmr test fix

2019-09-04  slloyd  <slloyd@localhost>

	9/4/19 - HK-411 - (Awaiting Review) implemented remaining DMRTest fixes

2019-08-27  Nathan Potter  <ndp@opendap.org>

	Fixing broken naming of rpm's, again.

	Fixing the missong devel and debuginfo snaps

	Testing snapshot gen in travis, tweaking target names

	Testing snapshot gen in travis

	Testing snapshot gen in travis

	Merge branch 'master' of https://github.com/opendap/libdap4

	Testing snapshot gen in travis

2019-08-26  Kodi Neumiller  <kneumiller@mtech.edu>

	Merge pull request #98 from OPENDAP/authorization_fix
	Cleanup and Verbose

	Made it easier to set the verbose for HTTPConnect and added a very verbose option.

	Merge pull request #97 from OPENDAP/authorization_fix
	Fixed netrc authorization

2019-08-23  James Gallagher  <jgallagher@opendap.org>

	more edits to ce_expr.yy

2019-08-23  Kodi Neumiller  <kneumiller@mtech.edu>

	Took out the curlopt_username and curlopt_password

	Fixed netrc authorization

2019-08-22  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' into natural_axes

	Modified CE parser. It now contains stubs for range-based subsetting

2019-07-08  James Gallagher  <jgallagher@opendap.org>

	Added DOI
	[skip ci]

2019-07-03  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of https://github.com/opendap/libdap4
	Resolved Conflicts: chunked_istream.cc

2019-07-02  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #96 from OPENDAP/header-byte-order-hack
	Hacked chunked_i/ostream.cc using HEADER_IN_NETWORK_BYTE_ORDER

	Revert "Fixes to ntohl() use and auto_ptr --> unique_ptr."
	This reverts commit c8c427b01dd95ff2f0da820630ffc8133d77d0aa.

	Hacked chunked_i/ostream.cc using HEADER_IN_NETWORK_BYTE_ORDER
	This is an attempt to revert edits made to correct the calls
	to htonl() adn ntohl(). Most thought is needed.

2019-07-01  James Gallagher  <jgallagher@opendap.org>

	ChangeLog, etc., for version 3.20.4

	Merge pull request #95 from OPENDAP/scan-fixes
	Fixes to ntohl() use and auto_ptr --> unique_ptr.

	Fixes to ntohl() use and auto_ptr --> unique_ptr.
	Will this pass the CentOS 6 build?

2019-06-21  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #94 from OPENDAP/libdap-leak-fix
	DMRParser leak fix

	DMRParser leak fix

2019-06-20  Nathan Potter  <ndp@opendap.org>

	Code tidying

	Merge pull request #93 from OPENDAP/dmr_chunking_parser
	Dmr chunking parser

	Dropping conditional termination of the DMR parse operation.

	Minor changes for readability

	Updated baselines to account for modified parse error messages and whitespace alterations

	Merge branch 'master' into dmr_chunking_parser

	chunking improvement

2019-06-20  James Gallagher  <jgallagher@opendap.org>

	Start of fixes to the DMRTest.at file
	The logic for the --baselines feature needs to be fixed.

	Merge pull request #92 from OPENDAP/dmr-test-mem-leak
	Dmr test mem leak

2019-06-19  James Gallagher  <jgallagher@opendap.org>

	One small edit for D4Attributes - remove unused code.

	Added a DMR that intentionally includes a forward reference error
	EnumDMR_1.6

	Found that a malformed DMR breaks the parser in a very odd way
	No error message or exception. The error is to have a forward
	reference for a dimension defined in a Group.

2019-06-19  Nathan Potter  <ndp@opendap.org>

	Merge branch 'master' into dmr_chunking_parser

	first pass at chunk reading parser

2019-06-19  James Gallagher  <jgallagher@opendap.org>

	Memory leak fix for XMLWriter.
	The libxml2 macro LIBXML_TEST_VERSION leaks 40 bytes.

	Merge pull request #91 from OPENDAP/HK-403.1
	Hk 403.1

2019-06-19  Cloud User  <centos@ip-172-31-23-170.ec2.internal>

	Used auto_ptr<> in DmrToDap2Test.cc.

	Memory leak fixes in DMR.cc and D4Group.cc

2019-06-19  Nathan Potter  <ndp@opendap.org>

	Minor output change for D4ParserSax2Test. New baselines with newline chars

2019-06-19  James Gallagher  <jgallagher@opendap.org>

	Reduced method count in D4Group and DMR.

	Spelling in a comment (AttrTable.cc)

	Formatting in D4Attributes.cc

	More work - tests still pass on OSX.
	I'm working in removing more code in D4Attributes, load_AttrTable()
	is removed and get_AttrTable() is only used by D4Group.

	Fixes for HK-403 (the HK-403.1 branch). Tests pass on OSX.

2019-06-18  Cloud User  <centos@ip-172-31-23-170.ec2.internal>

	checkpoint HK-403.1 Work on attribute transfer.

2019-06-18  James Gallagher  <jgallagher@opendap.org>

	Minor edit to D4Attributes.g - formatting only.

	Minor edits to the Array.cc file. In connection with HK-403
	[skip ci]

	Found part of HK-403 fixes that doesn't break tests - added back in.

2019-06-17  James Gallagher  <jgallagher@opendap.org>

	More fixes - Marked two tests in DmrToDap2Test as expected to fail.

	Another hack to fix DDSTests added.
	[skip ci]

	I found that some of the CI test failures are 'fixed' by including code in Array.cc
	That is, some of the code that was removed because it caused leaks was,
	apparently, doing more than causing leaks. I'm commiting this because,
	while it's a WIP, I'm on the road and don't know when I can look at it
	again.

2019-06-13  Nathan Potter  <ndp@opendap.org>

	Cleaning up

2019-06-12  Nathan Potter  <ndp@opendap.org>

	Improved error/memory management for DmrToDap2Test

2019-06-11  Nathan Potter  <ndp@opendap.org>

	Fixed memory leak in DMR::getDDS()

	Fixed copying problem in Array::transform_to_dap2(). Fixed memory leak in DmrToDap2Test.cc

2019-05-30  Nathan Potter  <ndp@opendap.org>

	Memory leak patch.

2019-04-19  James Gallagher  <jgallagher@opendap.org>

	checkpoint

2019-04-19  Nathan Potter  <ndp@opendap.org>

	Merge pull request #89 from OPENDAP/d4_to_d2_attr_err_msg
	Added more fine grained error handling in get_dap2_AttrType()

	Added Enum and Opaque to d4->d2 attribute conversion.

	Added more fine grained error handling in get_dap2_AttrType()

2019-04-18  James Gallagher  <jgallagher@opendap.org>

	Added nascent geodap library to libdap4

	Reverted the D4 parser/scanner to master; saved natural_axes versions
	DAP4 tests were failing - I'll work on the natual axes hack for DAP2
	and, if that seems promising, look at the DAP4 code.

2019-04-05  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #88 from OPENDAP/c++11-bison-hack
	Modified the build so that --std=c++-1x works on CentOS 6

	Modified the build so that --std=c++-1x works on CentOS 6
	The issue was that the bsin code failed to build. The fix is
	to not use the --std=... flag for it. Since it's generated code
	we're not using any C++ 2011 stuff. If that changes, it _will_
	build with 2011++, but not the 0x implementation found on CentOS 6.

2019-03-26  James Gallagher  <jgallagher@opendap.org>

	Arrgh. C++-11 on centos 6 is broken or our code stresses it.
	Dropping back to, either we find c++11 support or we don't. Use
	CXX11_FLAG is non-zero to if it was found (and if so, how to get the
	compiler to use it).

	This runs under autoconf 2.63, but there's another hitch. Potential fix...

	Potential fix for centos 6 and the new c++11 test.

	Merge pull request #87 from OPENDAP/c++11-test-use
	Added a test for either c++11 or c++0x and its use by the Makefiles

2019-03-25  James Gallagher  <jgallagher@opendap.org>

	Parsing works for the ERDDAP syntax for DAP2 CEs.
	DAP4 is still hosed and breaks some tests.

	Resolved conflicts in D4ConsrtaintEvaluator.cc

	Merge branch 'master' into natural_axes

	Added cxx_flags_check macro for configure.ac

2019-03-22  James Gallagher  <jgallagher@opendap.org>

	Added a test for either c++11 or c++0x and its use by the Makefiles
	No code changes. The idea is to see if this makes it through CI/CD.
	C++0x is the prequel to C++11. The '0x' version is supported on
	CentOS 6 by gcc/++ 4.4.x

2019-03-20  James Gallagher  <jgallagher@opendap.org>

	Fixed comments.
	[skip ci]

2019-02-15  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #86 from OPENDAP/leak_test
	HK-87. Fixed libdap memory leak for Ubuntu.

2019-02-15  Slav Korolev  <slav.korolev@nasa.gov>

	HK-87. Fixed libdap memory leak for Ubuntu.

2019-02-15  James Gallagher  <jgallagher@opendap.org>

	fixed debian/changelog

	Bumped up the version in denian/changelog

2019-02-14  James Gallagher  <jgallagher@opendap.org>

	Forgot the libdap spec file for the RPM

	Version 3.20.3 source release

2019-02-12  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #85 from OPENDAP/sonar-travis
	Sonar travis

	I think we're done - it works. Moving the scan to follow the builds
	[skip ci]

	Might work!

	one last try

	Another try...

	Run just the scan to test if that works.

	test sonar via travis

2019-02-11  James Gallagher  <jgallagher@opendap.org>

	Added multi-thread option to the sonar properties file
	[skip ci]

2019-02-08  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #84 from OPENDAP/rpm-aws-cli
	RPM aws cli

	Modified build-rpm.sh to work with the CentOS 6 docker image
	It has the aws cli tools buried in an odd place.

	Modified the RPM CI build to use aws cli and not curl

	Merge branch 'master' of https://github.com/opendap/libdap4 [skip ci]

	Merge pull request #83 from OPENDAP/sonar
	Sonar

	Added to gitignore for sonarscan
	[skip ci]

	minor edit to the sonar-project.properties file

	Sonar Scan changes

2019-02-06  James Gallagher  <jgallagher@opendap.org>

	Changes based on sonar scan

2019-02-05  Nathan Potter  <ndp@opendap.org>

	Fixed incorrect delete (changed to delete[]) in chunked_istream.h

	Repaired incorrect 'throw new ...' calls.

2019-01-30  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #82 from OPENDAP/travis-aws
	Modified the .travis.yml to use aws and not curl.

	Modified the .travis.yml to use aws and not curl.
	The idea here is that maybe this will be a bit more robust and thus
	cut down on spurious build errors. Testing here before in the bes.

2019-01-29  Nathan Potter  <ndp@opendap.org>

	Fixed typo [skip ci]

2019-01-02  Kodi Neumiller  <kneumiller@mtech.edu>

	Merge pull request #81 from OPENDAP/debian
	Debian

	Merge branch 'master' into debian

	Travis passed, took out unnecessary code. Also changed the branch to "if branch = master"

	Re-added the travis_build_dir

	Checkpoint..

	Checkpoint.

	Changed directory to $prefix/

	Forgot the / in /root

	Trying to mv the deb package from /root/

	Realized that the build-deb.sh file has a different value for $prefix

2018-12-31  Kodi Neumiller  <kneumiller@mtech.edu>

	Changed the directory the db package is put to $prefix/debbuild

	I think the deb package is being place in root

	Merge pull request #80 from OPENDAP/debian
	Changed where travis looks for the libdap deb package

	Trying to pinpoint libdap deb package...

	Instead of trying to put the libdap deb build in a different directory, will try to locate the deb package the docker build generates.

	Testing to see where libdap4 is put

	Forgot "--env"...

	Renamed the traivs dir

	Added the TravisBuildDir environment

2018-12-27  Kodi Neumiller  <kneumiller@mtech.edu>

	Changed it so that the deb packgage is made in the Travis_build_dir

	Merge pull request #79 from OPENDAP/debian
	Reverted the directory back to $TRAVIS_BUILD_DIR/../

	Reverted the directory back to $TRAVIS_BUILD_DIR/../

2018-12-21  Kodi Neumiller  <kneumiller@mtech.edu>

	Merge pull request #78 from OPENDAP/debian
	Changed the name of the directotry for deb build.

	Changed the name of the directotry for deb build.

	Merge pull request #77 from OPENDAP/debian
	Debian docker build

	Moved debian packages to Dockerfile

2018-12-21  Kodi Neumiller  <kodi@Udays-MacBook-Pro.local>

	Forgot to set permissions for .sh file

	Had the wrong name for the docker repository...

	libdap debian docker build.

2018-12-20  James Gallagher  <jgallagher@opendap.org>

	Updated comments
	[skip ci]

2018-12-19  Kodi Neumiller  <kodi@Udays-MacBook-Pro.local>

	Merge branch 'master' into debian

2018-12-06  James Gallagher  <jgallagher@opendap.org>

	Added DOI for 3.20.2
	[skip ci]

2018-12-05  James Gallagher  <jgallagher@opendap.org>

	Updated version numbers and Documentation for 3.20.2

2018-11-29  Slav Korolev  <slav.korolev@nasa.gov>

	Corrected comments.

2018-11-28  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #76 from OPENDAP/rename_dim
	Rename dim

2018-11-20  Slav Korolev  <slav.korolev@nasa.gov>

	HK-247. Removed unneeded include.

	HK-247. Added Array function rename_dim.

2018-11-19  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #75 from OPENDAP/version-3.20.1
	Version 3.20.1

	Updated debian changelog (which includes the version)

	Modified travis.yml for builds and packages on version-* branches

	Release versions and files updated

2018-10-24  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'travis'
	[skip ci]

	Updated travis build so that the build-rpm.sh script is accessible

2018-10-23  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'travis' of https://github.com/opendap/libdap4 into travis
	# Conflicts:
	#	.travis.yml

	Added c6 to deply list

2018-10-22  James Gallagher  <jgallagher@opendap.org>

	Updated the containers to tag 1.1

2018-10-20  James Gallagher  <jgallagher@opendap.org>

	Container tags from 1,latest to 1.0

	Removed old files

	Merge branch 'travis' of https://github.com/opendap/libdap4 into travis

	As with hyrax deps, container tag change from 1 to 1.0

2018-10-17  James Gallagher  <jgallagher@opendap.org>

	Added centos6 build

	replace mv with cp - maybe the user is not root
	That is, a non-root user cannot mv because that implies delete/write
	privileges and group and other have only read privileges.

2018-10-16  James Gallagher  <jgallagher@opendap.org>

	Debug broken mv

	Another try at debugging the mv problem

	More debugging of the mv bug.

	Debug package move error.
	Also, changed to $HOME from /root in both travis yml and build-rpm.sh

	Fixed paths in build-rpm.sh

	Missed a /home in the centos7 RPM build

	Changed /home to /root inside the docker container.
	This should enable the rpms to be accessed by Travis. Also, changed the
	branch restrictions on the deployment so the Travis branch will run the
	before_deploy code (deploy itself won't run for a PR).

	Corrected error in build-rpm.sh - was missing call to configure

	Fixed container spec; hacked yml to test only the RPM build

	Hacked Travis to run the new RPM build. checkpoint

	Changed rpm-build.sh to use 'make rpm' and added some instrumentation

2018-10-15  James Gallagher  <jgallagher@opendap.org>

	Initial version of a Travis-based RPM build. checkpoint

2018-10-11  James Gallagher  <jgallagher@opendap.org>

	Revert "Revert "--enable-coverage added to configure.ac and Makefile.am""
	This reverts commit fea75b3260c99e4edcd9b01de6aa446025a6a889.

	Revert "--enable-coverage added to configure.ac and Makefile.am"
	This reverts commit 726f30bbf743a9fc2213f3a2c7d28a7cb2df3174.

	--enable-coverage added to configure.ac and Makefile.am

	Added initial version of docker bootstrap script
	[skip ci]

	Added the new docker command - it didn't get committed previously

	# WARNING: head commit changed in the meantime
	Added docker as a 'service,' named the package build stage.
	This is a test to see if I can get the docker container to load and run

2018-09-13  James Gallagher  <jgallagher@opendap.org>

	Debian package build fail was a version number error
	Changed the distribution back to 'trusty'

	There are errors reported by debian lintian - change dist to UNSTABLE

	Modified the debian/changelog to indicate the package was built on trusty

	Updated the debian package build changelog

2018-09-13  James Gallagher  <jgallagehr@opendap.org>

	Fixed spec file changelog date [skip ci]

2018-09-13  James Gallagher  <jgallagher@opendap.org>

	Release files updated for 3.20.0

	Merge branch 'centos6-build-fixes'

2018-09-12  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #74 from OPENDAP/ddx-fix-2
	DDX fix 2

	Now the code builds DAP3.2 DDX reposnes by default.

2018-09-11  James Gallagher  <jgallagher@opendap.org>

	Baselines for DAP2 DDXs (*.dap2.xml)
	The DAP 3.2 baselines end in .xml.

	Merge branch 'ddx-fix-2' of https://github.com/opendap/libdap4 into ddx-fix-2

	The configure script now sets DAP2 or DAP3.2 DDX reposes.
	DAP2 DDX's in this commit. Tests are switched automatically.

	The configure script now sets DAP2 or DAP3.2 DDX reposes.
	Tests are switched automatically.

	This is the alternative DDX fix - compile-time choice of DAP2 or 3.2 DDX
	With DAP2 DDX, all but a handful of BES tests pass, with DAP3.2, many
	more tests fail.

2018-09-10  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #73 from OPENDAP/ddx-3.2-only
	The DDS::print_xml and print_xml_writer now only return a '3.2' DDX

	The DDS::print_xml and print_xml_writer now only return a '3.2' DDX
	There is an issue in the BES where, for unknown reasons, a DAP2 or
	DAP3.2 DDX will be returned. The DDX response should only be '3.2'.
	Since there is no used for DAP2 DDX, I've removed it. This doesn't
	address the underlying problem, however (why the version number in
	the DDS object do not match those set by the BES's client).

2018-08-29  James Gallagher  <jgallagher@opendap.org>

	centos6 edits

2018-08-22  James Gallagher  <jgallagher@opendap.org>

	Fixed commands in the before_deploy section of the travis yaml

	try moving two packages to S3

2018-08-22  Kodi Neumiller  <kodi@Udays-MacBook-Pro.local>

	Added || in the condition section.

	Took out = main

	Fixed the directory to send the .deb file.

	Got rid of /debian

2018-08-22  Kodi Neumiller  <kneumiller@mtech.edu>

	Merge pull request #71 from OPENDAP/debian
	Debian. Should move the created deb package to s3.

2018-08-22  James Gallagher  <jgallagher@opendap.org>

	Fix for DDS::has_dap2_attributes

2018-08-22  Kodi Neumiller  <kodi@Udays-MacBook-Pro.local>

	Took out the ls ../ -l after make deb -j7.

	Uncommented the different jobs. Also made it so that the deb package is grabbed from the directory above.

	Looking at a directory above the current one.

2018-08-22  James Gallagher  <jgallagher@opendap.org>

	Modified travis for coverity
	[skip ci]

2018-08-22  Kodi Neumiller  <kodi@Udays-MacBook-Pro.local>

	Added ls -l to see where the debian package is.

	Took out the condition "$LIBDAP_BUILD = main"

	Added the debian branch to the list of branches to be built. Also commented out the other jobs that aren't debian.

2018-08-21  Kodi Neumiller  <kodi@Udays-MacBook-Pro.local>

	Made it so that the debian package is moved to s3.

	Added debhelper package.

2018-08-20  James Gallagher  <jgallagher@opendap.org>

	Added the fakeroot package for debian pkg builds on Travis

	Added devscripts build-essential lintian for debian pkg build

	Modified travis.yml to trigger a debian package build.

	Merge branch 'master' into debian

	Fixed comments in MarshallerThread.h
	[skip ci]

	Merge branch 'master' into debian

2018-07-31  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #70 from OPENDAP/dds_test_fix
	DDS test fix

2018-07-30  James Gallagher  <jgallagher@opendap.org>

	Made a corresponding change to dds-test:test_class() re: mem leak

	Changed BaseTypeFactory in dds-test:test_parser() fixing a memory leak.

2018-07-25  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #68 from OPENDAP/travis
	Added a new parallel build for the asan checks

	Added a new parallel build for the asan checks

2018-07-10  Ubuntu  <ubuntu@ip-172-31-6-46.ec2.internal>

	Updated the copyright file. It may need to be looked at to ensure it is formated correctly.

2018-07-06  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #67 from opoplawski/libtirpc
	Use libtirpc

	Merge pull request #66 from OPENDAP/debian
	deb packaging

2018-06-24  Orion Poplawski  <orion@cora.nwra.com>

	Use libtirpc

2018-06-19  Ubuntu  <ubuntu@ip-172-31-6-46.ec2.internal>

	The makefile now has an option (make deb) to build the debian package for libdap.

2018-06-18  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #65 from OPENDAP/debian
	Debian Packaging

2018-06-13  Ubuntu  <ubuntu@ip-172-31-6-46.ec2.internal>

	Deleted generated files.

	Finished adding the appropriate files to build a debian package. The libdap directory was added after the debian package was installed.

2018-06-11  Ubuntu  <ubuntu@ip-172-31-6-46.ec2.internal>

	Edited the Makefile in unit tests so that it included the missing test files.

2018-06-07  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #64 from OPENDAP/print_das_fix
	Print das fix

	Merge pull request #58 from OPENDAP/keyword-refactor
	Keyword refactor

2018-05-25  James Gallagher  <jgallagher@opendap.org>

	Fixed the last two tests for the print_das() fix.

	Merge branch 'print_das_fix' of https://github.com/opendap/libdap4 into print_das_fix

	Merge branch 'master' into print_das_fix

2018-05-25  Nathan Potter  <ndp@opendap.org>

	Merge pull request #62 from OPENDAP/hyrax-730
	Fixed DDS::has_dap2_attributes() so that Grids are handled, eliminated printing MAP vectors in Grid from print_var_das()

	Dropped Grid Map arrays from Grid container in DAS (Flatten Grids man)

2018-05-25  James Gallagher  <jgallagher@opendap.org>

	Switched print_das() so that it uses get_das() and then prints. WIP.

2018-05-25  Nathan Potter  <ndp@opendap.org>

	Merge branch 'master' into hyrax-730

2018-05-24  James Gallagher  <jgallagher@opendap.org>

	Switched print_das() so that it uses get_das() and then prints. WIP.

	Added a note about HYRAX-766: bes/dapreader issue.
	The proble is due to a change in the DAS objects are printed when they
	are built using a DDS or DMR.

	[skip ci]

2018-05-23  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of https://github.com/opendap/libdap4

	Changes to comments and some instrumentation in DmrRoundTripTest.cc
	No functional/operational changes except some of the instrumentation
	output in the DmrRoundTripTest unit test.

2018-05-22  Nathan Potter  <ndp@opendap.org>

	Fixed DDS::has_dap2_attributes() so that Grids are handled by evaluating only the GRid Array and ignoring the Maps.

2018-05-21  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #61 from OPENDAP/hyrax-730
	Hyrax 730

	Update DDS.cc

2018-05-21  Nathan Potter  <ndp@opendap.org>

	Fixed DDS::print_das() so thatv it makes special the Gridness

	Make DDS::get_das() work recursively on Constructor types

2018-05-18  Nathan Potter  <ndp@opendap.org>

	Revert "Adding metadata to Grid and to Grid Array now."
	This reverts commit b16ede3e866ea55daff0ad28d87bd43f3ff834da.

	Adding metadata to Grid and to Grid Array now.

	Patch to DAP4->DAP2 metadata assignment for Grid type problem.

2018-05-15  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #60 from OPENDAP/url_fix
	Url fix

	Merge branch 'master' into url_fix

2018-05-07  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #59 from ryandesign/configure-CC
	Use quotes when testing $CC

2018-05-06  Ryan Schmidt  <git@ryandesign.com>

	Use quotes when testing $CC
	This avoids the error "test: too many arguments" appearing in the
	configure output if CC contains multiple words, such as "ccache cc".

2018-05-04  James Gallagher  <jgallagher@opendap.org>

	More old code removed from Url.h

	Removed unused internal storage in Url.h

2018-04-11  James Gallagher  <jgallagher@opendap.org>

	Removed Keywords2 unit test code (to old/)

	Removed keywords from DDS. The class is still in the library

2018-04-09  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #57 from OPENDAP/dmrpp-dap2
	Dmrpp dap2

2018-04-07  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'dmrpp-dap2' of https://github.com/opendap/libdap4 into dmrpp-dap2

	Protect against infinite loop in get_unique_top_level_global_container_name().

	Added code to ensure a unique top-level table is used but DDS::get_das()
	When that is needed - when there are top-level attributes in a DMR - make
	new top-level container for those attributes. This new code makes sure
	those attributes go in a container with a unique name. The code will fail
	if there are more than MAX_INT top-level tables.

2018-04-07  Nathan Potter  <ndp@opendap.org>

	sync

2018-04-06  James Gallagher  <jgallagher@opendap.org>

	DDS::get_das(): Added a test and fix for top-level 'value' attributes
	It's possible to have a DMR or DDS that has top-level attributes that
	are not in a container. These work in the DMR or DDS object, but not
	in the DAS (which can only have containers at the top-level). The
	'orphan' attributes are put in the DAP4_GLOBAL container, since these
	almost certainly come from DMR objects. We might revisit this name
	choice...

	Added tests for DDS::get_das() and get_das(DAS *).
	Also edited the implementaiton just a bit to test for global attributes
	that are not containers.

2018-04-06  Nathan Potter  <ndp@opendap.org>

	Merge branch 'master' of https://github.com/opendap/libdap4

	Added some (much needed) get_das() methods to DDS

2018-04-02  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #53 from captainkirk99/ck_valgrind
	change valgrind invocation, also fixed some memory leaks in unit-tests

	Merge branch 'master' into ck_valgrind

2018-03-31  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #56 from captainkirk99/ck_fix_more_2
	fixed tests

2018-03-31  Ed Hartnett  <37277297+captainkirk99@users.noreply.github.com>

	fixed tests

2018-03-29  James Gallagher  <jgallagher@opendap.org>

	Changed D4Enum::set_is_signed() so it doesn't call abort()
	This 'fixed' an issue with testing where abort() fails hard and stops
	the tests right away. The next line throws an exception, which is really
	good enough and makes it possbile to test the error case. I also fixed
	up the comments for D4Enum::transform_to_dap2().

2018-03-28  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #55 from captainkirk99/ck_fix_big_endian
	fixed tests for big-endian

2018-03-28  Ed Hartnett  <37277297+captainkirk99@users.noreply.github.com>

	fixed tests for big-endian

2018-03-25  Ed Hartnett  <37277297+captainkirk99@users.noreply.github.com>

	fixed memory leak in D4FilterClausetest

	added macro file

	change valgrind invocation, also fixed some memory leaks in unit-tests

2018-03-24  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #48 from captainkirk99/ck_tests_1
	added some tests

2018-03-24  Ed Hartnett  <37277297+captainkirk99@users.noreply.github.com>

	added new tests to .gitignore

	more tests

2018-03-19  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #52 from OPENDAP/print-das-fix
	Print das fix

	Merge branch 'master' into print-das-fix

	DDS:print_das() fixes and test baseline edits.

	Changed DDS::print_das() so it's more in line with DAS::print()
	But, tests fail.

2018-03-18  Ed Hartnett  <37277297+captainkirk99@users.noreply.github.com>

	more tests

	more testing

	fixed problem with code coverage changes

	changing the way test coverage is computed

2018-03-17  Ed Hartnett  <37277297+captainkirk99@users.noreply.github.com>

	fixing inadvertant whitespace changes

	fixing inadvertant whitespace changes

	fixing inadvertant whitespace changes

	attempting to fix second problem with travis

	attempting to fix second problem with travis

	attempting to fix second problem with travis

	attempting to fix second problem with travis

	attempting to fix second problem with travis

	attempting to fix second problem with travis

	attempting to fix second problem with travis

	attempting to fix second problem with travis

	attempting to fix second problem with travis

	attempting to fix second problem with travis

	attempting to fix second problem with travis

	attempting to fix second problem with travis

	attempting to fix second problem with travis

	attempting to fix second problem with travis

	attempting to fix second problem with travis

	more changes to fix header problem

	more changes to fix header problem

	more changes to fix header problem

	more changes to fix header problem

	trying to fix header issue

	more tests

2018-03-16  James Gallagher  <jgallagher@opendap.org>

	Use curl to read the hyrax-deps build tar ball
	This should fix the issue with PRs from outside our GitHub space.

2018-03-14  Ed Hartnett  <37277297+captainkirk99@users.noreply.github.com>

	fixed test

	more testing

	merged

2018-03-14  James Gallagher  <jgallagher@opendap.org>

	Removed now unused ecr_credentials.sh script
	We can just use the AWS_SECRET_ACCESS_KEY and AWS_ACCESS_KEY_ID
	environment variables from within travis.

	[skip ci]

	Modified aws operations to get the hyrax-dependencies - trying to fix the build

2018-03-13  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #49 from OPENDAP/travis
	Modified aws operations to get the hyrax-dependencies - trying to fix…

	Removed now unused ecr_credentials.sh script
	We can just use the AWS_SECRET_ACCESS_KEY and AWS_ACCESS_KEY_ID
	environment variables from within travis.

	[skip ci]

	Modified aws operations to get the hyrax-dependencies - trying to fix the build

2018-03-12  Ed Hartnett  <37277297+captainkirk99@users.noreply.github.com>

	added some tests

2018-03-06  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #47 from OPENDAP/header-refactor
	Added #include "DapIndent.h" as I try to remove nested headers

	Added #include "DapIndent.h" as I try to remove nested headers

2018-03-02  Nathan Potter  <ndp@opendap.org>

	Merge branch 'master' of https://github.com/opendap/libdap4

	Added doxygen link to README

2018-02-24  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #46 from OPENDAP/travis
	Travis: $prefix set to $HOME/install

	added some comments

	testing

	testing

2018-02-23  James Gallagher  <jgallagher@opendap.org>

	testing

	testing

	more travis hacking

	Merge pull request #45 from OPENDAP/travis
	Travis

	travis test

	travis fixed?

	travis testing

	travis testing

	travis testing

	travis testing

	travis testing

	travis test

	travis testing

	travis testing

	travis testing

	travis test

	travis test

	Test travis

	Merge branch 'travis' of https://github.com/opendap/libdap4 into travis

	Test travis changes

	Test new travis build

2018-02-09  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of https://github.com/opendap/libdap4

	Minor tweak to --with-curl
	The configure.ac script needs more work to simplify it and replace
	raw shell commands with AS_IF, etc.

2018-02-08  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #44 from OPENDAP/asan
	Hacked configure so developer and asan are separate and both are used…

	Hacked configure so developer and asan are separate and both are used by travis

	Merge pull request #43 from OPENDAP/asan
	Asan

2018-02-07  James Gallagher  <jgallagher@opendap.org>

	Repaired d4_function/D4FunctionEvaluator.cc (See HYRAX-247)
	I used std::set which is supposed to preserve order, but apparently
	does not with gcc 4.8 and some levels of optimization.

	Found and fixed a memory error in tests/D4TestFunction.cc
	The $Byte() special form was being used to build an argument to
	the test function 'scale()' but the code i D4TestFunction assumed
	the argument was a TestArray instance (when it was/is an Array).

2018-02-06  jgallagher59701  <jgallagher@opendap.org>

	Fixed memory error in D4UnMarshallerTest.

2018-02-06  James Gallagher  <jgallagher@opendap.org>

	Added test for Address Sanitizer option

	Merge pull request #42 from OPENDAP/asan
	Added Asan (address sanitizer) to the --enable-developer option

	Added Asan (address sanitizer) to the --enable-developer option
	All the tests pass using this option on OSX.

	Minor hacks to the DAP2 CE grammar

2018-02-02  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #41 from OPENDAP/hyrax-598
	Fixed a memory error that could be triggered by passing bad XML to ...

2018-02-02  jgallagher59701  <jgallagher@opendap.org>

	Fixed a memory error that could be triggered by passing bad XML to the DAP4 DMR parser.
	vsnprintf() could be called with a tainted format string.

2018-01-31  James Gallagher  <jgallagher@opendap.org>

	Removed html dir from the master branch - it's still on the gh-pages branch
	Use 'make gh-docs' to build the online docs.

2018-01-30  James Gallagher  <jgallagher@opendap.org>

	Updated build-gh-docs.sh to use add --force since 'html' is on gitignore

	Added new docs

2018-01-28  James Gallagher  <jgallagher@opendap.org>

	Modifications to the DAP4 CE parser for the Natural Axes subset syntax - still fails tests

	The parser now accepts the [(float)] syntax. Sort of...
	Only floating point values work and other parts of the parser
	might be broken because a new lexeme (FLOAT) can be returned by
	the scanner. The issue is the WORD does not contain a dot (.) so
	it cannot represent float values the way people expect/need.

2018-01-27  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'natural_axes' of https://github.com/opendap/libdap4 into natural_axes

2018-01-12  James Gallagher  <jgallagher@opendap.org>

	travis

	travis

	travis

	travis

	travis

	travis

	travis

	travis

	travis

	travis

	travis

	travis

	travis

	travis

2018-01-11  James Gallagher  <jgallagher@opendap.org>

	travis

	travis

	travis

	more travis

	travis

	more travis tweaks

	travis syntax fixes

	Travis hacks

2018-01-09  James Gallagher  <jgallagher@opendap.org>

	More hacking on the new natural axes subsetting. Still nowhere near working.

2018-01-02  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #38 from OPENDAP/crypto-fix
	Fixed the libcrypto link error on OSX 10.13

2018-01-01  James Gallagher  <jgallagher@opendap.org>

	Fixed the libcrypto link error on OSX 10.13

	More hacks for natural_axes projections

2017-12-29  James Gallagher  <jgallagher@opendap.org>

	Started on the implementation of 'natrual axes' projections
	Based on the syntax developed by Bob Simons for ERDDAP. See
	http://upwell.pfeg.noaa.gov/erddap/griddap/documentation.html

2017-09-25  James Gallagher  <jgallagher@opendap.org>

	Source release 3.19.1

2017-08-25  James Gallagher  <jgallagher@opendap.org>

	Added a comment to my HTTPCacheTest change...
	[skip ci]

	Removed a test for block_size in HTTPCacheTest that failed on Fedora ppc64le system with XFS system

	Merge pull request #32 from OPENDAP/hyrax390
	Hyrax390

	Marked two of the Dmr Round Trip Tests as failing.
	This matched the results of the master branch. Thus we can merge
	the hyrax390 branch and move on to either fix those issues or
	accept the behavior as 'good enough.'

	Merge branch 'master' into hyrax390

	Merge pull request #36 from OPENDAP/gnulib-update
	Updated gnulib and added mkstemps() to avoid portability issues.

	Added malloca.valgrind

	Added more in gl

	Added more ...

	Added more still more

	Added more files in gl

	Added gl/gettimeofday.c

	Added more gnulib m4 files

	Updated gnulib and added mkstemps() to avoid portability issues.

	Added comments to DMR.h

2017-07-18  James Gallagher  <jgallagher@opendap.org>

	Fixed a warning in D4EnumTest and CppUnit usage in DmrRoundTripTest

	Merge branch 'master' of https://github.com/opendap/libdap4.git

	Added --disable-dependency-tracking to configure in travis.yml
	Will it build faster? Also, fixed a comment in D4Maps.h

2017-05-31  Slav Korolev  <slav.korolev@nasa.gov>

	Ticket #390. Cleaned 4 files.

	Ticket #390. Cleaned 4 files.

2017-05-22  ndp-opendap  <ndp@opendap.org>

	Updated versions, ChangeLog and News

2017-05-22  Nathan Potter  <ndp@opendap.org>

	Merge pull request #29 from OPENDAP/hyrax390
	Task #390. The CppUnit unit tests in libdap4 should all support runni…

	Merge pull request #31 from OPENDAP/hyrax-400
	Hyrax 400

2017-05-19  James Gallagher  <jgallagher@opendap.org>

	Fixed vec_resize() in Vector.
	I was mixing cpacity() and resize() and that leads to some odd
	behavior - I'm not sure I really understand it, but comments in
	Vector::vec_resize() are a stab at an explanation. The bottom line
	is that the fix is to use size() with resize() and not capacity().

	I also modified TestArray so that its read() method allocates
	enough space for a vector of Structures before it starts writing
	to it, just to demonstrate good behavior.

2017-05-19  Slav Korolev  <slav.korolev@nasa.gov>

	#390. More changes

2017-05-18  James Gallagher  <jgallagher@opendap.org>

	Checkpoint

	Checkpoint - run using valgrind on centos

2017-05-18  Slav Korolev  <slav.korolev@nasa.gov>

	Merge branch 'master' into hyrax390

2017-05-17  James Gallagher  <jgallagher@opendap.org>

	I edited the ByteTest.cc file so it compiles and works.

2017-05-17  Nathan Potter  <ndp@opendap.org>

	Merge pull request #30 from OPENDAP/attr_bug
	Attr bug

2017-05-17  ndp-opendap  <ndp@opendap.org>

	Dropped references to missing files.

2017-05-17  Slav Korolev  <slav.korolev@nasa.gov>

	"Task #390."

2017-05-16  ndp-opendap  <ndp@opendap.org>

	instrumentaiton

2017-05-12  ndp-opendap  <ndp@opendap.org>

	Fixed possible null pointer deref

	Dropped unused file

2017-05-11  Nathan Potter  <ndp@opendap.org>

	Merge pull request #26 from OPENDAP/dmr2dds
	Dmr2dds

2017-05-11  ndp-opendap  <ndp@opendap.org>

	Changed return value of transform_to_dap4() to void.

2017-05-10  Nathan Potter  <ndp@opendap.org>

	Merge branch 'master' into dmr2dds

2017-05-09  ndp-opendap  <ndp@opendap.org>

	Fixed bad implmentations of transform_to_dap4 in Test classes. Instrumenttion

	Fixed bad implmentations of transform_to_dap4 in Test classes. Instrumenttion

2017-05-08  ndp-opendap  <ndp@opendap.org>

	Reworked transform_to_dap4() implmentation so that they all (in libdap4) return NULL and populate the container passed in. Next will be to change the return from BAseType* to void

	Reworked transform_to_dap4() implmentation so that they all (in libdap4) return NULL and populate the container passed in. Next will be to change the return from BAseType* to void

	First pass at fixing the duplicate variables bug in DMR::build_using_dds() and Grid::transform_to_dap4()

2017-05-06  ndp-opendap  <ndp@opendap.org>

	Patched DMR tests to use the new CppUnit test pattern.

2017-05-05  ndp-opendap  <ndp@opendap.org>

	Repairing baselines

	Fixed Grid::transform_to_dap4() so maps have correct names (FQN names)

	Fixed Grid::transform_to_dap4() so maps have correct names (FQN names)

	Fixed namespace issue in tests that prevented individual tests from being run byt command line parameters.

2017-05-04  ndp-opendap  <ndp@opendap.org>

	Alternate Array assignment in Grid::transform_to_dap4()

	sync

	Stuff

2017-05-04  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #27 from OPENDAP/new_docs_target
	New docs target

2017-05-04  ndp-opendap  <ndp@opendap.org>

	A stab at correcting the FQN issue described in Hyrax-389

2017-05-04  James Gallagher  <jgallagher@opendap.org>

	Removed unused tests.
	Grid::transform_to_dap4() had used dynamic_cast<>() but now uses
	static_cast<>(), so it no longer needs to test for null returns from
	the cast operator.

2017-05-04  ndp-opendap  <ndp@opendap.org>

	Supressing warnings

	Merge branch 'master' into dmr2dds

2017-05-04  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #28 from OPENDAP/dmr_parser_fix
	Fixed fixed length line limit in the DMR Sax parser

2017-05-04  ndp-opendap  <ndp@opendap.org>

	Added some DAP4 related TODO items.

	Added some DAP4 related TODO items.

	Merge branch 'master' into dmr2dds

	unwinding small change

2017-05-04  James Gallagher  <jgallagher@opendap.org>

	Changed class field names so they start with 'd_'
	modified:   D4ParserSax2.cc
	modified:   D4ParserSax2.h

2017-05-03  James Gallagher  <jgallagher@opendap.org>

	Fixed fixed length line limit in the DMR Sax parser
	modified:   D4ParserSax2.cc

2017-05-03  ndp-opendap  <ndp@opendap.org>

	Updated .gitignore for new test executables

	Adding two more working DMR to Grid tests. Failing test still fails.

	Checking in new dmr2Grid test which fails because the supplied DMR fails to parse, despite the fact that it was generated by Hyrax 1.13.3

	Added new dmr2dds with Grid test.

	Added new dmr2dds with Grid test.

	Updating comments etc.

	Updating comments etc.

2017-05-02  ndp-opendap  <ndp@opendap.org>

	Ooops. Forgot test baseline

	Silencing more debug chatter.

	Silencing more debug chatter.

	First cut at extracting dap2 Grid objects from dap4 Arrays with maps.

	First cut at extracting dap2 Grid objects from dap4 Arrays with maps.

	Turned off compiled in debug.

	Refactored the transform_to_dap2() aip. woot.

2017-05-02  James Gallagher  <jgallagher@opendap.org>

	Modified Makefile.am to use the new build-gh-docs.sh script.
	This seems to work, although I think it might be fragile.

	A better way to build the docs and push them to gh-pages new file:   build-gh-docs.sh

	Working on using a script instead of makefile targets modified:   Makefile.am

	modified:   .gitignore

	Fixed spaces/tabs in Makefile.am

	deleted:    doxy_private.conf

	Modified doxy.conf.in so it writes output to 'html'
	It used to write output to docs/html.

	I added the new docs targets to the Makefile.am
	These will build and commit/push doxygen docs to github.io via gh-pages.
	The gh-pages branch has to be made first and should be empty.

2017-04-28  ndp-opendap  <ndp@opendap.org>

	Weekend update baby... More tests working. Need to sort out Groups next.

	Refactored DMR test suite, add round-trip and dmr_to_dap2 test suites.

2017-04-26  James Gallagher  <jgallagher@opendap.org>

	Added -g3 to the coverage flags

	Removed generated docs

	Deploy to GitHub Pages

2017-04-26  ndp-opendap  <ndp@opendap.org>

	Still dorting tests

2017-04-25  ndp-opendap  <ndp@opendap.org>

	Merged master to dmr2dds branch

	Structures now transfer attributes correctly

	Space indented BAseType (why was it not before?)

	Structures now transfer attributes correctly

2017-04-24  ndp-opendap  <ndp@opendap.org>

	Structures now transfer attributes correctly

	Structures now transfer attributes correctly

	sync

	Provisional patch to DMR.print_das()

2017-04-23  ndp-opendap  <ndp@opendap.org>

	Provisional patch to DMR.print_das()

2017-04-21  ndp-opendap  <ndp@opendap.org>

	Created DMR specific testsuite. Migrated exisiting DMR tests from dds-testsuite.

	TEst draft (broken)

2017-04-20  ndp-opendap  <ndp@opendap.org>

	sync

2017-04-18  James Gallagher  <jgallagher@opendap.org>

	Added comments to Connect and mime_util regarding tainted data

	Fixed minor issue in D4ParserSax2.
	The namespace prefix could be null and was passed directly to
	std::string's ctor

	Fixed for potential issue in D4ConstraintEvaluator.
	The pointer 'dim' could be dereferenced when it was null.

2017-02-17  James Gallagher  <jgallagher@opendap.org>

	Travis should work now...
	We need a better way to test changes to this process

	Removed codecov.io from the build.
	Debug on CentOS and stop hacking at Travis...

	Added libgcov a an attempt to fix the travis build.

	Turn on coverage in travis.yml

2017-02-16  James Gallagher  <jgallagher@opendap.org>

	more travis hacks

	travis hacks for code cov io

	more travis hacks

	another tack for travis and codecov...

	tedious... (still travis debugging)

	travis test...

	travis.yml fix for codecov.io

	Mods for codecov.io (https://codecov.io/gh/OPENDAP/libdap4)

	Added code coverage to travis.yml

	Merge branch 'master' of http://github.com/opendap/libdap4

	Added code coverage script (get_code_cov.sh)

2017-02-08  James Gallagher  <jgallagher@opendap.org>

	Hacked up gitignore for various build stuff [ci skip]

2017-01-06  James Gallagher  <jgallagher@opendap.org>

	Version 3.18.3

	Modified etags for the files at the new test.o.o site.

2016-12-08  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #25 from OPENDAP/chunked_istream_bug
	Fixed a memory issue in chunked_istream.h

	Fixed a memory issue in chunked_istream.h (new[] mis-matched with delete)

2016-11-18  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #24 from OPENDAP/dmr++
	Dmr++

	Merge pull request #23 from OPENDAP/D4Group_ptr_duplicate_fix
	Fix fir D4Group::ptr_duplicate(). It was not returning BaseType*

2016-11-17  James Gallagher  <jgallagher@opendap.org>

	Fix fir D4Group::ptr_duplicate(). It was not returning BaseType*
	Instead, it returned D4Group. There may have been a good reason,
	But I think consistency is better. ...maybe

2016-11-16  ndp-opendap  <ndp@opendap.org>

	DMR parser will now ignore and XML not in the DAP4 namespace. woot.

2016-11-15  ndp-opendap  <ndp@opendap.org>

	XML namespace thing sorted. DMR parser will now ignore all elements that are not in DAP4 namespace. woot.

	Still working the namespace thing

	Still working the namespace thing

	Still working the namespace thing

	Still working the namespace thing

2016-11-15  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of https://github.com/opendap/libdap4.git

2016-11-15  ndp-opendap  <ndp@opendap.org>

	Trying to get name space centralization class working. ugh. Static methods

2016-11-15  James Gallagher  <jgallagher@opendap.org>

	Added comment for dmr_start_element()

2016-11-05  James Gallagher  <jgallagher@opendap.org>

	Corrected the file: URL in HTTPConnectTest - I think ...

	Merge branch 'master' of http://github.com/opendap/libdap4

2016-11-04  James Gallagher  <jgallagher@opendap.org>

	Another try at fixing the travis build

	Trial fix of test_config.h error on Travis.

	Stopped running the tests using multiple jobs on Travis.
	This might have been the cause of failures there.

2016-11-03  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of http://github.com/opendap/libdap4

2016-11-02  James Gallagher  <jgallagher@opendap.org>

	Updated the library version info for version 3.18.2

	Version 3.18.2

2016-11-01  James Gallagher  <jgallagher@opendap.org>

	Formatting Grid.cc

2016-10-20  James Gallagher  <jgallagher@opendap.org>

	Fixed type in tests/DMRTest.at - names_with_spaces3.dmr

	Fixed Hyrax-267
	The DAP4 ce parser was not removing double quotes or the %<hex>
	escaping, so names that needed those were not 'found' in the
	dataset. Also, the grammar used by the parser had a syntax error
	in it where /s in the id name were turned into dots and the
	resulting names could not be found. The result was a valid names
	were being rejected.

2016-10-12  James Gallagher  <jgallagher@opendap.org>

	Corrected a comment in Vector.h

2016-08-30  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #22 from sharkcz/getopt
	type fix for getopt

2016-08-30  Dan Horák  <dan@danny.cz>

	type fix for getopt
	The getopt() function uses int as return type and using char for a variable storing
	teh return value makes problem on platform where char is unsgined by default.

	http://www.arm.linux.org.uk/docs/faqs/signedchar.php

	Fix by Orion Poplawski <orion[at]cora.nwra.com> for https://bugzilla.redhat.com/show_bug.cgi?id=1366787

2016-08-26  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #21 from sharkcz/dmr-bigendian-2
	add missing big endian baselines

2016-08-26  Dan Horák  <dan@danny.cz>

	add missing big endian baselines

2016-08-22  James Gallagher  <jgallagher@opendap.org>

	Added main_page.doxygen to gitignore

2016-07-14  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of https://github.com/opendap/libdap4

	Added libuuid to the requirements listed in INSTALL.
	Also added a comment and fixed error message text in util.cc for
	void extract_double_array(Array *a, vector<double> &dest)

2016-06-09  James Gallagher  <jgallagher@opendap.org>

	Fixed a compiler warning when USE_POSIX_THREADS is not def'd in XDRStreamMarshaller

2016-06-08  James Gallagher  <jgallagher@opendap.org>

	Removed generagted file since it's causing grief on Travis

	Updates for the source dist and unit-tests

2016-05-31  James Gallagher  <jgallagher@opendap.org>

	Version 3.18.0

2016-05-25  James Gallagher  <jgallagher@opendap.org>

	Fixed ugly DBG2() macro calls

2016-05-18  James Gallagher  <jgallagher@opendap.org>

	Merge remote-tracking branch 'origin/Hyrax-98'
	Conflicts:
		D4Connect.cc
		d4_ce/D4ConstraintEvaluator.cc
		d4_ce/d4_ce_parser.yy

2016-05-17  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #19 from OPENDAP/response_cache
	Response cache

2016-05-16  James Gallagher  <jgallagher@opendap.org>

	Added recursive Sequence::rest_row_number() and comments

2016-05-15  James Gallagher  <jgallagher@opendap.org>

	Minor edits after testing specializing read_row() for the ResponseCache
	See bes/dap CachedSequence and CacheTypeFactory for more info.

2016-05-13  James Gallagher  <jgallagher@opendap.org>

	Checkpoint - Nathan's hack for Sequence plus debugging

	Added comments for the hacked set_send_p() and set_read_p() methods

	Added a (potential) fix for Vector::set_send_p()

2016-05-12  James Gallagher  <jgallagher@opendap.org>

	Hacks for the bes branch 'response_cache'

2016-05-10  James Gallagher  <jgallagher@opendap.org>

	Changes for Coverity
	[ci skip]

	Comments

2016-05-09  James Gallagher  <jgallagher@opendap.org>

	Coverity edits - both minor
	[ci skip]

	Removed extraneous include

2016-05-06  James Gallagher  <jgallagher@opendap.org>

	Added parser-util.cc back in after deleting it by mistake.

	Minor patches for issues found by Coverity Changes to be committed: 	modified:   Connect.cc 	deleted:    parser-util.cc

2016-05-05  James Gallagher  <jgallagher@opendap.org>

	Improved error checking for the DDX parser.
	When text is feed into the parser and its not valid xml, the parser
	was just ignoring that. No more...

	Arrg. baselines were not int he last commit...

	Moved the newest tests' baselines to the 'universal' directory
	It's time to switch the new DMR tests to ones that don't have to
	have a separate set of baselines for bin- and little-endian
	machines. It takes too long to build up the big-endian test
	baselines (get a b-e VM, etc.) and we have a good set of baselines
	for each arch so if issues pop up on one or the otehr arch,
	it should be easy to catch them.

	Merge pull request #18 from OPENDAP/jg_filters
	Jg filters

	Merge branch 'master' into jg_filters
	Conflicts: D4Sequence.h

	Added 'universal' tests for DMRTest
	The DMR includes a checksum when it's built from received data and
	that checksum is a function of word order of the sender. This made
	building baselines for the DMR tests a pain. We've built a number of
	tests for both big- and little-endian machines - from now on new
	tests should use 'universal' baselines (built by removing the checksum
	using sed).

2016-05-04  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #17 from OPENDAP/D4Sequence_value_ref
	Added a new method to D4Sequence

2016-05-03  James Gallagher  <jgallagher@opendap.org>

	Cosmetic editing

	Optimized the read_sequence_values() code.
	Child sequences do not have copies of the filter clauses. These are not
	needed by them since they have already been filtered.

	Added tests for complex CEs involving nested seqeunces

	Inner sequence filter issue resolved
	The code still needs tests and there is a potential optimization and
	the syntax needs to be documented because the way fields in a
	sequence can be referenced is less general than other places in the CE.

	Fixed the issue with child sequences in DAP4

2016-05-02  James Gallagher  <jgallagher@opendap.org>

	Partial fix for Hyrax-182
	https://opendap.atlassian.net/browse/HYRAX-182

2016-04-29  James Gallagher  <jgallagher@opendap.org>

	More test baselines

	Scanner fix

	Fixed the numeric constant error with the filter code
	Numeric constants were showing up as the value '1.' The checking_*()
	functions were the culprit. In the process I added missing methods in
	the FilterClause code and debugging in a number of places.

	Added tests for the new filter code. Not all of the tests pass...
	There is some work to be done with parsing the != and ~= operators
	and also mixing int and float arguments. There may be issues with
	filed references as well, but we'll have to check the spec for that.

2016-04-25  James Gallagher  <jgallagher@opendap.org>

	Fixed the issue with <constant> <op> <var> not working.

	Fixed three operand filter clauses in the CE evaluator, but...
	they still don't work correctly. There seems to be a problem with the
	parsing of constants.

2016-04-24  James Gallagher  <jgallagher@opendap.org>

	Removed debugging statements; Using the 'ND' operator is an error.

	The parser now builds filter clauses and binds them to a D4Sequence.
	Some by-hand tests show not everything works, but mostly it's a problem
	with relops and String variables or constants.

2016-04-23  James Gallagher  <jgallagher@opendap.org>

	Parser tweaks - relops now are returned as strings

	Fixed a problem with the TestByte, ..., classes when used for 'series values'
	Some of the classes had the odd behavior that the series of values
	was per-process and not per object instance. So, TestStr's value
	would not repeat until a new process was started, it instead kept
	increasing "... 1", "... 2", etc., across different instances of
	the class. Fixing this made it easy to fix the TestD4Sequence code.

2016-04-22  James Gallagher  <jgallagher@opendap.org>

	Added tests for D4Sequences, including filter clause evaluation

	Added D4SequenceTest

	D4Sequence now supports evaluating a FilterClauseList.
	Added tests too. I have only tested D4Sequence::intern_data(),
	not serialize().

	D4FilterClauseList now used by D4Sequence::serialize()

	Eh, I rewrote the relops operator code.
	It now uses the same approach that I used for DAP2 - a method
	for each type (Byte, ...).

	Added D4FilterClauseTest

	Fixed a bug in the was D4Function was used
	In the ServerFunctionList and d4_function_parser.yy, I should
	have been using a poiter to D4Function and not the object itself.
	Now the DMRTests for functions pass

2016-04-21  James Gallagher  <jgallagher@opendap.org>

	Hacks to the D4FilterClause code
	This also includes fixes to D4RValue and tests for the filter clause
	code. Two minor changes to the parsers.

2016-04-20  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' into jg_filters

	Added a new method to D4Sequence
	D4SeqValues &D4Sequence::value_ref(): Returns a reference to the
	internal data held by a D4Sequence instance.

2016-04-20  Nathan Potter  <ndp@opendap.org>

	Updated doxygen version number

	Merge branch 'master' of https://github.com/opendap/libdap4

	Added debugging statements to various Sequence items.

2016-04-18  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of https://github.com/opendap/libdap4

	Version 3.17.3

	Version 3.17.2; Fixed a soname error
	Adding a const constructor seems to have *removed* the old constructor
	as far as some code is cncerned (it's still there, but with a
	different mangled name).

2016-04-15  James Gallagher  <jgallagher@opendap.org>

	Version 3.17.2

	Merge branch 'master' into Hyrax-98
	Conflicts:
		tests/DMRTest.at

	Removed use of a const iterator in D4Maps' remove_map method

	Merge pull request #15 from sharkcz/cppunit
	fallback to pkg-config if cppunit-config is not available

	Fixed an error in the script related to Coverity support
	The env var COVERITY_SCAN_BRANCH should have been quoted.

	Merge pull request #13 from sharkcz/dmr-bigendian
	add missing big endian baselines

2016-04-15  Dan Horák  <dan@danny.cz>

	fallback to pkg-config if cppunit-config is not available
	Recent version of cppunit packages do not distribute the cppunit-config script
	and expect the usage of pkgconfig file.

2016-04-14  Dan Horák  <dan@danny.cz>

	remove the condition because we added the missing baselines

	add big endian baseline files for new tests

2016-04-13  James Gallagher  <jgallagher@opendap.org>

	Added tests for Hyrax-98 issues.
	These tests cover requests for an Array w/o including the Map and
	requests that use local dimension slices. The test dataset is has
	only one dimension/map.

	Fix for Hyrax-98: Requests for Arrays with Maps fail sometimes
	There are two cases where the request for an Array that contains Maps
	was failing: The request didn't also name the Maps, or the request
	used 'local dimension slices'. The latter case is fairly complex and
	the fix here (actually both fixes here) may need revision once we
	look at how the specification should be clarified when these kinds of
	CEs are used. Here is the ticket:
	https://opendap.atlassian.net/browse/HYRAX-98

2016-04-08  James Gallagher  <jgallagher@opendap.org>

	Added comments to D4 parser code.

2016-04-06  James Gallagher  <jgallagher@opendap.org>

	Added dump() methods for D4Attribute and D4Attributes.

2016-04-01  James Gallagher  <jgallagher@opendap.org>

	Version 3.17.1

	Added #include <string> to D4RValue.h to fix an issue over in the BES

2016-03-22  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #11 from OPENDAP/d4-threads
	D4StreamMarshaller now uses the double buffering code for transmission

2016-03-18  James Gallagher  <jgallagher@opendap.org>

	Added #include <cstring> for linux

	D4StreamMarshaller now uses the double buffering code for transmission of vector and opaque data.

	Merge branch 'master' of https://github.com/opendap/libdap4

	Possible fix for the memory issue in Hyrax-152.
	Push this to github and test on linux.

2016-03-01  Nathan Potter  <ndp@opendap.org>

	Updated getdap4 usage statement to better reflect the new behavior of the application.

2016-02-29  Nathan Potter  <ndp@opendap.org>

	Fixed BES-102 in which getdap4 was bumbling the DAP4 CE.

2016-02-26  Nathan Potter  <ndp@opendap.org>

	Merge branch 'master' of https://github.com/opendap/libdap4

	Removed timing code fro MarshllerThread using our friend #if 0

2016-02-24  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #9 from sharkcz/endian
	fix big endian detection

2016-02-22  James Gallagher  <jgallagher@opendap.org>

	Edit Int8::print_val() so that Int8 values always print as numbers.

2016-02-20  Dan Horák  <dan@danny.cz>

	fix big endian detection
	Currently there is a endian detection during configure, but the code relies
	on non-portable __BIG_ENDIAN__ define. The default actions in AC_C_BIGENDIAN
	break setting the correct value for WORD_BIGENDIAN.

	See also https://bugzilla.redhat.com/show_bug.cgi?id=962091#c48

2016-02-18  James Gallagher  <jgallagher@opendap.org>

	Added long-needed const constructor and operator=()
	This was done to support some experiments with memory caching,
	but it's a long-overdue fix in general.

	Zero-length array support: Vector::serialize() traps calls when length() == 0
	This is part of a series of changes to support netCDF files
	that use zero-length arrays as arbitrary attribute containers.

	Removed old code that was commented out.

	Replaced fgets() > 0 with fgets() != 0 in the parser's main loop
	A suggestions from David Binderman.

2016-02-12  James Gallagher  <jgallagher@opendap.org>

	Patch for gcc 6 from Orion Poplawski

2016-02-02  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #8 from OPENDAP/BES-97
	Bes 97

2016-01-29  James Gallagher  <jgallagher@opendap.org>

	Modified Vector::val2buf() in support of zero-length arrays
	val2buf() was throwing an InternalErr when called with a null data
	pointer. I modified it so that if the pointer is null and the length()
	of the vector/array is zero, it returns zero. The exception is still
	thrown if the pointer is null and the length() is not zero.

	Removed #define DODS_DEBUG

	Tests for empty DAP2 Structures

	Tests for empty structures added.

2016-01-28  James Gallagher  <jgallagher@opendap.org>

	Zero-length arrays now work with libdap, with caveats
	I have implemented and tested zero-length arrays of the
	cardinal types for DAP2 and 4. There's more to be done and
	no testing outside of libdap has been done.

	Added documentation comments in crc.h

	Spelling fixes in the ChangeLog, ...

2016-01-26  James Gallagher  <jgallagher@opendap.org>

	ChangeLog, et al., updated Version 3.17.0

2016-01-20  James Gallagher  <jgallagher@opendap.org>

	Removed #if 0 in the D4Function/ConstraintEvaluator::error() methods

2016-01-19  James Gallagher  <jgallagher@opendap.org>

	Found one more place in the DAP4 CE and Function parser where errors did not result in an exception.

2016-01-13  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #6 from OPENDAP/BES-87
	BES 87

2016-01-12  James Gallagher  <jgallagher@opendap.org>

	Added comments re how the Error object codes map to HTTP codes

	Added mapping between libdap and HTTP codes (suggestions)

	Added a code to Error; made sure Error was used consistently
	Changes to mesh with those in the OLFS. Error(unknown_error, ...)
	maps to an HTTP 400, internal_error --> 500, not_impelemented -->501,
	etc.

	DAP2 and 4 scanners now throw Error(malformed_expr, <msg>)
	They were writing to stderr...

	DAP2 CE parser uses no_such_identifier where apropos

2016-01-11  James Gallagher  <jgallagher@opendap.org>

	Added codes Error response in the DAP2 parser
	There were only a handful since most of the Error throws were well
	behaved.

	Modified the DAP4 ce and function parsers to include code w/Errors
	See https://opendap.atlassian.net/browse/BES-87.

2016-01-05  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' into bes-40

2016-01-04  James Gallagher  <jgallagher@opendap.org>

	Modified the CRC32 byte-order change so that it's not included by default

	Popped old changes for Connect; fix for Makefile.am; etc.

2015-12-31  James Gallagher  <jgallagher@opendap.org>

	Hacks for doxygen.
	The Makefile works now (rebuilds doxy.conf when needed) and the docs
	are better. I stopped including docs for methods w/o doc comments
	and those are now listed in the doxygen_warnings.txt file.
	[ci skip]

2015-12-30  James Gallagher  <jgallagher@opendap.org>

	Tried CLion; added CMakeLists.txt to gitignore

	Removed the calls to DDS:timeout_{on,off}
	This code is no longer used. The timeout feature of the BES is far
	better.

2015-12-08  James Gallagher  <jgallagher@opendap.org>

	Removed commented-out code

	Merge branch 'master' of https://github.com/opendap/libdap4

	Float32 attributes mis-coded as Byte in the DMR

2015-12-03  Nathan Potter  <ndp@opendap.org>

	Travis install check

	Travis install check

2015-11-30  Patrick West  <pwest@vsto.tw.rpi.edu>

	Missing xml2 libraries in unit-tests build
	Added $(XML2_LIBS) to the Makefile.am in unit-tests so that tests would
	build. On Ubuntu 14.04.

2015-11-13  James Gallagher  <jgallagher@opendap.org>

	I removed the deploy lines from the travis.yml file
	These seem broken - I have to investigate how to handle
	deployment of RPMs out of travis

2015-10-22  James Gallagher  <jgallagher@opendap.org>

	Fixed error in printing of child groups.
	The child group values were printed twice.

2015-10-21  James Gallagher  <jgallagher@opendap.org>

	Source release version, ChangeLog, News, ... for 3.16.0

2015-10-19  James Gallagher  <jgallagher@opendap.org>

	Fixes #1

	Merge branch 'master' into jg_filters
	Conflicts:
		BaseType.cc

	Added changes to exit when 'report_errors' (-r) is true

	Fix for the missing 'child groups' in getdap4's output
	And some minor mods to XMLWriter - clean up the includes a bit.

2015-10-15  James Gallagher  <jgallagher@opendap.org>

	Merge pull request #5 from OPENDAP/intern_no_crc32
	Intern no crc32

	Merge pull request #4 from OPENDAP/endian_fixes
	Endian fixes

2015-10-14  James Gallagher  <jgallagher@opendap.org>

	Some of the DAP4-only types were not setting is_dap4
	This casued the DMR output code to throw an error (Unknown Type) in
	cases where those types were used.
	See https://opendap.atlassian.net/browse/HR-63

2015-10-13  James Gallagher  <jgallagher@opendap.org>

	fixed a warning in dmr-test - /* in a comment

2015-10-13  jgallagher59701  <jgallagher@opendap.org>

	Added test baselines for intern_data with no checksum
	I dropped computing the checksum in the intern_data() method,
	so the baselines for the tests had to be updated.

2015-10-13  James Gallagher  <jgallagher@opendap.org>

	Now the intern_data() method used with DAP4 does not compute the checksum
	It is only computed by the code that serializes the response - sends it
	to a remote client. I added baselines specifically for the intern tests
	on little endian machines. Will add ones for big endian next...

	Merge branch 'intern_no_crc32' of https://github.com/opendap/libdap4.git into intern_no_crc32

	Removed crc32 generation from intern_data()
	This seems better - I htink computing the CRC code
	when interning values is not necessary. Those should
	only be computed when the server is going to send values.

2015-10-12  James Gallagher  <jgallagher@opendap.org>

	Completed changes to D4UnMarshallerTest.cc
	This copy of the tests hould work on both little- and big-endian
	hosts.

	More changes to D4UnMarshallerTest.cc

2015-10-12  jgallagher59701  <jgallagher@opendap.org>

	Partial fix for D4UnMarshallerTest.cc

2015-10-12  James Gallagher  <jgallagher@opendap.org>

	Changed WORDS_BIGENDIAN to __BIG_ENDIAN__

2015-10-07  jgallagher59701  <jgallagher@opendap.org>

	One step closer to the tests working on big endian machines
	D4MarshallerTest now works

	Update to D4Marshaller/UnMarshaller tests - added baselines for big-endian
	...There's still an issue, however.

2015-10-07  James Gallagher  <jgallagher@opendap.org>

	D4UnMarshallerTest also needs two sets of baselines. Added little-endian ones.

	D4MarshallerTest need two sets of baselines...
	One for big- and one for litte-endian machines. I made the little
	endian set.

2015-10-07  jgallagher59701  <jgallagher@opendap.org>

	Changed to D4EnumTest to support changes for big-endian machines.

2015-10-07  James Gallagher  <jgallagher@opendap.org>

	The change to D4Enum::compute_checksum() was correct.
	This fixes the last of the issues with Enum on big-endian machines.
	The problems we caused by the assumption that 64-, 32-, 16- and 8-bit
	integers would align on the LSB, which is the case for little-endian
	machines (but not big...). In several places where reinterpret_cast<>()
	was used I first assigned the Enum _value_ to a temp variable of the
	correct size and then passed the address of that to the checksum calculation
	function. High cost in one sense, but really, scalar Enum variables will
	be rare and Arrays of Enums are handled differently. I also have dropped
	the overly-complex design that used a union. It eliminated some casts,
	but was based on the erroneous assumption regarding alignment.

	Test change in computing checksum for big-endian machines.

	Debugging big-endian issues still..

2015-10-07  James Gallagher  <jimg@idoru.local>

	Merge branch 'endian_fixes' of https://github.com/opendap/libdap4 into endian_fixes

	Cleanup of a version of this that should work on big and little-endian machines.

2015-10-06  jgallagher59701  <jgallagher@opendap.org>

	Baselines for Enum tests on big endian machines
	Now only the tests 54 and 55 fail on the big enian machines...

2015-10-06  James Gallagher  <jimg@idoru.local>

	Removed union in the D4Enum implementation
	This is an attempt to fix the issues found on big endian machines.

2015-10-01  James Gallagher  <jgallagher@opendap.org>

	The DMR tests now work on little endian machines, mostly
	There is an issue with D4Enum that causes some tests to fail.

2015-10-01  jgallagher59701  <jgallagher@opendap.org>

	Fixes for function/ce tests modified:   tests/DMRTest.at

2015-09-30  jgallagher59701  <jgallagher@opendap.org>

	Baselines for a big endian machine.

2015-09-30  James Gallagher  <jgallagher@opendap.org>

	Fail: fixed a syntax error that got pushed.

	Added capability to build baselines that's sane

	Continue with fixes for data + ce tests

	DMRTest is dependent on word order - this is a trial fix.

2015-09-29  James Gallagher  <jgallagher@opendap.org>

	Fixed an issue in HTTPCacheTest; version number bump.
	In HTTPCacheTest, a quirk of RCReader meant that when the tests
	were run as part of distcheck they would fail if the user has set
	USE_CACHE to 1 in their ~/.dodsrc. Version numbers bumped to 3.15.1.

2015-09-23  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of https://github.com/opendap/libdap4

	Fixed a syntx error in cgi_util.h
	... and added comentary to MarshallerThread.cc

2015-09-20  James Gallagher  <jgallagher@opendap.org>

	Version 3.15.1

2015-09-18  James Gallagher  <jgallagher@opendap.org>

	Added empty Coverity model file

	Fixed a bug in the DAP4 CE evaluator
	The DAP4 CE evaluator was using just the stop index value
	as the size of a dimension when testing if the stride value
	was valid. When a dimension of length 1 (i.e., [0:0]) was
	found, it's length was '0' and a stride of '1' was invalid.
	I fixed this and the test now uses stop-start +1 for the
	dimension length.

2015-09-17  James Gallagher  <jgallagher@opendap.org>

	HTTPCacheTable uses verbose errors
	... instead of obscure error codes

	Modified configure.ac to fail if uuid.h is not found.

2015-09-16  James Gallagher  <jgallagher@opendap.org>

	Added #error if uuid.h is not found modified:   DODSFilter.cc modified:   tests/ResponseBuilder.cc

	Fixed a syntax error modified:   tests/ResponseBuilder.cc

	An attempt to fix the uuid.h header issues.
	I added a test to test for uuid.h in addition to uuid/uuid.h
	in the hope that it'll find something and compile. I may have to
	work on this a bit more since it's caused such a hassle on the
	different build systems.

2015-09-15  James Gallagher  <jgallagher@opendap.org>

	Minor issue in D4EnumDefs.cc with range checking

	Added #include <cerrno> where needed

2015-09-14  James Gallagher  <jgallagher@opendap.org>

	Minor fix for precision in Float64

	CID 81430

	CID 81412

	CID 81409

	CID 81405

	CID 81402

	CID 81401

	CID 81397

	formatting

	CID 81389

	CID 81382

	CID 81377

	CID 81375

	CID 81373

	CID 81370

	CID 81363

	CID 81362

	CID 81361

	CID 81360

	CID 81359

2015-09-10  James Gallagher  <jgallagher@opendap.org>

	Updated files for the release of 3.15

2015-09-09  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' into parallel_io

	An error introduced in March has been fixed; Freeform tests now pass
	Commit 6b005387 introduced a change where set_read_p() no longer
	tested the state of the is_synthesized property. Before, if the property
	was set the method would not change the state of is_read. The change
	made it so the is_read propery was changed regardless of the state of
	is_synthesized. This broke the 'projection functions' in the FreeForm
	handler. I have reverted to the old libdap behavior, and the tests now
	pass.

2015-09-04  James Gallagher  <jgallagher@opendap.org>

	Removed the old serialize_no_release() method

2015-09-02  James Gallagher  <jgallagher@opendap.org>

	Now has a special class for RAII on the lock in the child thread.

2015-08-31  James Gallagher  <jgallagher@opendap.org>

	Cleaned out more dead code from Vector.cc

2015-08-28  James Gallagher  <jgallagher@opendap.org>

	Updated the versio number to 3.15
	This because of the parallel IO code and pipelining support.

	Removed old code from MarshallerThread refactor.

	Moved the pthread code from XDRStreamMarshaller
	It's now in MarshallerThread and used by XDRStreamMarshaller via the
	'pointer to an implementation' pattern. This means that the pthread.h,
	which configure looks for but may not find, is not included in XDR-
	StreamMarshaller's header anymore.

2015-08-27  James Gallagher  <jgallagher@opendap.org>

	Added support for put_vector_part() to D4StreamMarshaller

	Refactor: CLEAR_LOCAL_DATA and USE_POSIX_THREADS
	We found that we could call clear_local_data() right after variables
	were serialized and get a much flatter memory profile. However, putting
	those calls in serialize() changed its behavior. I've moved them to
	bes/dap/ResponseBuilder - but that is controllable using a comple-time
	directive. Similarly, the compile-time switch USE_POSIX_THREADS
	can be used to turn off that feature (#undef). See XDRStreamMarshaller.

	Refactor: Parallel I/O methods
	I refactored the three new parallel I/O methods back into the matching
	put_vector() methods of the same/similar names. This cuts down on the
	naming mess and means that other classes like XDFFileStream don't have
	to include hacked methods that throw exceptions. This commit also
	includes changes tha wrap the clear_local_data() calls in #ifdef
	CLEAR_LOCAL_DATA. Lastly, this refactor will also require a matching
	edit to ncml_module.

2015-08-24  James Gallagher  <jgallagher@opendap.org>

	Patch/fix/hack for XDRStreamMarshaller
	This class' header requires pthread.h but that makes for issues since
	we cannot put an include of config.h in a .h file that is installed.
	To get on with testing, I'm checking in this version that just includes
	it; later on I may modify the class to encapsulate the pthreads stuff.

	Fix for clear_local_data() race condition
	Took advantage of the current XDRStreamMarshaller impl that copies
	data before writing it out. This means our code can delete the original
	data held by the object right after the thread used to send that data
	hass been called (actually, it could delete it _before_ starting the
	thread, but doing so afterward keeps that feature out of the marshaller
	class, which may come in handly later on...). Later on we may switch
	to reference counted pointers and then this issue will go away.

	Removed call to clear_local_data() in Vector::Serialize()
	This was colliding with the call to clear_local_data() in the thread
	when put_vector_thread() was called. This showed up as a 'sometimes'
	failure of expr test #21. The bug happens only when serializing an
	array of strucutre that contains arrays.

2015-08-22  James Gallagher  <jgallagher@opendap.org>

	Corrected a spelling mistake with 'serialize_no_release'

	I've added synchronization code to the XDRStreamMarshaller dotr
	This causes the XDRStreamMarshaller dtor to block on the d_out_mutex
	until the child thread (possibly) writing to the output stream
	completes.

2015-08-21  James Gallagher  <jgallagher@opendap.org>

	Added parallel_io to the set of branches Travis will build.

	Now threads in XDRStreamMarshaller are created detached state

	Added the new put_vector_thread methods to Marshaller
	I made them have a default implementation so that child classes
	won't break. I'm not sure if that's the best way to go...
	Also dropped the new *_thread() methods into Vector::serialize(),
	but they don't work so those are turned off by using #undef
	USE_POSIX_THREADS

	Parallel I/O for vector data maybe working
	I have coded put_vector_thread() and put_vector_part_thread() and
	they are passing unit tests.

2015-08-18  James Gallagher  <jgallagher@opendap.org>

	Removed some of the TODOs in libdap
	[ci skip]

2015-08-17  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of https://github.com/opendap/libdap4

	Modified Vector::get_buf() so it can be used in the ncml handler

2015-08-17  Nathan Potter  <ndp@opendap.org>

	Merged the new (template-less) version of Vector inot master branch

2015-08-17  James Gallagher  <jgallagher@opendap.org>

	Completed DAP2 put_vector_part() and associated methods.

2015-08-14  Nathan Potter  <ndp@opendap.org>

	Typo

2015-08-14  James Gallagher  <jgallagher@opendap.org>

	Partial Vector/Array serialization partly working!
	Must still implement the parts for Arrays of int16, ..., types;
	only byte arrays work now.

	Checkpoint: Adding methods to allow serailization of Vectors in parts.
	Missing methods in D4StreamMarshaller, XDRFileMarsahller and parts of
	methods in XDRStreamMarshaller.

	Added three protected accessors to Vector
	These provide access to the underlying data held in a Vector/Array
	and are accessible to descendant classes only.

2015-08-14  Nathan Potter  <ndp@opendap.org>

	Replaced template methods in Vector.cc with more pedantic implmentations. Made the templted methods private and used them in the implementations of the new pedantic methods.

2015-08-10  James Gallagher  <jgallagher@opendap.org>

	Bumped up the version number to 3.14.2

	Bumped up the version (and SO numbers). This is 3.14.2

	Merge branch 'serialize_n_release'

	Added a serialize_no_release() method
	This rounds out the serialize_n_release branch. The new behavior of
	freeing the dynamic memory is very desireable, so it's the default,
	but if some code wants to serialize, do something else and then delete
	the storage, the new serialize_no_release provides that option. All
	of our libdap and bes/module tests pass. This will be merged to the
	master branch once the latter has been tagged.

2015-08-07  James Gallagher  <jgallagher@opendap.org>

	Fixed overwriting commit for Vector::serialize()
	We decided to make the serialize and release code real, but in the
	process that collided with changes to BaseType::name() (making it
	a virtual method). One line was broken, but since it was the call to
	clear_local_data() in Vector::serialize(), it was an important line!

2015-08-06  James Gallagher  <jgallagher@opendap.org>

	distcheck works locally

	Fix for distcheck and getdapTest

	make check now supports parallel execution
	Modified test/Makefile.am so that autotest parallel tests work. Run
	make check with TESTSUITEFLAGS=-jN

2015-08-05  Nathan Potter  <ndp@opendap.org>

	pulled from github and merged conflicts

	Refactored use of the name() method in BaseType so that it is now overrideable

2015-08-05  James Gallagher  <jgallagher@opendap.org>

	Added BaseType::clear_local_data()
	The clear_local_data() method is used to free just the parts of a
	BaseType (child of, really) that hold large amounts of data. It applies
	to only a handful of the variable types (Vector, Sequence, D4Opaque and
	D4Sequence). It is used to free memory right after data values are
	sent to the client using serailize(). This means that data are no longer
	held by the variable objects once serialize() returns - at least for
	Array, Sequence, ... Other types like Byte, Int16, ..., will retain
	their values because those values are not held in dynamically allocated
	storage.

2015-08-04  James Gallagher  <jgallagher@opendap.org>

	Hacked the marshT unit-test
	I modified this so that it no longer relies on data being present after
	serialize() has been called. It seems that none of the handlers use
	this 'feature' and we can change the code so that memory is freed right
	after the bits are sent fir each variable. This means that only one
	variabe's data are in memory at any given time.

2015-08-03  Nathan Potter  <ndp@opendap.org>

	Checking in change to _always_ release array memory after serialization. This causes the Marshaller test for Structure to seg fault.

2015-07-15  James Gallagher  <jgallagher@opendap.org>

	Removed the bisong version print out
	...I think this is working fine now
	[ci skip]

2015-07-13  James Gallagher  <jgallagher@opendap.org>

	Added distcheck to travis

	travis caching
	Modified travis.yml and install_libdap4_source_deps.sh so that
	the bison source build is cached.

	Another fix: added '/bin' to $HOME/bison in $PATH

	Removed odd ^S from install_libdap4_source_deps.sh

	More travis hacks - addes sudo: false back in; remove tabs

	travis: The build was not triggered with the last push...
	... so try removing 'sudo: false'

	Switched travis to use docker/containers

2015-07-09  James Gallagher  <jgallagher@opendap.org>

	Added .NOTPARALLEL: back to the C++ parser Makefile.am files
	We need this because stack.hh, ..., are built in one shot by
	bison.

	Updated the library version

	Grammar fixes - for flex and its C++ scanner code.
	There is a conflict between the defined return type of
	FlexLexer::LexerInput. Some versions of flex define that
	method as returning an int and some a returning a size_t.
	Including generated code using one will break when a build
	machine uses the other. I used dist-hook to just 'rm' those
	generated lex.*.cc files  from d4_ce and d4_function - the
	other generated scanners are OK. This is really a work-around
	since we should be able to include the generated scanners
	and then drop the build requirement for both bison and flex.

2015-07-07  James Gallagher  <jgallagher@opendap.org>

	Added absolute-header-m4 and removed .gitignore
	I think the .gitignore is from the gnulib source
	and is fine for their git repo, but not for clients
	of the library.

	Changed the tag for non-master travis builds to _travis
	... from -travis. Minor, but it bugged me.

	Modified travis.yml so that branches ending in -travis will be built.

	Updated gnulib code - this may affect the coverity results

2015-07-02  James Gallagher  <jgallagher@opendap.org>

	Coverity fix in dds.yy
	Fixed a potential leak where storage allocated is overwritten.
	An unlikely bug, but not a big deal to fix.

	Issues found using coverity fixed

2015-06-29  James Gallagher  <jgallagher@opendap.org>

	Fixed cppunit package for travis.yml

	Fixed a memory leak in dds.y

2015-06-26  James Gallagher  <jgallagher@opendap.org>

	Minor syntax error in TestArray; Travis now includes cppunit tests

	Memory leak in TestArray.cc plugged

	More changes WRT coverity and travis
	...in the travis.yml. Removed the before_build_command
	stuff from the coverity scan addon section since it seems
	to be redundant.

	Added coverity scan to travis CI

2015-06-25  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of https://github.com/opendap/libdap4.git

	Issues found in D4ParserSax2, DAS and DDS using Coverity.

2015-06-20  James Gallagher  <jgallagher@opendap.org>

	Finally fixed...?
	Using autoconf 2.69 make dist is building a tar-gz that includes the
	BUILT_SOURCES, which would be great for builders without bison 3. I'm
	not sure if that will work with autoconf 2.63.

	Move the D4 Function parser to its own directory.
	This is an attempt to really fix the stack, position and location.hh
	problem for once and for all. The Travis build is working, but maybe
	we're just lucky because a build from the tar.gz made using make dist
	was still failing.

2015-06-19  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of https://github.com/opendap/libdap4.git

2015-06-19  Ubuntu  <ubuntu@ip-172-31-34-168.ec2.internal>

	Modified build-deb-pkg.sh so that dap-config matches the installed files.

2015-06-19  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of https://github.com/opendap/libdap4.git

	Try using NOTPARALLEL with the libdap build - another travis hack.

2015-06-19  Ubuntu  <ubuntu@ip-172-31-34-168.ec2.internal>

	Modified DEBIAN/control to use libcurl4-openssl-dev as a dependency.
	Not sure why this was not working before.
	[ci skip]

	Merge branch 'master' of https://github.com/opendap/libdap4

	Added hackery script to DEBIAN directory.
	This will help with my simple deb file used for the bes build.

2015-06-18  James Gallagher  <jgallagher@opendap.org>

	Modified Makefile.am and d4_ce/... so bison is called only once
	This should stop the semi-random build fails for libdap4 on Travis
	and for other people.

	Added .NOTPARALLEL to d4_ce/Makefile.am for the grammar files
	I hope this fixes the odd issue with the generated grammar files
	breaking hte build in a random fashion. The error may be do to parallel
	builds running bison several times for each of the generated files, all
	at the same time.

	Cleaned up the d4_ce code
	The Makefile.am had leftover parts from the attempt to make the build
	work when bison 3 was not present. That may have been the cause of the
	seemingly random build errors I see on Travis CI

2015-06-17  James Gallagher  <jgallagher@opendap.org>

	Added dpkg -l to travis.yml
	This is part of debugging the bes travis build - I cannot seem to sort
	out the libcurl dependency since my Ubuntu AMI is a 14.x but the build
	is using 12.x

	travis bison hack...

2015-06-17  Ubuntu  <ubuntu@ip-172-31-34-168.ec2.internal>

	Merge branch 'master' of https://github.com/opendap/libdap4

	Changed DEBIAN/control arch to amd64

2015-06-17  James Gallagher  <jgallagher@opendap.org>

	travis.yml edits
	Now uses deploy section only for tagged pushes; removed unneeded
	--force-yes with apt-get; and will build tags in addition to the
	master branch.

	Fixed build-deb-pkg.sh and added 'deploy' section to travis.
	Not sure about the deploy bit...

2015-06-16  James Gallagher  <jgallagher@opendap.org>

	Use newly built bison 3
	Added /usr/local/bin to PATH...

	Build bison from source (circling back)
	Travis-CI is currently using ubuntu 12 which using bison 2; Ubuntu 14
	has bison 3 in its package system.

	More tweaks to the simple deb package build
	This is a deb package for use with travis-ci when we get a bes CI
	build working

	Added debian package build to travis.yml
	...also tried using --force-yes to get bison to load with apt-get
	[ci skip]

2015-06-16  Ubuntu  <ubuntu@ip-172-31-34-168.ec2.internal>

	Added the build-deb-pkg.sh script.

	Added DEBIAN/control
	Use this along with dpkg-deb --build libdap_<version> to make a
	debian package.

2015-06-16  James Gallagher  <jgallagher@opendap.org>

	Another change to the travis.yml file
	It now uses bison installed using apt-get

2015-06-08  James Gallagher  <jgallagher@opendap.org>

	travis-ci error fixed
	I left --prefix=... on the configure of bison but $prefix's definition
	was moved to a later step.

	Reorganization of the travis.yml script.

2015-06-07  James Gallagher  <jgallagher@opendap.org>

	clang...

	...another try at clang support

	...another try at clang

2015-06-06  James Gallagher  <jgallagher@opendap.org>

	minor tweak to 'make install' with sudo -i

	fix for clang

	more travis ci changes - learning what this can do...

	Added some package installs to travis ci

	travis ci fix

	travis ci: added install of libdap

	travis ci change: install bison 3 using sudo

2015-06-05  James Gallagher  <jgallagher@opendap.org>

	Travis CI updates

	Added an initial .travis.yml file

2015-06-01  James Gallagher  <jgallagher@opendap.org>

	Added DBG2N - no line number version of DBG2

2015-05-24  James Gallagher  <jgallagher@opendap.org>

	Fixed comment

2015-05-23  James Gallagher  <jgallagher@opendap.org>

	D4FilterClause fixes

	Formatting and ctor warnings fixed

	Added D4FilterClause unit test
	... and removed ancient dejagnu tests

2015-05-14  James Gallagher  <jgallagher@opendap.org>

	Added a new function to make a temp file using mkstemps()
	This new function returns the temp file's name and a C++ fstream
	object that is opened to the temp file. This change adds to the
	libdap API.

2015-05-12  James Gallagher  <jgallagher@opendap.org>

	Fixed missing <string> include. Patch from O. Poplawski.

	Fix getopt() use. Patch from O. Poplawski

	Broke --enable-developer; now fixed.

	Fixed issues in configure and Makefiles reported by O. Poplawski.
	--enable-coverage and --enable-valgrind were broken.
	Setting CXXFLAGS to nothing broke builds on fedroa 21

	Added coverage file to gitignore

2015-05-01  James Gallagher  <jgallagher@opendap.org>

	Formatting, old code removeal, doxygen updates

2015-04-05  James Gallagher  <jgallagher@opendap.org>

	Bison 3 is required for the build.
	This might change, but for the next release (April 2015) it is a
	requirement for building the code. It will be possible to get the
	devel rpm and, however, and develop code that uses libdap w/o
	needing bison 3.

2015-04-03  James Gallagher  <jgallagher@opendap.org>

	Bumped up the library versions
	Each of libdap, libdapclient and libdapsever likely have new interfaces
	but the old interfaces are intact, so CURRENT and AGE are increased,
	and REVISION is reset to 0.

	Various changes as needed for the release.

2015-03-31  James Gallagher  <jgallagher@opendap.org>

	Added to gitignore

	Hacked more for the FlexLexer.h kludge...

	Resurrected the D4*Scanner.h files

	Modified the FlexLexer.h scheme
	Now it fits more with the way I'm handling the other generated
	files. The header is in the generated files dir and is only
	copied out when bison 3 is not found. It's still a kludge...

	Added FlexLexer.h
	This might be a mistake - remove if this fails on linux, etc.

2015-03-30  James Gallagher  <jgallagher@opendap.org>

	Rest of changes for template grammar files
	Now if bison 3.0+ is not found, the build will use
	template versions of the generated grammar files. This
	removes the dependence on bison 3.0 for most source
	builds. Of course, if you want to modify the D4 grammar
	you need bison 3.

	Added generated grammar sources
	When a machine does not have bison 3, it's a pain to install it, esp.
	at a site that doesn't let the builder do that! The work-around is to
	provide a backup set of sources that can be copied by the Makefile in
	lieu of the real thing.

2015-03-25  James Gallagher  <jgallagher@opendap.org>

	Added support 'match' to D4FilterClause

	Added commentary and some English fixes
	...to Operators.h and RValue

	Added D4FilterClause.
	This will be used to evaluate the DAP4 filter expressions.
	...in progress.

	Merge branch 'master' of https://github.com/opendap/libdap4

	Dropped the autoconf required version to 2.63
	This accommodates RH/CentOS 6. I also had to change the AT_ARG_OPTION_ARG
	calls so that multi-word options used underscores and not dashes.

	Change to libdap.spec
	I've added the dist info to the RPM and fixed up some of the
	description, too.

2015-03-20  James Gallagher  <jgallagher@opendap.org>

	Started implementing DAP4 filters

2015-03-17  James Gallagher  <jgallagher@opendap.org>

	Edited comments and reformatted.
	Also added a new method to Sequence that I subsequently removed
	from the code using the preprocessor. ...it might come in handy
	some day.

	Refactored TestCommon
	Now TestCommon.cc is not used; the constructors, etc. are now
	in TestCommon.h. In the future this class could be modified so
	that the 'series_values' property was accessible from TestCommon
	and not just the individual type classes.

	Change a comment emmited by configure less convoluted.

2015-03-16  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of https://github.com/opendap/libdap4

	Changes to build and to the Test* classes.
	Now configure tests for the uuid/uuid.h header (before it tested only
	for the library which meant that installing the libuuid package and
	not the needed libuuid-devel package would pass configure but fail
	during the build). I also removed some unused code from the Test* classes.
	The TestCommon.cc file was not needed.

	rpm target fixes
	Added getdap4 to the files list for RPM and fixed distclean/distcheck
	where some DMR tests are marked xfail (expected fail). With autotest,
	xfail leaves some cruft behind in the DMRTest.dir directory that
	./DMRTest --clean should remove (see the clean-local makefile target).
	However, because a space was added to the names in the Makefile.am,
	those --clean calls were not being made. Fixed. Somewhat exasperating...

2015-02-27  James Gallagher  <jgallagher@opendap.org>

	Merge branch 'master' of https://github.com/opendap/libdap4

2015-02-26  James Gallagher  <jgallagher@opendap.org>

	Added convenience function to util
	The new function extracts doubles from numeric arrays using a vector
	to cu down on memory management complexity (at the cost of an addition
	to the interface).

2015-02-21  James Gallagher  <jgallagher@opendap.org>

	Fixed GetOpt.cc includes
	This code used old includes (string.h, etc.) and was missing
	stdio. I added <cstdio> and changed stdlib.h and string.h to
	cstdlib and cstring. Removed a duplicate header. Build now works
	on AWS Centos 6.

2015-02-19  James Gallagher  <jgallagher@opendap.org>

	More Cleanup
	I re-indented TestSequence and removed some old code
	as part of my work on the aggregation server (which
	may not make it into the BES, another story...)

	Cleanup
	I removed unused code from Sequence, DDS.cc and AttrTable.cc

2015-02-09  James Gallagher  <jgallagher@opendap.org>

	Tweaked D4Sequence for BES function's tabular()
	The d_length field is now set when set_values()
	is called.

2015-02-02  James Gallagher  <jgallagher@opendap.org>

	Removed incorrect comment in Vector.h

2015-01-14  James Gallagher  <jgallagher@opendap.org>

	Added a type_name() function to util.cc/h
	In the merge with DAP4, type_name() split into D2type_name() and
	D4type_name(). That removes the symbol 'type_name()' from the library.
	I added a function with that name that first tries to apply D4... and
	then D2. If both fail, an exception is thrown. This provides forward
	looking backward compatibility.

	Fixed an issue with String constant arguments to DAP4 functions.
	The function parser for DAP4 was including the double quotes that
	delimit string constants in the value itself. I modified the parser
	to eliminate those.

2015-01-07  James Gallagher  <jgallagher@opendap.org>

	HTTPCacheTest was failing; fixed.
	The test assumed that the number of headers for a cached response
	would equal the headers in a response. This might not be the case.
	For example, the received response might include a Keep-Alive header.

	Error in D4Maps copy ctor fixed.
	This addresses an error in the DMRTest.cc unit test for the DMR
	class. DMR's copy ctor was failing to copy the maps from Arrays
	in the src object to the dest object because of an error in the
	D4Maps m_duplicate method.

	Corrected some comment text in DMR.cc

2015-01-05  James Gallagher  <jgallagher@opendap.org>

	Minor changes to the Makefile.am files

2014-12-31  James Gallagher  <jgallagher@opendap.org>

	Merge remote-tracking branch 'origin/dap4'
	Conflicts:
		unit-tests/HTTPConnectTest.cc

2014-12-12  James Gallagher  <jgallagher@opendap.org>

	Added eclipse meta files to gitignore.

	Merge branch 'master' of https://github.com/opendap/libdap

	comment change in main_page.doxygen

2014-12-03  James Gallagher  <jgallagher@opendap.org>

	Added files  left over from a full build to gitignore

2014-11-19  James Gallagher  <jgallagher@opendap.org>

	Added .gitignore and hacked up Makefile.am so that it uses subdir-objects.

2014-10-21  James Gallagher  <jgallagher@opendap.org>

	Added a valgrind 'suppressions' file for OSX 10.9. Not sure where this is going, but valgrind for unit tests and regression tests is probably a good thing.

	Fixed to the Makefile.am in d4_ce so that the grammar for DAP4 builds correctly.

2014-10-20  James Gallagher  <jgallagher@opendap.org>

	Changed HTTPConnect.cc on the release branch and then copied here. Minor fix in the test baseline to accommadate a change in the test host (etag changed with a change in the Apache server version).
	M    unit-tests/HTTPConnectTest.cc

2014-10-16  James Gallagher  <jgallagher@opendap.org>

	Fixed ticket 2260 - The issue where the DMR copy ctor built a DMR that would subsequently cause a segfault has been fixed. The problem was in Array::update_dimension_pointers(). The D4Dimension objects were not copied correctly between the old and new set of D4Dimensions in the Groups in the source and dest DMRs

2014-10-14  James Gallagher  <jgallagher@opendap.org>

	Leak fix in the D4CE code - both the CE and Functions parser leaked memory - fixed. Tests HTTPCacheTest and HTTPConnectTest fixed - there were two issue with the new test.o2 server. Array.h - removed the D4Dimensions.h include.

	Bug fix in ServerFunction: The setFunction setters in ServerFunction were setting other function pointers to null so that the ServerFunction object could hold only one kind of function for any given name. If we want linear_scale, e.g., to work for both DAP2 and DAP4, the class has to be able to support a btp_func and D4Function. I fixed the ctors and setters so that works.

2014-09-17  James Gallagher  <jgallagher@opendap.org>

	Renamed the bison 'Driver' classes to be D4ConstraintEvaluator and D4FunctionEvaluator. Added an eval() method to the latter so that the BES can evaluation DAP4 Functions in a some sort of a sane way. I also moved the old and crufty D4ResponseBuilder code out of the libdap dir; there's a class with the same name in tests, but it does different (and more sane) things.

	Comments and changed template type from 't' to 'T'.

	Comments...

2014-09-12  James Gallagher  <jgallagher@opendap.org>

	Fixed FQN() for Constructors that hold arrays.

2014-09-11  James Gallagher  <jgallagher@opendap.org>

	I removed the DMR& parameter to BaseType::intern_data(). This seems to be a relic from DAP2 (where it may not have actually been used either) and it makes employing delegation somewhat harder in the 'transmitter' handlers I'm working on porting over to DAP4.

	Modified to use the new 'DMR-free' version of intern_data(). Also fixed the help message.

	Added a DMR that holds a nested sequence so this can be tested - currently does not work and is not part of the tests.

2014-09-08  James Gallagher  <jgallagher@opendap.org>

	Marked four tests a xfail. See ticket #2244
	M    tests/DMRTest.at

	I added specializations for transform_to_dap4() to TestStructure and TestSequence so that, among other things, the dapreader code can build DAP4 data responses using DAP2 response files.

2014-09-05  James Gallagher  <jgallagher@opendap.org>

	Fixed hiccup in Makefile.am that prevented the D4Connect.h header from being installed - it was not listed in pkginclude_HEADERS. Added subdir-objects to the options list in the Makefile.am too. Fixed an error message in getdap4 - text change only.

2014-09-04  James Gallagher  <jgallagher@opendap.org>

	Added a FQN() method that will return the FQN for any variable, including the group part. Also added a decent comment on the D4Group::find_var() method. Unit tests added to the D4GroupTest unit test.

2014-09-03  James Gallagher  <jgallagher@opendap.org>

	Removed duplicate code in Sequence and Structure for the transform_to_dap4() method; moved the common code to Constructor.

2014-08-27  James Gallagher  <jgallagher@opendap.org>

	Added an update of the weak pointers held by Array so that the DMR::m_duplicate() method can use D4Group::ptr_duplicate(). This was useful when porting the gdal_handler code to DAP4.

2014-08-21  James Gallagher  <jgallagher@opendap.org>

	Change to Constructor::serialize(). It now calls read(). This was removed because it broke the behavior of D4Sequence - at least in the test code (it still does). More work needs to be done on this, but the FreeForm handler, which builds sequences is working with D4Sequence (DMR/DAP4 Data via the DDS --> DMR hack). I will need to revisit this...

2014-08-19  James Gallagher  <jgallagher@opendap.org>

	Now has a separate method to 'blend in' variables from a DDS into the DMR. This is used by the DDS-ctor for DMR but it can also be called on an existing DMR like the ones built by the BES. This was done so that information set when the BES builds the DMR won't be lost.

	Changes to the transform_to_dap4() method - both Sequence and Structure have implementations that work for tests and clients, but not most servers. Array should be pretty general and may work for most handlers.

2014-08-18  James Gallagher  <jgallagher@opendap.org>

	Removed unused code - part of an aborted attempt to add a factory class as a param to BaseType::transform_to_dap4(...). Instead, it's likely better to subclass that method in the types like FFSequence (in the handlers). In the process I found a fair amount of old code that was commented out and removed it.

2014-08-15  James Gallagher  <jgallagher@opendap.org>

	Fixed an issue in Array where D4Dimensions made using the 'transform dap2 to dap4 code' with the same name but different sizes could be made. This was bad; I changed the code so that when a name conflict is found, the D4Dimension  will have a different name (made using the orig dimension name and the variable name). In this case, the fist D4Dimension gets to use the name exactly as it appears in the Array while the second D4Dimension gets a more cumbersome, but unique, name.

	Fixed the order of printing of attributes and variables for constructor types when working with DAP2 responses (i.e., the DDX). The order (attr; vars) is reversed in DAP4.

2014-08-14  James Gallagher  <jgallagher@opendap.org>

	Patch for getopt applied
	_M   .
	M    unit-tests/DDSTest.cc
	M    unit-tests/DDXParserTest.cc
	MM   unit-tests/SequenceTest.cc
	M    unit-tests/ServerFunctionsListUnitTest.cc

	Patch from Orion Poplawski to fix some of the getopt calls in the unit-tests
	M    unit-tests/DDSTest.cc
	M    unit-tests/DDXParserTest.cc
	M    unit-tests/SequenceTest.cc
	M    unit-tests/ServerFunctionsListUnitTest.cc

2014-08-11  James Gallagher  <jgallagher@opendap.org>

	Changes from H 1.9.9 on the trunk

2014-08-09  James Gallagher  <jgallagher@opendap.org>

	Merge from the trunk to include changes for Hyrax 1.9.9
	_M   .
	M    RValue.cc
	M    XMLWriter.h
	M    configure.ac
	M    ChangeLog
	M    main_page.doxygen
	M    INSTALL
	M    libdap.spec
	M    README
	M    Makefile.am
	M    NEWS
	M    ce_expr.yy
	M    unit-tests/HTTPConnectTest.cc
	M    doxy.conf

2014-08-08  James Gallagher  <jgallagher@opendap.org>

	Version 3.13.3
	M    ChangeLog
	M    INSTALL
	M    NEWS
	M    README
	M    configure.ac
	M    doxy.conf
	M    libdap.spec
	M    main_page.doxygen

	Fixed a leak in RValue.cc using a patch from Aron (ADB)

2014-08-01  James Gallagher  <jgallagher@opendap.org>

	Release checklist steps for 3.13.2
	M    ChangeLog
	M    INSTALL
	M    NEWS
	M    README
	M    configure.ac
	M    doxy.conf
	M    libdap.spec
	M    main_page.doxygen

2014-07-30  James Gallagher  <jgallagher@opendap.org>

	Second fix for ticket 2240 - SCAN_STR from the CE scanner was leaking because the parser did not delete the reutrned string. I also modified the first fix so that a local tmp string was used instead of new dynamic storage.
	M    ce_expr.yy

	Fixed a memory leak reported by Aron.Bartle@mechdyne.com. See ticket 2240.
	M    ce_expr.yy

	I added a comment about a potential memory leak to ce_expr.yy

2014-05-07  James Gallagher  <jgallagher@opendap.org>

	spelling

	Fixed a test baseline in HTTPConnectTest so that it will work with the new headers returned by H 1.9.3 (which include so things from DAP4).

2014-05-05  James Gallagher  <jgallagher@opendap.org>

	namespace libdap addex
	M    XMLWriter.h

2014-05-02  James Gallagher  <jgallagher@opendap.org>

	Minor edit to Makefile.am for builds on centos 5 - there libgl builds a copy of unistd.h that doesn't work with flex generated cc files. So I pulled -I./gl from CPP flags for the parsers library.

	Merged code from the trunk - this effectively merges changes from the Hyrax 1.9.3 release.

2014-04-22  James Gallagher  <jgallagher@opendap.org>

	Updated for 3.13
	M    INSTALL
	M    README
	M    configure.ac

2014-04-15  James Gallagher  <jgallagher@opendap.org>

	Updates to NEWS, ChangeLog to match the bump in the vesion number.

2014-04-11  James Gallagher  <jgallagher@opendap.org>

	Added comment info to abi_checker.xml.in so we'll remember how to use the abi checker.

	path fix/typo

	Added abi_checker.xml.in file for the perl-based abi checker. Seems to work only with gcc.

2014-03-29  James Gallagher  <jgallagher@opendap.org>

	typo...

	Unified the DMR() constructors so they all initialize the fields in essentially the same way.

2014-03-28  James Gallagher  <jgallagher@opendap.org>

	Fixed forward declarations in the D4 parser code.

2014-03-26  James Gallagher  <jgallagher@opendap.org>

2014-03-24  James Gallagher  <jgallagher@opendap.org>

	Commentary

2014-03-22  James Gallagher  <jgallagher@opendap.org>

	Removed the const iterator methods from DDS since they broke gcc on OSX 10.7.

	DDS --> DMR Grid working and tested.

2014-03-21  James Gallagher  <jgallagher@opendap.org>

	More changes for Grid in the DDS --> DMR code. It's not quite working, but the other types work. One test fails.

	Starting on Grid for the DDS to DMR code...

2014-03-20  James Gallagher  <jgallagher@opendap.org>

	more DDS --> DMR tests

	DDS --> DMR attribute merge/transform tests added.

2014-03-19  James Gallagher  <jgallagher@opendap.org>

	DDS --> DMR: Attribute transform method added to D4Attributes and wired up the BaseType::transform_to_dap4(). Not tested.

	DDS --> DMR; everything works except Grid and Attributes.

	DDS --> DMR: Datasets with Structures now work. Tested.

	commentary

2014-03-18  James Gallagher  <jgallagher@opendap.org>

	Changed the transform_to_dap4() method so that it will work with constructor types. Not implemented yet for them, however.

	Two tests for the DDS to DMR code.

	Little bit of the DDS --> DMR solution. No tests.

	Initial fix for shared dimensions and Enumerations in function results - this code (in dmr-test.cc) depends on the original DMR remaining intact until the function result is serialized. To fix this, either change how D4Dimension and D4EnumDef objects are stored or use reference counted pointers.

2014-03-17  James Gallagher  <jgallagher@opendap.org>

	Added

	Added all the $<type> special forms for the DAP4 numeric types along with tests to the DAP4 Function expression parser.

2014-03-14  James Gallagher  <jgallagher@opendap.org>

	The $<type> special form works and the argument length 'hint' optimization is working too. I made a template function that will shorten the rules in the parser so that each kind of simple type can be used with this ($Byte, $Int16, ...) but only implemented $Byte. Added a test.

2014-03-14  Nathan Potter  <ndp@opendap.org>

	libdap: Renaming intenral variables to clearly indicate when things are using DAP2 ce's and DAP4 ce's

	libdap: Renaming intenral variables to clearly indicate when things are using DAP2 ce's and DAP4 ce's

	libdap: Renaming intenral variables to clearly indicate when things are using DAP2 ce's and DAP4 ce's

	libdap: Renaming intenral variables to clearly indicate when things are using DAP2 ce's and DAP4 ce's

2014-03-14  James Gallagher  <jgallagher@opendap.org>

	Need to include both the .cc and .hh files for the parsers in the Makefile.am

	Added

	Initial version of the function parser with $<type> special forms (untested). The code compiles and passes existing tests.

2014-03-13  James Gallagher  <jgallagher@opendap.org>

	Marked some tests as xfail - because the function evaluation code does not deal with names dimensions correctly.

	more tests for server functions; composition is working

	Function parsing and evaluation working; initial set of tests added.

2014-03-12  James Gallagher  <jgallagher@opendap.org>

	Starting on function evaluation.

	Added a DAP4 server function - modified TestFunction to make D4TestFunction that includes both a DAP2 and DAP4 scale() function. The parser recognizes this function and seems to work. Not quite ready for a complete set of tests yet...

	initial cut of the tests for function parsing - it can figure out that a function has not been registered.

	Added initial tests for the Function parser; reorganized the CE parser tests in dmr-test.cc

2014-03-12  Nathan Potter  <ndp@opendap.org>

	lobdap: Fixed compile issue

2014-03-12  James Gallagher  <jgallagher@opendap.org>

	Added...

	Working on tests for the D4 function parser... Removed use of ConstraintEvaluator in intern_data() and other places for DAP4.

2014-03-11  James Gallagher  <jgallagher@opendap.org>

	First cut at the DAP4 function parser

	new stuff added for DAP4 functions and the parsing of the same

	Removed unneeded includes; switched to forward class declarations; cleaned up the namespace std stuff (this is a header file so it should not contain 'using namespace std').

	Removed unneeded includes; switched to forward class declarations; cleaned up the namespace std stuff (this is a header file so it should not contain 'using namespace std').

	Removed unneeded includes; switched to forward class declarations; cleaned up the namespace std stuff (this is a header file so it should not contain 'using namespace std').

	Added namespace std:: stuff to the RValue.h file to remove a 'using namespace std' line from a header. Made sure the header did not depend on other code's #includes.

	Added support for the D4Function typedef and DAP4 functions in the ServerFunctionsList class and friends.

2014-03-07  James Gallagher  <jgallagher@opendap.org>

	Merged the trunk code to the dap4 branch

	Removed cruft from HTTPResponse.h

2014-03-05  Nathan Potter  <ndp@opendap.org>

	libdap: Added stylesheet support to D4AsyncUtil along with associated tests

2014-02-28  Nathan Potter  <ndp@opendap.org>

	libdap: Incremental ci for team sync

2014-02-19  Nathan Potter  <ndp@opendap.org>

	libdap: Added D4AsyncUtil (xml document generation)  and DapXmlNamespaces classes. Unit tests for former.

2014-02-05  James Gallagher  <jgallagher@opendap.org>

	Merged a tiny change to SequenceTest from the trunk

	Fixed the SequenceTest 'baseline' regex.
	M    unit-tests/SequenceTest.cc

2014-02-04  James Gallagher  <jgallagher@opendap.org>

	Merged with the trunk on 2/4/14

	Minor changes for OSX 10.9. Also, move tests/ResponseBuilder to D4ResponseBuilder so that the DAP2 function caching test code won't collide with it when I merge the trunk into this branch.

	Unit test updates after the OS upgrade from OSX 10.8 to 10.9. There seems to be an issue with the sizeof(std::string) and also with libxml2 and/or my code to read from a C++ stream and have libxml2 parse text/xml. For now I'm removing these tests... but will return to the libxml2 issue later (the sizeof(std::string) maybe a bad idea since that could be pretty variable between  libstdc++ versions - I might just drop that test).

2014-01-02  James Gallagher  <jgallagher@opendap.org>

	Added

	Added and/or corrected the creation date in the comments.

2013-12-31  James Gallagher  <jgallagher@opendap.org>

	Added test DMRs for/from the vol_1 spec from the CE chapter. (added more of them)

2013-12-30  James Gallagher  <jgallagher@opendap.org>

	Added test DMRs for/from the vol_1 spec from the CE chapter.

2013-12-27  James Gallagher  <jgallagher@opendap.org>

	Added test baseline

	Sequence arrays that hold arrays now work.

	collected hacks that were lost in the system restore made on 12/27/13

2013-12-23  James Gallagher  <jgallagher@opendap.org>

	Added tests for sequences that hold arrays and sequence arrays that hold arrays. Not all pass...

	Added tests for Sequences and arrays of sequences used with various CEs that project various things and/or slice the sequence array. Works. No filters yet.

	Structure arrays that hold arrays can now be constrained as can their fields. With tests.

	CEs that slice arrays that are fields of structures now work.

	Added a note about CEs like "a" when a is a strcuture that contains arrays. The array has to be 'marked' as such. The simple set_send_p code won't do.

	Structures with fields that are arrays now print using the DAP4 syntax

	Added. Simple structures that contain arrays are broken - their print rep is teh DAP2 print rep.

	Added. Structures of arrays that contain arrays segfault at this point.

2013-12-22  James Gallagher  <jgallagher@opendap.org>

	Added support for the 'fields' syntax where a structure s can have some/all of its fields projected using the suntax s{f1;f2;...}. This will provide a way to slice a structure array and  yet ask for a subset of its fields without a confusing syntax. Tests added too.

2013-12-21  James Gallagher  <jgallagher@opendap.org>

	Added test baseline for one of the new CE tests.

	Now shared dimensions are shown in a CDMR only if they are used by a projected (array) var.

2013-12-20  James Gallagher  <jgallagher@opendap.org>

	Structure field projection using the dot operator now works as does slicing of array of structure. Two tests fail; see #2041.

2013-12-08  James Gallagher  <jgallagher@opendap.org>

	Added 5 tests for array slicing CEs

	removed some cruft from the slicing/CE stuff for Arrays. Removed 'local_constriant' state from Array.

	Array and sdim slices now work. No tests.

2013-12-04  James Gallagher  <jgallagher@opendap.org>

	Added (partial) support for sdim slices; See Array::add_constraint() for what needs to be completed.

	Adding stuff to the CE Parser for DAP4 to handle shared dimension slices. ...in progress

2013-12-03  James Gallagher  <jgallagher@opendap.org>

	Added D4CEDriver::slice_dimension() to process shared dimension slices in the modified CE syntax we now have.

2013-12-02  James Gallagher  <jgallagher@opendap.org>

	libdap distcheck works now

	Fixed distcheck issue in d4_ce

	Updated baselines to accommodate new print order for dims, enums, ...

	Reordered the print order of DAP4 stuff in Groups, vars, arrays and Constructors to match what Dennis and I agreed on.

	Changed order of Groups' printing stuff (dims, etc.) and changed TestStr so that it does not change values unless 'series_values' is on.

	Added comment about stack/store BaseTypes and indexes as they are parsed

2013-11-29  James Gallagher  <jgallagher@opendap.org>

	Renamed testall to test_escaped_paths. Does not parse correctly.

	Enumerations are included in the CDMR only if they are used; media types are correct for the dods_data_ddx response (used for responnse caching); The D4 CE parser now clears the d_index vector before starting a new array slicing CE; added a test file (but not a test... see Trac) to check that the Enumerations really are being elided correctly.

	Fixed the content-description values (added dods_data_ddx back in since it's used for the response caching by the bes).

	Makefile,ams now make DMR xmls

	Compile libtest-types using -fPIC for linux now that it's used by a handler (dapreader

	Added include string.h to D4ParserSax2.h for memset on linux

2013-11-28  James Gallagher  <jgallagher@opendap.org>

	All tests work with the new install of D4CEDriver - the interface for the DAP4 CE parser.

	Added D4CEDrvier to the libdap headers that are installed; tweaked the local copy of ResponseBuilder so it more closely matches the code used by teh BES in DapResponseBuilder.

	fixes for AWS (ConetOS6) build

2013-11-27  James Gallagher  <jgallagher@opendap.org>

	Removed FlexLexer.h and hacked Makefile.am to clean the .hh files.
	D    d4_ce/FlexLexer.h
	M    d4_ce/Makefile.am

	initial version of code that suppresses shared dims in the CDMR when a 'local' slicing operator is applied to an array with shared dims. The Array's dims are demoted to anonymous dims.

	local slicing CEs work after a fashion...

	Dennis clarified the spec WRT chunk headers and modified his code. I changed mine back to 1 in bit 2 of the MSB means Little Endian byte order. It all works.

2013-11-26  James Gallagher  <jgallagher@opendap.org>

	Changed the chunked encoding so that bit 2 of the MSB of the chunk is set to indicate big endian hosts. Easy to swap back in the 'set if little endian' logic. Also added code to D4CEDriver to set CEs for Arrays. The serialization of values works but the CDMR is hosed when the Array has shared Dimensions.

	Added basic error response for the case where a variable was not found in the data set.

2013-11-25  James Gallagher  <jgallagher@opendap.org>

	Added mark_variable() method to D4CEDriver; this can be used to shorten the action section of the other projection rules RHS.

	Removed lame ctor from D4CEDriver: only pass an expression in via the parse() method. For the offending ctor, the expression was ignored. There was no need for the extra ctor.

	fixed minor issue with dmr-test: received DMRs should not be printed with 'constrained' set.

	Fixed teh DAP4 CE parser - simple projections now work.

	cleaning up...

	Added -c option to dmr-test - CE evaluation is not yet working.

	dmr-test linked to D4CEDriver - not tested yet

	Integrated d4_ce parsers to the libdap build

	removed @todo comment in chunked_istream.cc

	Added a bytes_in_buffer() method to chunked_istream. This can be used with read_next_chunk to gobble up the remain bytes in the buffer before they are dumped by the read next call.

	chunked io code passes tests.

	checkpoint - more chunkied I/O hacks. Now the byte order flag from only the first chunk is used. The flag is set in all the chunks by the sender.

2013-11-24  James Gallagher  <jgallagher@opendap.org>

	checkpoint - adopting the 'byte order in chunk header' version of the chunked protocol.

2013-11-22  James Gallagher  <jgallagher@opendap.org>

	spelling

	hacked tests and baselines so that the DMR Value element will be parsed (was value - lowercase 'v').

	Fixed value --> Value inthe XML
	M    unit-tests/D4-xml/D4Attributes_1.xml
	M    unit-tests/D4-xml/D4Attributes_2.xml
	M    unit-tests/D4-xml/D4Attributes_3.xml
	M    unit-tests/D4-xml/D4Attributes_assignment.xml
	M    unit-tests/D4-xml/D4Attributes_assignment_2.xml
	M    unit-tests/D4-xml/D4Attributes_copy_ctor.xml
	M    unit-tests/D4-xml/D4Attributes_values_1.xml
	M    unit-tests/D4-xml/D4Group_everything.xml
	M    unit-tests/D4-xml/D4Group_named_with_scalars_and_stuff.xml
	M    unit-tests/D4-xml/D4Group_with_scalars_and_stuff.xml
	M    unit-tests/D4-xml/DMR_0.1.xml
	M    unit-tests/D4-xml/DMR_0.1_baseline.xml
	M    unit-tests/D4-xml/DMR_0.xml
	M    unit-tests/D4-xml/DMR_0_baseline.xml
	M    unit-tests/D4-xml/DMR_1.xml
	M    unit-tests/D4-xml/DMR_2.1.xml
	M    unit-tests/D4-xml/DMR_2.xml
	M    unit-tests/D4-xml/DMR_3.1.xml
	M    unit-tests/D4-xml/DMR_3.1_baseline.xml
	M    unit-tests/D4-xml/DMR_3.2.xml
	M    unit-tests/D4-xml/DMR_3.3.xml
	M    unit-tests/D4-xml/DMR_3.3_baseline.xml
	M    unit-tests/D4-xml/DMR_3.xml
	M    unit-tests/D4-xml/DMR_4.xml
	M    unit-tests/D4-xml/DMR_5.1.xml
	M    unit-tests/D4-xml/DMR_5.1_baseline.xml
	M    unit-tests/D4-xml/DMR_5.xml
	M    unit-tests/D4-xml/DMR_6.1.xml
	M    unit-tests/D4-xml/DMR_6.1_baseline.xml
	M    unit-tests/D4-xml/DMR_6.2.xml
	M    unit-tests/D4-xml/DMR_6.2_baseline.xml
	M    unit-tests/D4-xml/DMR_6.xml
	M    unit-tests/D4-xml/DMR_7.1.xml
	M    unit-tests/D4-xml/DMR_7.2.xml
	M    unit-tests/D4-xml/DMR_7.3.xml
	M    unit-tests/D4-xml/DMR_7.4.xml
	M    unit-tests/D4-xml/DMR_7.5.xml
	M    unit-tests/D4-xml/DMR_7.xml
	M    unit-tests/D4-xml/DMR_8.xml

	value --> Value for the name of the element
	M    dmr-testsuite/test_array_1.xml.trans_base
	M    dmr-testsuite/test_array_10.xml
	M    dmr-testsuite/test_array_10.xml.trans_base
	M    dmr-testsuite/test_array_11.xml
	M    dmr-testsuite/test_array_11.xml.trans_base
	M    dmr-testsuite/test_array_2.xml.trans_base
	M    dmr-testsuite/test_array_3.xml.trans_base
	M    dmr-testsuite/test_array_4.xml.trans_base
	M    dmr-testsuite/test_array_5.xml.trans_base
	M    dmr-testsuite/test_array_6.xml.trans_base
	M    dmr-testsuite/test_array_7.xml.trans_base
	M    dmr-testsuite/test_array_8.xml.trans_base
	M    dmr-testsuite/test_simple_1.xml.trans_base
	M    dmr-testsuite/test_simple_10.xml.trans_base
	M    dmr-testsuite/test_simple_2.xml.trans_base
	M    dmr-testsuite/test_simple_3.xml.trans_base
	M    dmr-testsuite/test_simple_4.xml
	M    dmr-testsuite/test_simple_4.xml.baseline
	M    dmr-testsuite/test_simple_4.xml.send_base
	M    dmr-testsuite/test_simple_4.xml.trans_base
	M    dmr-testsuite/test_simple_5.xml.trans_base
	M    dmr-testsuite/test_simple_6.xml.trans_base
	M    dmr-testsuite/test_simple_7.xml.trans_base
	M    dmr-testsuite/test_simple_8.xml.trans_base
	M    dmr-testsuite/test_simple_9.1.xml.trans_base
	M    dmr-testsuite/test_simple_9.xml.trans_base

2013-11-19  James Gallagher  <jgallagher@opendap.org>

	checkpoint - adding the DAP4 parser. nascent...

2013-11-14  James Gallagher  <jgallagher@opendap.org>

	Removed some old, duplicate code

2013-11-13  James Gallagher  <jgallagher@opendap.org>

	UInt64 array bug fixed

	Tested Enum array support - Works. AUInt64 array test is failing, however.

	Tested Enum array support - Works. AUInt64 array test is failing, however.

	Added support for Arrays of Enum in TestArray.

	Modified Vector so that set_value()/value() can be used with enum arrays. Code has to be savvy about the Enum type, however. In the process, made these methods along with the value(indices, array) methods templates with explicit instantiation.

	checkpoint on the way to enum arrays

	Added a first crack at templated value() method for Vector.cc.

2013-11-12  James Gallagher  <jgallagher@opendap.org>

	Fixed issues in D4Connect related to media types; Added media_types.h; Added tests (pretty limited) for Char; Added parser support for arrays of Enum; added print_dap4() support for arrays of Enum (but the arrays still don't work, only the DMR stuff works).

	Added support for Char; other tests broke as I twidled code for the content type mess. Char untested.

2013-11-11  James Gallagher  <jgallagher@opendap.org>

	Minor fix for the DAP4 media types

2013-11-10  James Gallagher  <jgallagher@opendap.org>

	Client code looks for Content-Type; does not seem to be returned by the OLFS or there's an error in reading the CT header value from curl's internal goo.

	Added client support for the data response (D4Connect and getdap4).

2013-11-08  James Gallagher  <jgallagher@opendap.org>

	There appears to be no Content-Type or Content-Description header in the response document - I hacked D4Connect to decode a 'no type' response as a DMR when request_dmr() is called, for now.

	getdap4 reads DMRs from a server, builds binary DMR objects and prints them out.

	Fixed bug in getdap4 that prevented it from reading from stdin

2013-11-07  James Gallagher  <jgallagher@opendap.org>

	Repaired the mime types errors - now DDX is refferred to as 'dods-ddx' and 'dods-data-ddx' while the dap4 things are dap4-dmr and dap4-data. The multipart code is still in mime_util.cc since it's being used by the function value cache hack, but that could be changed to use the DAP4 responses.

2013-11-05  James Gallagher  <jgallagher@opendap.org>

	Minor formatting changes

2013-10-30  James Gallagher  <jgallagher@opendap.org>

	Errors fixed from machine at home. D4StreamUnMarshaller didn't include dods-datatypes.h; getdap4 call to usage() is ambiguous (not fixed).

2013-10-29  James Gallagher  <jgallagher@opendap.org>

	Get DMR from a file is broken; seg fault.

	Added (untested) support for reading a dmr from a file...

	Added a basic client to libdap for DAP4 - reads DAP4 data response documents from local files only at this point.

	Added a basic client to libdap for DAP4 - reads DAP4 data response documents from local files only at this point.

2013-10-28  James Gallagher  <jgallagher@opendap.org>

	Added new D4Connect class - a work in progress.

2013-10-25  James Gallagher  <jgallagher@opendap.org>

	svn:ignore update

	Added getdap test baseline

	Added a simple test for getdap and generally looked at different ways to write a DAP4 CLI client. Fixed some comment errors along the way...

2013-10-24  James Gallagher  <jgallagher@opendap.org>

	All tests now pass for array projections for server function arguments.

	tests pass for array projections in function arg lists

	Fixed an obscure bug in the test function - for the scalar case it was not reading the arg's value.

2013-10-23  James Gallagher  <jgallagher@opendap.org>

	missed one baseline for the function stuff...

	Added support for array subsetting (projection) in the argument list of a function. Tests need work and there's an issue when the function arg is a scalar not an array. Also, the intern_data() methods don't work, but this may be a larger issue with the hack to the function evaluation scheme added for 'grads syntax' support.

	Opaque arrays now work - they are stored using BaseType pointers (like the constructor types) instead of as a C array of vector<uint8_t>, so they are not optimized. Overhead will be high for large arrays of Opaque, but how often will that happen?

2013-10-22  James Gallagher  <jgallagher@opendap.org>

	D4Opaque::print_val() now works; tests added

	All tests pass - Enums in decent shape.

	Maps and Enums, when referenced should use FQNs. Now the DMR prints this way even though my parser tolerates relative names.

	Error baselines updated
	M    tests/dmr-testsuite/test_simple_3_error_3.xml.baseline
	M    tests/dmr-testsuite/test_simple_3_error_1.xml.baseline
	M    tests/dmr-testsuite/test_simple_3_error_2.xml.baseline

2013-10-21  James Gallagher  <jgallagher@opendap.org>

	More Enum fixes

	More enum tests

	Fix to checksum() for D4Enum - must use just the part of d_buf that matches the type in the enumeration definition.

	Test file added - Both Enum and Opaque need work to pass their tests.

	D4Enum seems to work - dmr-test returns valid stuff.

	Opaque minor fixes and tests added via D4ParserSAX2 unit tests

	Added TestOpaque

	D4Opaque added - no tests yet, but the code builds

2013-10-21  Joe Lee  <hyoklee@hdfgroup.org>

	fixed the bug #2016.

2013-10-21  James Gallagher  <jgallagher@opendap.org>

	Add D4Opaque... checkpoint; not working yet

2013-10-19  James Gallagher  <jgallagher@opendap.org>

	Added tests for Enum

	All tests pass - might look into D4Enum ctors and/or asserts to make sure that both the element type and enum def pointer are set before different kinds of operations. NB: The enum def is needed to print and for some value accesses, but not for reading/writing numeric values.

	Enums close to working - one test in D4AttributesTest fails

	Added test class for D4Enum and set the stage for building valid D4Enums in the DMR parser - it will have to find the matching Enumeration definition in an enclosing group and record that, along with the base type for the enum.

2013-10-18  James Gallagher  <jgallagher@opendap.org>

	Checkpoint - working on Enum's ctor

	Checkpoint - working on Enum's ctor

	Hyrax 1.9.1
	M    configure.ac
	M    ChangeLog
	M    main_page.doxygen
	M    INSTALL
	M    libdap.spec
	M    README
	M    NEWS
	M    doxy.conf

	svn:ignore

2013-10-17  James Gallagher  <jgallagher@opendap.org>

	Manually patched changes to Sequence::read_row and TestSequence::read() from the DAP4 development branch so they work with the newly modified handlers (the DAP4 branch uses _trunk_ copies of the handlers). We will have to document this change before releasing the code!
	M    tests/TestSequence.cc
	M    Sequence.cc

	Added to svn:ignore

	Enums now work (but not arrays of Enums). BaseType::width(bool = false) is now a const method and Array::width() is no more (it didn't do anything that Vector::width() didn't do with fewer lines of code).

	Added D4Maps::operator=()

2013-10-16  James Gallagher  <jgallagher@opendap.org>

	Added support for Map - in the parser, Array and in unit tests. Needs better semantic checks, but first those have to be clarified...

	Added to svn:ignore

	Linux (centos 6.4) changes
	M    chunked_istream.h
	M    chunked_ostream.cc
	M    tests/dmr-test.cc
	M    chunked_istream.cc
	M    unit-tests/chunked_iostream_test.cc
	M    unit-tests/D4ParserSax2Test.cc

	Added to svn:ignore

	Merge from the trunk; this mostly involves a massive-looking change that's really only an edit to the FSF address in the copyright block (and thus just about every cc or h file). But it's only an edit to a comment. Also, I updated the gnulib code because I thought there was an issue there WRT byteswap.h and the distcheck build. Not the case, but the update was not a bad idea all the same. Lastly, some issues crept into new unit-tests that broke distcheck and those have been resolved. The distcheck target now works.
	_M   .
	M    ServerFunctionsList.cc
	M    ServerFunctionsList.h
	M    RValue.cc
	M    DODSFilter.cc
	M    XMLWriter.h
	M    HTTPResponse.h
	M    D4Dimensions.cc
	M    Int32.h
	M    Int16.cc
	M    Structure.h
	M    gridfields_functions.h
	M    error-test.cc
	M    AISResources.cc
	M    Str.h
	M    Sequence.h
	M    SignalHandler.cc
	M    ResponseTooBigErr.cc
	M    SignalHandler.h
	M    ResponseTooBigErr.h
	M    configure.ac
	M    XDRUtils.h
	M    ResponseCache.h
	M    debug.h
	M    UInt64.cc
	M    XDRStreamUnMarshaller.h
	M    Connect.h
	M    escaping.h
	M    fdiostream.cc
	M    D4EnumDefs.h
	M    gridfields_functions.cc
	M    ResponseBuilder.h
	M    DAPCache3.cc
	M    DAPCache3.h
	M    D4ParserSax2.cc
	M    DDXExceptions.h
	M    VCPP/sample/getdap.cc
	M    Keywords2.cc
	M    Resource.h
	M    Error.cc
	M    HTTPCacheDisconnectedMode.h
	M    XMLWriter.cc
	M    UnMarshaller.h
	M    Response.h
	_M   conf
	M    conf/snippet/c++defs.h
	M    conf/snippet/warn-on-use.h
	M    conf/snippet/arg-nonnull.h
	A  + conf/config.rpath
	M    Int16.h
	M    SignalHandlerRegisteredErr.h
	M    ConstraintEvaluator.cc
	M    DAS.h
	M    XDRFileMarshaller.h
	M    DDS.cc
	M    HTTPCacheTable.cc
	M    HTTPCacheTable.h
	M    D4ParseError.h
	M    BaseType.h
	M    Array.cc
	M    tests/TestInt16.h
	M    tests/TestUrl.h
	M    tests/TestArray.cc
	M    tests/TestFloat64.cc
	M    tests/TestFloat64.h
	M    tests/das-test.cc
	M    tests/TestUInt32.cc
	M    tests/TestGrid.cc
	M    tests/TestUInt16.cc
	M    tests/TestCommon.h
	M    tests/TestByte.cc
	M    tests/TestByte.h
	M    tests/ResponseBuilder.h
	M    tests/TestTypeFactory.h
	M    tests/TestArray.h
	M    tests/TestUInt16.h
	M    tests/TestInt32.cc
	M    tests/TestInt16.cc
	M    tests/TestInt32.h
	M    tests/TestStructure.h
	M    tests/TestFloat32.cc
	M    tests/TestSequence.h
	M    tests/TestStr.h
	M    tests/TestGrid.h
	M    tests/expr-test.cc
	M    tests/TestStructure.cc
	M    tests/TestUrl.cc
	M    tests/ResponseBuilder.cc
	M    tests/TestSequence.cc
	M    tests/TestStr.cc
	M    tests/TestTypeFactory.cc
	M    tests/TestFloat32.h
	M    tests/TestUInt32.h
	M    tests/dds-test.cc
	M    HTTPCacheInterruptHandler.h
	M    EventHandler.h
	M    Float64.h
	M    D4ParserSax2.h
	M    AISConnect.cc
	M    UInt16.cc
	M    InternalErr.h
	M    EncodingType.h
	M    DDXParserSAX2.cc
	M    UInt64.h
	M    AlarmHandler.h
	M    Marshaller.h
	M    Byte.cc
	M    Byte.h
	M    GNU/GetOpt.cc
	M    GNU/GNURegex.cc
	M    GNU/GNURegex.h
	M    ResponseBuilder.cc
	M    DataDDS.h
	M    DDS.h
	M    BaseType.cc
	M    XDRUtils.cc
	M    win32/gl/mbchar.h
	M    win32/gl/mbuiter.h
	M    win32/gl/mbchar.c
	M    ServerFunction.h
	M    HTTPCacheResponse.h
	M    Makefile.am
	M    RCReader.cc
	M    Constructor.h
	M    util_mit.h
	M    Keywords2.h
	M    Error.h
	M    DDXParserSAX2.h
	M    D4EnumDefs.cc
	M    Int32.cc
	M    DapObj.h
	M    DODSFilter.h
	M    HTTPCache.cc
	M    DataDDS.cc
	M    HTTPCache.h
	M    parser-util.cc
	M    DapIndent.h
	M    AISResources.h
	M    Float32.cc
	M    ObjectType.h
	M    ServerFunction.cc
	M    PipeResponse.h
	M    util.h
	M    AISExceptions.h
	M    AISDatabaseParser.h
	M    AttrTable.cc
	M    InternalErr.cc
	MM   mime_util.h
	M    Grid.h
	M    XDRStreamUnMarshaller.cc
	M    HTTPConnect.cc
	M    D4BaseTypeFactory.h
	M    AISMerge.h
	M    RValue.h
	M    Structure.cc
	M    Url.cc
	M    Vector.cc
	M    getdap.cc
	M    Int64.h
	M    BaseTypeFactory.h
	M    Str.cc
	M    Sequence.cc
	M    XDRFileUnMarshaller.cc
	M    Float32.h
	M    XDRFileUnMarshaller.h
	_M   gl
	A  + gl/glthread
	M    expr.h
	M    Int8.cc
	M    AttrTable.h
	MM   mime_util.cc
	M    Constructor.cc
	M    UInt32.h
	M    XDRStreamMarshaller.h
	M    AISMerge.cc
	M    D4BaseTypeFactory.cc
	M    parser.h
	M    Url.h
	M    Int64.cc
	M    BaseTypeFactory.cc
	M    Vector.h
	M    DAS.cc
	M    ConstraintEvaluator.h
	M    util.cc
	M    Clause.h
	M    Float64.cc
	M    Ancillary.h
	M    Operators.h
	M    Int8.h
	M    UInt32.cc
	M    XDRStreamMarshaller.cc
	M    Grid.cc
	M    util_mit.cc
	M    D4Maps.cc
	M    Connect.cc
	M    escaping.cc
	M    dods-limits.h
	M    HTTPConnect.h
	M    unit-tests/AISMergeTest.cc
	D    unit-tests/test_small_text_file.txt
	M    unit-tests/DASTest.cc
	M    unit-tests/ThreadTest.cc
	D    unit-tests/test_big_binary_file_2.bin
	D    unit-tests/test_big_binary_file_3.bin
	M    unit-tests/DDSTest.cc
	R  + unit-tests/test_config.h.in
	D    unit-tests/test_text_file.txt
	M    unit-tests/ArrayTest.cc
	M    unit-tests/chunked_iostream_test.cc
	D    unit-tests/test_big_binary_file.bin
	D    unit-tests/test_scalars_1.dat
	D    unit-tests/test_scalars_2.dat
	M    unit-tests/ByteTest.cc
	M    unit-tests/ResponseBuilderTest.cc
	M    unit-tests/AISDatabaseParserTest.cc
	M    unit-tests/ResponseCacheTest.cc
	D    unit-tests/test_opaque_1_bin.dat
	M    unit-tests/D4UnMarshallerTest.cc
	M    unit-tests/RCReaderTest.cc
	M    unit-tests/D4EnumDefsTest.cc
	M    unit-tests/DODSFilterTest.cc
	M    unit-tests/D4DimensionsTest.cc
	D    unit-tests/test_cmp.dat
	M    unit-tests/HTTPCacheTest.cc
	M    unit-tests/AISResourcesTest.cc
	M    unit-tests/SignalHandlerTest.cc
	A    unit-tests/D4-marshaller
	A  + unit-tests/D4-marshaller/test_scalars_2.dat
	A  + unit-tests/D4-marshaller/test_opaque_1_bin.dat.sav
	A  + unit-tests/D4-marshaller/test_vector_1_bin.dat
	A  + unit-tests/D4-marshaller/test_vector_2_bin.dat
	A  + unit-tests/D4-marshaller/test_cmp.dat
	A  + unit-tests/D4-marshaller/test_scalars_1_bin.dat
	A  + unit-tests/D4-marshaller/test_scalars_2_bin.dat
	A  + unit-tests/D4-marshaller/test_opaque_1_bin.dat
	A  + unit-tests/D4-marshaller/test_scalars_3_bin.dat
	A  + unit-tests/D4-marshaller/test_scalars_1.dat
	D    unit-tests/test_opaque_1_bin.dat.sav
	M    unit-tests/AttrTableTest.cc
	M    unit-tests/ancT.cc
	MM   unit-tests/MIMEUtilTest.cc
	M    unit-tests/HTTPConnectTest.cc
	M    unit-tests/ServerFunctionsListUnitTest.cc
	M    unit-tests/DDXParserTest.cc
	D    unit-tests/test_vector_1_bin.dat
	D    unit-tests/test_vector_2_bin.dat
	MM   unit-tests/fdiostreamTest.cc
	A    unit-tests/chunked-io
	A  + unit-tests/chunked-io/test_text_file.txt
	A  + unit-tests/chunked-io/test_small_text_file.txt
	A  + unit-tests/chunked-io/test_big_binary_file.bin
	A  + unit-tests/chunked-io/test_big_binary_file_2.bin
	A  + unit-tests/chunked-io/test_big_binary_file_3.bin
	M    unit-tests/SequenceTest.cc
	M    unit-tests/RegexTest.cc
	M    unit-tests/generalUtilTest.cc
	D    unit-tests/test_scalars_1_bin.dat
	M    unit-tests/D4MarshallerTest.cc
	D    unit-tests/test_scalars_2_bin.dat
	D    unit-tests/test_scalars_3_bin.dat
	M    unit-tests/Makefile.am
	M    unit-tests/Keywords2Test.cc
	M    unit-tests/parserUtilTest.cc
	MM   fdiostream.h
	M    StdinResponse.h
	M    DapIndent.cc
	M    XDRFileMarshaller.cc
	M    Clause.cc
	M    AISDatabaseParser.cc
	M    Array.h
	M    ResponseCache.cc
	M    AISConnect.h
	M    UInt16.h
	M    ce_expr.lex
	M    RCReader.h

2013-10-15  James Gallagher  <jgallagher@opendap.org>

	Added
	_M   gl
	A  + gl/m4/lib-link.m4
	A  + gl/m4/lock.m4
	A  + gl/m4/lib-prefix.m4
	A  + gl/m4/lib-ld.m4
	A  + gl/m4/eealloc.m4
	A  + gl/m4/extern-inline.m4
	A  + gl/m4/threadlib.m4
	A  + gl/wctype-h.c
	A  + gl/unistd.c

	Added
	A    gl/glthread
	A    gl/glthread/threadlib.c
	A    gl/glthread/lock.c
	A    gl/glthread/lock.h

	Added
	AM   config.rpath

	gl partial commit so I can merge again and pick up some missing files

	Added to gl
	A    gl/m4/lib-link.m4
	A    gl/m4/lock.m4
	A    gl/m4/lib-prefix.m4
	A    gl/m4/lib-ld.m4
	A    gl/m4/eealloc.m4
	A    gl/m4/extern-inline.m4
	A    gl/m4/threadlib.m4
	A    gl/wctype-h.c
	A    gl/unistd.c

	Updated gnulib.
	M    XMLWriter.cc
	M    conf/snippet/c++defs.h
	M    conf/snippet/warn-on-use.h
	M    conf/snippet/arg-nonnull.h
	M    Byte.h
	M    XDRUtils.cc
	M    ServerFunction.cc
	M    Url.cc
	M    XDRFileUnMarshaller.cc
	M    gl/m4/fcntl-o.m4
	M    gl/m4/configmake.m4
	M    gl/m4/localcharset.m4
	M    gl/m4/locale_h.m4
	M    gl/m4/sys_types_h.m4
	M    gl/m4/mbrtowc.m4
	M    gl/m4/btowc.m4
	M    gl/m4/longlong.m4
	M    gl/m4/00gnulib.m4
	M    gl/m4/ssize_t.m4
	M    gl/m4/glibc21.m4
	M    gl/m4/localeconv.m4
	M    gl/m4/codeset.m4
	M    gl/m4/alloca.m4
	M    gl/m4/off_t.m4
	M    gl/m4/locale-fr.m4
	M    gl/m4/langinfo_h.m4
	M    gl/m4/wint_t.m4
	M    gl/m4/mbsinit.m4
	M    gl/m4/stdint.m4
	M    gl/m4/gnulib-common.m4
	M    gl/m4/stdbool.m4
	M    gl/m4/malloc.m4
	M    gl/m4/regex.m4
	M    gl/m4/warn-on-use.m4
	M    gl/m4/wchar_h.m4
	M    gl/m4/gnulib-comp.m4
	M    gl/m4/unistd_h.m4
	M    gl/m4/wcrtomb.m4
	M    gl/m4/locale-zh.m4
	M    gl/m4/stddef_h.m4
	M    gl/m4/gnulib-cache.m4
	M    gl/m4/include_next.m4
	M    gl/m4/mbstate_t.m4
	M    gl/m4/wctype_h.m4
	M    gl/m4/nl_langinfo.m4
	M    gl/m4/locale-ja.m4
	M    gl/m4/wchar_t.m4
	M    gl/m4/multiarch.m4
	M    gl/m4/stdlib_h.m4
	M    gl/m4/mbtowc.m4
	M    gl/m4/gnulib-tool.m4
	M    gl/m4/byteswap.m4
	M    gl/m4/extensions.m4
	M    gl/localcharset.c
	M    gl/mbsinit.c
	M    gl/regex_internal.c
	M    gl/malloc.c
	M    gl/byteswap.in.h
	M    gl/localcharset.h
	M    gl/locale.in.h
	M    gl/regex_internal.h
	M    gl/sys_types.in.h
	M    gl/wcrtomb.c
	M    gl/btowc.c
	M    gl/regexec.c
	M    gl/ref-del.sin
	M    gl/mbtowc.c
	M    gl/regcomp.c
	M    gl/mbtowc-impl.h
	M    gl/streq.h
	M    gl/alloca.in.h
	M    gl/langinfo.in.h
	M    gl/ref-add.sin
	M    gl/verify.h
	M    gl/regex.c
	M    gl/config.charset
	M    gl/mbrtowc.c
	M    gl/wchar.in.h
	M    gl/regex.h
	M    gl/stdint.in.h
	M    gl/stdbool.in.h
	M    gl/unistd.in.h
	M    gl/stddef.in.h
	M    gl/localeconv.c
	M    gl/wctype.in.h
	M    gl/nl_langinfo.c
	M    gl/Makefile.am
	M    gl/gettext.h
	M    gl/stdlib.in.h
	M    BaseTypeFactory.cc
	M    XDRStreamMarshaller.cc
	M    escaping.cc
	M    DapIndent.cc
	M    XDRFileMarshaller.cc

	modified configure so that dap4 is enabled by default - this fixes (some but not all) issues with distcheck

	Added compute_checksum() to BaseType and children. Added intern_data() so that the CRC attribute is added to the interned variables. The same baselines for RT transmission tests work with the intern_data tests (including the checksums).

2013-10-14  James Gallagher  <jgallagher@opendap.org>

	Checkpoint - Arrays or Sequences implemented and libdap tests pass; check handlers.

	Array of Sequence tests pass

	D4Sequences work, along with tests and some sembelance of rationale behavior by the read() and read_next_instnace() methods.

	Removed call to read() in D4Group::serialize(). Let the variable's serialize() methods call read() so that constructor types will not break the semantics of the D4Sequence::read() method and so that variable's data lifetime can be controlled more (i.e., only reading in data right before it's needed and freeing it right after it's sent to minimize the memory requirements when lots of data are sent).

2013-10-13  James Gallagher  <jgallagher@opendap.org>

	D4Sequence debugging: for some reason D4Sequence::read is called twice for the first instance and that leads to an off-by-one error in the count of elements since the very first element is never saved and thus not sent. E.G., tehe count will be 4 but there are only three instances sent.

	The Parser now recognizes Sequence.

	Added more of D4Sequence... the parser is still not right...

2013-10-11  James Gallagher  <jgallagher@opendap.org>

	Checkpoint - normalized ::read() and all of the handler tests work too.

2013-10-10  James Gallagher  <jgallagher@opendap.org>

	Checkpoint for the D4Sequence code

2013-10-09  James Gallagher  <jgallagher@opendap.org>

	Added D4Sequence and TestD4Sequence. Also foud the smallest number of files to change and arrive at uniform semantics for BaseType::read(). Now when read() returns true all the data have been read and when it returns false some data were not read. Not sure how this will work for Arrays and streaming data, but at least libdap uses it uniformly. Handlers may need tweaks.

	cleanup/formatting

	cleanup/formatting

	Arrays of Structure work and have regression tests - well, a test.

	Added unit test for Array of Structure parse

	Arrays of Structures parse.

2013-10-08  James Gallagher  <jgallagher@opendap.org>

	checkpoint: debugging arrays of structure. See Vector:: prototype(), D4ParserSax2 Constructor and DMR_7.4.xml.

	...working on Array of Structure

	...working on Array of Structure

	Added tests for the DAP4 integer types

	Removed some instrumentation that made it's way into svn

	Added tests for roundtrip transmission.
	M    tests/DMRTest.at
	A    tests/dmr-testsuite/test_array_5.xml.trans_base
	A    tests/dmr-testsuite/test_simple_1.xml.trans_base
	A    tests/dmr-testsuite/test_simple_3.xml.trans_base
	A    tests/dmr-testsuite/test_simple_5.xml.trans_base
	A    tests/dmr-testsuite/test_array_2.xml.trans_base
	A    tests/dmr-testsuite/test_array_4.xml.trans_base
	A    tests/dmr-testsuite/test_simple_2.xml.trans_base
	A    tests/dmr-testsuite/test_simple_4.xml.trans_base
	A    tests/dmr-testsuite/test_array_1.xml.trans_base
	A    tests/dmr-testsuite/test_array_3.xml.trans_base

	Added binary Data DMR response baselines
	AM   dmr-testsuite/test_array_3_data.bin
	AM   dmr-testsuite/test_array_5_data.bin
	AM   dmr-testsuite/test_simple_1_data.bin
	AM   dmr-testsuite/test_simple_3_data.bin
	AM   dmr-testsuite/test_simple_5_data.bin
	AM   dmr-testsuite/test_array_2_data.bin
	AM   dmr-testsuite/test_array_4_data.bin
	AM   dmr-testsuite/test_simple_2_data.bin
	AM   dmr-testsuite/test_simple_4_data.bin

	Updated baselines and the DMR test driver
	M    tests/DMRTest.at
	M    tests/dmr-testsuite/test_array_2.xml.send_base
	M    tests/dmr-testsuite/test_array_3.xml.send_base
	M    tests/dmr-testsuite/test_array_4.xml.send_base
	M    tests/dmr-testsuite/test_array_5.xml.send_base
	M    tests/dmr-testsuite/test_simple_2.xml.baseline
	M    tests/dmr-testsuite/test_simple_4.xml.baseline
	M    tests/dmr-testsuite/test_array_1_data.bin
	M    tests/dmr-testsuite/test_simple_1.xml
	M    tests/dmr-testsuite/test_simple_2.xml
	M    tests/dmr-testsuite/test_simple_3.xml
	M    tests/dmr-testsuite/test_simple_4.xml
	M    tests/dmr-testsuite/test_simple_5.xml
	M    tests/dmr-testsuite/test_array_5.xml.baseline
	M    tests/dmr-testsuite/test_simple_1.xml.baseline
	M    tests/dmr-testsuite/test_simple_1.xml.send_base
	M    tests/dmr-testsuite/test_simple_3.xml.baseline
	M    tests/dmr-testsuite/test_simple_2.xml.send_base
	M    tests/dmr-testsuite/test_simple_3.xml.send_base
	M    tests/dmr-testsuite/test_simple_4.xml.send_base
	M    tests/dmr-testsuite/test_simple_5.xml.baseline
	M    tests/dmr-testsuite/test_simple_5.xml.send_base
	M    tests/dmr-testsuite/test_array_5.xml
	M    tests/dmr-testsuite/test_array_1.xml.send_base
	M    tests/io_test.cc

	DMRTest now on svn:ignore

	Added baselines for the DMR regression tests.
	A    dmr-testsuite/test_array_2.xml.send_base
	A    dmr-testsuite/test_array_3.xml.send_base
	A    dmr-testsuite/test_array_4.xml.baseline
	A    dmr-testsuite/test_array_4.xml.send_base
	A    dmr-testsuite/test_array_5.xml.send_base
	A    dmr-testsuite/test_simple_3_error_1.xml.baseline
	A    dmr-testsuite/test_simple_3_error_3.xml.baseline
	A    dmr-testsuite/test_simple_2.xml.baseline
	A    dmr-testsuite/test_simple_4.xml.baseline
	AM   dmr-testsuite/test_array_1_data.bin
	A    dmr-testsuite/test_array_1.xml.baseline
	A    dmr-testsuite/test_array_3.xml.baseline
	A    dmr-testsuite/test_array_5.xml.baseline
	A    dmr-testsuite/test_simple_3_error_2.xml.baseline
	A    dmr-testsuite/test_simple_1.xml.baseline
	A    dmr-testsuite/test_simple_1.xml.send_base
	A    dmr-testsuite/test_simple_3.xml.baseline
	A    dmr-testsuite/test_simple_2.xml.send_base
	A    dmr-testsuite/test_simple_3.xml.send_base
	A    dmr-testsuite/test_simple_5.xml.baseline
	A    dmr-testsuite/test_simple_4.xml.send_base
	A    dmr-testsuite/test_simple_5.xml.send_base
	A    dmr-testsuite/test_array_1.xml.send_base
	A    dmr-testsuite/test_array_2.xml.baseline

	DMR tests - first stab at regression tests for the DMR code.

	Added a test for the DMR (DAP4 int types)

	Arrays of Int8, UInt8, Int64, UInt64 all work. All tests pass. Some major reworking of the Test classes to use templates. D4(Un)Marshaller test code fixed to match the edits to those classes based on recent changes to the binary doc spec. Test baselines updated.

2013-10-04  James Gallagher  <jgallagher@opendap.org>

	Fixed up the Marshallers for DAP4 - No more XDR unless a compile-time switch is defined. The code assumes IEEE754 reals

	Bug in integer type serialization fixed; Marshaller code made faster; removed most specail case code for platforms that don't use IEEE754.

	test updates

2013-10-03  James Gallagher  <jgallagher@opendap.org>

	Added more thorough unit tests for arrays - Enums and structures are still broken.

	Added a unit test for array stuff.

	Added support for Arrays of the DAP2 types that have been carried over to DAP4. Some testing of the parser; tests to follow in a subsequent commit.

2013-10-01  James Gallagher  <jgallagher@opendap.org>

	Switched to the print order Dennis uses.

	Updated the FSF address in the copyright headers

	Merge from the trunk: This includes all of the changes made for the H 1.9 release and the change to width(). The code builds and has minimal warnings.

2013-09-30  James Gallagher  <jgallagher@opendap.org>

	This checkin contains a fix for the conflicting definitions of width() in BaseType, Vector and Array, where Array provided a version/definition that clashes with the one in BaseType. BaseType defined width() and Array defined width(bool constrained = true), which shadowed the former. I changed BaseType width so that its signature is width(bool constrained = false) and made that the only version of the method. There are some changes to uses of width() in libdap and the BES, but not in the handlers.

2013-09-27  James Gallagher  <jgallagher@opendap.org>

	misc changes; a minor fix for Array; a fix for the DDX parser; A minor change in the scanners for the Error, DAS, DDS and CE parsers (added %option noinput to suppress a warning); removed -fno-defer-pop from the Makefile.ams.

2013-09-23  James Gallagher  <jgallagher@opendap.org>

	Turned on checksums in D4Group - I had the algorithm correct. dmr-test worked but more testing is going to be needed.

2013-09-20  James Gallagher  <jgallagher@opendap.org>

	Fixed byte order change in dmr-test - it seems to work now

	chunked i/ostream complete. dmr-test and expr-test are failing (expr-test fails soem tests, dmr-test seg faults).

2013-09-19  James Gallagher  <jgallagher@opendap.org>

	xsgetn works, errors and all, most of TODOs have been done.

	All tests now pass

	Removed putBack option/feature since it'll never be used and to support it we need a call to memcopy for every chunk read.

	checkpoint: chunked istream xsgetn() is close to working - only the error case fails the unit tests. The code is pretty hacked up, though.

2013-09-18  James Gallagher  <jgallagher@opendap.org>

	added big_file_2 tests

	more work on the chunked strream io code

2013-09-17  James Gallagher  <jgallagher@opendap.org>

	Added the data files for the chunked iostream tests; ignored result files

	Check point - mostly for the chunk iostream unit test.

	I changed the character used for the Type special form (from # to $, because # is a URL delim. and tomcat was filtering it).

	Fixed svn ignores...

	chunked_istream now takes byte-order info that it uses to correct the chunk header size and type to the host.

	Turned off some debugging code in D4StreamMarshaller and chunked_ostream. ResponseBuilder now uses byte order correctly and dmr-test's read code passes the value into D4StreamUnMarshaller.

	Improved D4 Sax Parser by making char* and string docs parse in two calls instead of using an io stream.

2013-09-16  James Gallagher  <jgallagher@opendap.org>

	checkpoint - unit testing for chunking iostream

	Added - has en embedded CRLF separator as with the data DMR response docs.

	Parser & response fixes

2013-09-13  James Gallagher  <jgallagher@opendap.org>

	More testing for the chunked response - looks like its now working correctly with the dmr-test code.

	Chunking for DAP4 implemented. Needs automated tests and a round of optimization.

2013-09-12  James Gallagher  <jgallagher@opendap.org>

	Added initial version of chunked_ostream. Added changes to the tests directory (and in libdap) to support round-trip serialization of DAP4 variables. ...work in progress

2013-09-09  James Gallagher  <jgallagher@opendap.org>

	Dap4 deserialize close to working.

	DAP4 Responses with checksums now work.

2013-09-06  James Gallagher  <jgallagher@opendap.org>

	Added Test classes for some of the DAP4 types.

	serialize() partly working - CRC32 checksums missing.

2013-09-05  James Gallagher  <jgallagher@opendap.org>

	Merged changes from the trunk made in preparation for the Hyrax 1.9 release. Updated the print rep of the DDS (aka DMR) to match Dennis' form. Fixed the display of Array Dim elements so that Dim names are fully qualified.

2013-09-04  James Gallagher  <jgallagher@opendap.org>

	Removed EVAL from configure.ac; only Sequence (dap2) and Vector/Array (dap4) will ever use that code.

	Arrays of atomic types parse and the resulting DDS can print the DMR.

2013-08-28  James Gallagher  <jgallagher@opendap.org>

	Build/Audit fixes.
	M    libdap/XDRFileUnMarshaller.cc
	M    libdap/XDRFileUnMarshaller.h
	M    bes/dispatch/unit-tests/keysT.cc
	M    bes/functions/Makefile.am

2013-08-27  James Gallagher  <jgallagher@opendap.org>

	Backed out an errant call to fclose()

	Removed errant call to fclose() in XDRFileUnMarshaller. This caused a segfault on Linux.

	audit fixes
	M    libdap/Makefile.am
	M    bes/dispatch/unit-tests/BESCache3Test.cc
	M    bes/functions/tests/functionsTest.at
	M    bes/functions/tests/bescmd/bind_name_4.dods.bescmd.baseline
	M    bes/functions/tests/bescmd/bind_name_2.dods.bescmd.baseline

	Source release info
	M    configure.ac
	M    ChangeLog
	M    INSTALL
	M    README
	M    NEWS

	Audit fixes.
	M    RValue.cc
	M    HTTPCacheTable.cc
	M    Array.cc
	M    DDXParserSAX2.cc
	M    Makefile.am
	M    HTTPCache.cc
	M    XDRStreamUnMarshaller.cc
	M    Structure.cc
	M    Sequence.cc
	M    XDRFileUnMarshaller.cc
	M    XDRFileUnMarshaller.h
	M    mime_util.cc
	M    util.cc
	M    util_mit.cc

	Changed the required bison version number to 2.4 and removed a bogus include from das.yy that breaks bison 2.4.
	M    das.yy
	M    Error.yy
	M    dds.yy
	M    ce_expr.yy

	Removed bad character from the Makefile.am
	M    Makefile.am

	Added the newly hacked grammar files - these along with updated versions of DAS.cc, DDS.cc, ConstraintEvaluator.cc and Error.cc and Makefile.am were copied over from the dap4 branch. A kind of cheap merge operation...
	A    das.yy
	A    Error.yy
	A    dds.yy
	A    ce_expr.yy

2013-08-26  James Gallagher  <jgallagher@opendap.org>

	Chnages so that a newer bison can be used.
	M    Error.lex
	M    Error.cc
	M    ce_parser.h
	M    ConstraintEvaluator.cc
	M    DDS.cc
	M    Makefile.am
	M    dds.lex
	M    Vector.cc
	M    das.lex
	M    Vector.h
	M    DAS.cc
	M    ce_expr.lex

2013-08-22  James Gallagher  <jgallagher@opendap.org>

	Added tests for teh Enum type class.

	Added tests and baselines for Array.

	Support for arrays of cardinal types (excluding Enum). Both named and anonymous dimensions are supported.

2013-08-16  James Gallagher  <jgallagher@opendap.org>

	Fiddled with the URL type (which is called Url in DAP2 and URL in DAP4 - ARRGH). It now seems to work OK since all tests are passing again.

2013-08-15  James Gallagher  <jgallagher@opendap.org>

	Added support for the DAP4 types Int8, UInt8, Int64 and UInt64 to Vector. Along the way I made some more fixes to teh ce_expr.yy and Error.yy parsers and fixed an issue with the BaseTypeFactory class. This code builds, passes its tests and the BES and all of the handlers also build and pass tests when using it.

2013-08-14  James Gallagher  <jgallagher@opendap.org>

	Added %requires "2.5" to all the bison parser sources. Fixed a missing filed initialization in D4ParserSax2.h

	much cleaner use of bison and flex - but this code requires a newer version of bison (2.5)

	Adapted parsers to the new bison 3.0 - all tests pass.

2013-08-13  James Gallagher  <jgallagher@opendap.org>

	TODO Comment done and removed

	spelling and more ignores for generated files.

2013-08-12  James Gallagher  <jgallagher@opendap.org>

	The scanner now does not use the default rule. Better processing of errors for the parser.

	ignore exec in d4_ce

	Hmmm... Something odd happened qith the conf dir getting moved by an accidental mouse click...

	Modified the DAP4 CE parser so that it's scanner won't clash with other scanners by using a parser/scanner specific prefix (d4_ce). Also uncommented an error() method i the D4CEDriver class, although it's not yet used.

	Added the DAP4 CE parser - first version. This code uses the C++ 'modes' of bison and flex, so it will parse anything in an istream. The code does not report locations yet and the scanner does not use a prefix, but that can fixed later if more of these parsers are needed.

2013-07-25  James Gallagher  <jgallagher@opendap.org>

	Merged down from the trunk, which has a bunch of changed developed on the MIIC branch. Those changes include caching code for server functions and modifications to the CE scanner and parser so that large arrays can be passed into constraint expressions (using POST, e.g.). This will require a matching merge of the BES.

2013-07-23  James Gallagher  <jgallagher@opendap.org>

	Removed the openssl/evp.h header because it winds up including des_old.h on OSX 10.5 and that has a conflict with set_key() in BESKeys.h. Also, the code no longer uses the evp.h header...
	M    XDRStreamMarshaller.h

	Manually transferred some fixes from the trunk to these files. I was using malloc() when it wasn't needed (switched to vector<char>) and there were buffers that were not being freed (because I thought xdr_destroy() was calling free() - that's why I used malloc(); it does not call free()).

	Memory leaks fixed in the DAP4 Stream Marshaller classes - but these are in code in the trunk. will check in all the same and make corresponding changes to the code on the dap4 branch (which uses the filename prefix 'D4' instead of 'DAP4').

	Modified ConstraintEvaluator so that it always frees the scanner/parser string buffer when an exception is thrown. I made this change while working on a problem that turned out to be in the scanner (state was not reset when an error was found) but even though this change is not the fix for that - see ce_expr.lex - it seems like a good idea.

	Fixed the rpm build - libtest-types.a was missiing from the spec file.

2013-07-10  James Gallagher  <jgallagher@opendap.org>

	Fixed a bug where a CE with mismatched quotes left the CE parser in the <quote> state, making subsequent requests fail. The fix was in the scanner to reset the parser (technically the scanner's) state to INITIAL when an error was detected. I also added code to catch the Error object thrown by the scanner and delete the parse buffer, although that might be overkill.

	Merged changes from the miic_6.2013 branch. These changes support the new #<type>() special forms that enable big arrays to be use in CEs.
	_M   .
	M    Error.lex
	M    ConstraintEvaluator.cc
	M    Array.cc
	M    tests/expr-test.cc
	A  + tests/ResponseBuilder.cc
	A  + tests/ResponseBuilder.h
	M    tests/Makefile.am
	M    DDXParserSAX2.cc
	M    Makefile.am
	M    ce_expr.y
	M    Error.y
	M    dds.lex
	MM   mime_util.h
	M    XDRStreamUnMarshaller.cc
	M    RValue.h
	M    BaseTypeFactory.h
	M    das.lex
	MM   mime_util.cc
	M    das.y
	M    BaseTypeFactory.cc
	M    util.cc
	D    unit-tests/server-testsuite/geturl.0
	D    unit-tests/server-testsuite/config
	_M   unit-tests/ancT.cc
	M    unit-tests/DDXParserTest.cc
	D    unit-tests/response_cache
	M    unit-tests/Makefile.am
	M    dds.y
	M    Array.h
	M    ce_expr.lex

2013-07-09  James Gallagher  <jgallagher@opendap.org>

	Trunk fixes for the functions module in the libdap andbes spec files. Also a repair to XDRStreamMarshaller.cc

2013-07-08  James Gallagher  <jgallagher@opendap.org>

	Fixed distcheck
	M    tests/Makefile.am

	Fixed some warnings that had been bothering me for a while...

2013-07-06  James Gallagher  <jgallagher@opendap.org>

	Added more special forms for more types (Byte, Int16, UInt16, Int32, UInt32, Float32, and Float64).

2013-07-05  James Gallagher  <jgallagher@opendap.org>

	Added support for a special form that builds an array. This is far faster than the make_array() function in the bes/functions module. Also, I added a new method to Array so that the current shape of the array can be cleared; this is used by the bind_shape() function that can take an array of N elements and set its shape to something with M dimensions.

2013-06-26  James Gallagher  <jgallagher@opendap.org>

	Updates used by the make_array() and bind_name() functions.

2013-06-11  James Gallagher  <jgallagher@opendap.org>

	Removed some of the old dejagnu test stuff.

	Made a copy of ResponseBuilder for the expr-test test program. It's a duplicate of code now in bes/dap, but it seems important to keep the tests here. That might change if all the streaming code moves to bes/dap...

2013-06-06  Nathan Potter  <ndp@opendap.org>

	libdap: new value() methods so that the correct thinmgs are accessed and returned.

2013-06-06  James Gallagher  <jgallagher@opendap.org>

	Branch for MIIC feature development
	A    https://scm.opendap.org/svn/branch/libdap/miic_6.2013

2013-06-06  Nathan Potter  <ndp@opendap.org>

	libdap: Added new 'value' function to Vector that allows you use an subset_index array to retrieve non contiguous values in a single operation

2013-06-05  James Gallagher  <jgallagher@opendap.org>

	Added libdap-* to svn-ignore

2013-05-24  James Gallagher  <jgallagher@opendap.org>

	The Grid map_rbegin and rend methods were not using d_is_array_set correctly. Fixed.

2013-05-22  James Gallagher  <jgallagher@opendap.org>

	Changes/fixes from the merge with the trunk.

	Added
	A    unit-tests/valgrind_suppressions.txt

	Merge results
	D    unit-tests/valgrind_suppressions.txt
	M    unit-tests/DDSTest.cc
	M    unit-tests/ResponseBuilderTest.cc
	M    unit-tests/ResponseCacheTest.cc
	_M   unit-tests/response_cache

2013-05-21  James Gallagher  <jgallagher@opendap.org>

	Fixes for linux
	M    unit-tests/ResponseBuilderTest.cc
	M    unit-tests/ResponseCacheTest.cc

	added valgrind suppressions for stuff in libxml2

	Moved four set_mime_*() methods from ResponseBuilder to mime_util.

2013-05-20  James Gallagher  <jgallagher@opendap.org>

	Modified DDXParser so that it includes an intern_stream() method that takes a cpp istream. Added tests. Also modified ResponseBuilder so that it frees the AlarmHandler allocated when establish_timeout() is called.

	Fixed memory leaks in the DDXParserSax2 code. Other minor edits.

	Test fixes

	Added by merge with the trunk

	added

2013-05-19  James Gallagher  <jgallagher@opendap.org>

	merged code from the trunk - NB the unit-tests/response_cache directory did not get checked in and thus it's not merged and the ResponseCacheTest fails.

2013-05-17  James Gallagher  <jgallagher@opendap.org>

	Added these baseline files for ResponseBuilderTest

	Fixes for ResponseCache - I added tests and have tested most modes. Not tested: how it works with server functions. There are also fixes/modifications for ResponseBuilder that ResponseCache uses. Added a note to ServerFunctionsList that it stores weak pointers. I worked on the ResponseBuilderTests but never got the test for server functions to work completely; the test examines the response document and checks that the metadata part is correct but not the (trivial) data part.

	Added get_next_mime_header() for an istream (the existing version took a FILE*) and moved some of the MIME header methods from ResponseBuilder here.

2013-05-15  Nathan Potter  <ndp@opendap.org>

	libdap: Moving trunk/libdap/unit-tests/ce-functions-testsuite to trunk/bes/functions/unit-tests because that's where the functions are that need the contents of that directory.

2013-05-14  James Gallagher  <jgallagher@opendap.org>

	ResponseCache mostly working...

	We now install the library and *Test headers.

2013-05-14  Nathan Potter  <ndp@opendap.org>

	libdap: Repaired problems with conditional build in ServerFcuntionsList

2013-05-14  James Gallagher  <jgallagher@opendap.org>

	Added HAVE_STDLIB_H and HAVE_ATEXIT to DAPCache3.cc.

2013-05-10  Nathan Potter  <ndp@opendap.org>

	libdap: Instrumentation in Regex. Fixed baseline for ResponseBuilderTest::invoke_server_side_function_test

	libdap: Added life cycle control to DAPCache3 singleton.

	libdap: Added life cycle control to DAPCache3 singleton.

2013-05-10  James Gallagher  <jgallagher@opendap.org>

	(potential) fix for the ResponseBuilder cache bug

2013-05-10  Nathan Potter  <ndp@opendap.org>

	libdap: Updated ResponseBuilderTest to run a server side function.

2013-05-10  James Gallagher  <jgallagher@opendap.org>

	Added A significant refactor of libdap including the start of the DAP4 response object builder class.

	Removed (commented) #define DODS_DEBUG from ServerFunctionsList.

2013-05-10  Nathan Potter  <ndp@opendap.org>

	libdap: Added instrumentation (enabled in this check in) to ServerFunctionsList in an effort to understand the seg fault problem that seems to be associated with server side function calls.

	libdap: Added instrumentation (enabled in this check in) to ServerFunctionsList in an effort to understand the seg fault problem that seems to be associated with server side function calls.

	libdap: Added instrumentation (enabled in this check in) to ServerFunctionsList in an effort to understand the seg fault problem that seems to be associated with server side function calls.

2013-05-09  Nathan Potter  <ndp@opendap.org>

	libdap: Checking in repaired ServerFunctionsList

2013-05-06  James Gallagher  <jgallagher@opendap.org>

	Removed the Ancillary.h file from D4ResponseBuilder

	Removed old code

	DAPCache3 is now in the libdap namespace. The cache-specific methods of ResponseBuilder have been factored out to ResponseCache; RB still makes explicit calls to the cache code, however. The ResponseCache class was added.

2013-05-03  James Gallagher  <jgallagher@opendap.org>

	Added correct copyright headers for the ServerFunctions classes.

2013-05-03  Nathan Potter  <ndp@opendap.org>

	libdap: Attempting to fix memory leaks in ServerFucntionsList - adding unit tests for same.

2013-05-02  James Gallagher  <jgallagher@opendap.org>

	Removed old code in util

	Removed old code from ResponseBuilder

2013-05-01  James Gallagher  <jgallagher@opendap.org>

	Added D4ResponseBuilder and remove the timeout methods from DMR.

2013-05-01  Nathan Potter  <ndp@opendap.org>

	libdap: Change type signature for setter methods in ServerFunction so that they accept const parameters

	libdap: Change type signature for setter methods in ServerFunction so that they accept const parameters

2013-04-29  James Gallagher  <jgallagher@opendap.org>

	Fixed the access to the DODS_CONF environment variable in the RCReaderTest. The same fix should prbably be used in other tests that use putenv() or setenv().

	Added suppressions file for valgrind in the cache-testsuite dir. Made an attempt to fix the RCReader tests, but I think this is past the point where there is much return...

	Added crc.h to the code.

	Fix suppressions in the Makfile and added suppressions. There are still memory issues.

2013-04-27  James Gallagher  <jgallagher@opendap.org>

	Wrapped the two DAP4-only includes in #if DAP4. Those headers are not installed in a regular build and the includes break clients that included the file.
	M    BaseType.h

2013-04-26  James Gallagher  <jgallagher@opendap.org>

	Added a 'suppressions' file for valgrind. This may help with the bogus putenv/setenv reports.

	Added HTTPCacheTest back into the Makefile for unit-tests; the only errors in the unit-tests that remain are leaks reported from putenv() calls (only on OSX?) which are bogus reports since the man page for OSX notes putenv _will_ leak given the BSD definition. Not sure how to deal with this... Maybe suppress the error for putenv?

	Fixed a leak in the DODSFilterTest; Added a call to HTTPCache::delete_instance() in HTTPConnectTest so that some 'leaks' don't show up there.

	Fixed a leak in AttrTable but had to change the behavior of del_attr_table() in the process. That method now deletes the contained table.

	Repaired SignalHandlerTest - now works with valgrind.

2013-04-25  James Gallagher  <jgallagher@opendap.org>

	Fixed leaks in SequenceTest

	Fixed leaks in D4ParserSax2 - leaks that would occur when errors are found in the input (based on leaks in DDXParserSAX2).c

	Fixed leaks in DDXParserSAX2

	Fixed a leak in XDRStreamMarshaller

	More leaks fixed - mostly in ResponseBuilderTest

	Fixed memory leaks found using valgrind with the unit tests.

2013-04-24  James Gallagher  <jgallagher@opendap.org>

	Fixed a memory leak in D4StreamMarshaller.

	Renamed DAP4StreamMarshaller/UnMarshaller classes to use 'D4' prefix.

	Updated the tests for DAP4Marshaller and UnMarshaller

	Modified DAP4StreamMarshaler, it's test and baselines to use CRC32 as the checksum. Working.

	Move Type.h include in BaseType out of the namespace libdap { } and added namespace libdap { } to the Type header itself. Also swapped CRC32 into the DAP4Marshaller code.

2013-04-22  James Gallagher  <jgallagher@opendap.org>

	Added support for valgrind running the unit-tests (this could probably be extended to the autotest tests, too). The changes are in configure.ac (an option) and unit-tests/Makefile.am (see TEST_ENVIRONMENT). Added a small macro in conf for the configure.ac.

	Added he D4Enum variable type even though I'm not sure about its design. revisit this once arrays are in place.

	Hacked D4DimensionsTest so that it using a switch to control debugging output and can run tests by name.

	D4Dimensions now tests for errors when set_size() is called with a string - and the parser D4ParserSax2 does not do the conversion itself but uses the class' code. Added unit tests that illustrate using the CPPUNIT_TEST_EXCEPTION macro.

2013-04-19  James Gallagher  <jgallagher@opendap.org>

	Changed D4Dimension so it can take the dimension size as a string. Needs work on/in the error detection code, however. See set_size().

	Mem leak fix in D4Group

	Removed the unused D4ParserError class from the code; removed unneeded includes in D4ParserSax2.h

	Reworked the error reporting to be more rational. D4ParserError no longer used.

	Added debug switch to the parser's intern() methods

	Removed various preprocessor switches from the DAP4 parser.

	New D4Attributes in the code and all tests pass. Some debugging code still in place and other things to be changed.

2013-04-18  James Gallagher  <jgallagher@opendap.org>

	Added D4Attributes to BaseType.

	Turned off instrumentation; D4Attribtues in BaseType but not compiled yet.

	Fixed memory leaks in the D4Group unit tests

	Added unit tests for D4Attributes find and get methods; fixed a bug in that code.

	Added D4AttributesTest unit-tests and baselines.

2013-04-17  James Gallagher  <jgallagher@opendap.org>

	Added a new Attribute/s class for DAP4. Needs to be tested and integrated into the library (as a field in BaseType?)

	Added tests for DAP4 Attributes in various places like Structures, Groups and simple variables

2013-04-16  James Gallagher  <jgallagher@opendap.org>

	Added tests for Attributes. Have not tested Attributes with variables yet, but they work with the root group.

	Added Attribute code back in; Also, testing having BaseType define print_val(FILE *...)

	Used #if ATTR to remove the old attribute code from the parser.

2013-04-15  James Gallagher  <jgallagher@opendap.org>

	Added support and tests for Groups

	Structures parse - only test code was added/changed since the last commit.

	Parsing all of the simple variable types except enum and opaque.

	Basic DMR and D4Parser round-trip tests now work.

2013-04-13  James Gallagher  <jgallagher@opendap.org>

	DMR Parsing progress

	Tests for D4PaserSax2

2013-04-11  James Gallagher  <jgallagher@opendap.org>

	svn ignore updated for tests

	Changed D4Dimensions so that it is a container for D4Dimension pointers. This mirrors D4EnumDefs & D4EnumDef.

	ignored (for svn) stuff; removed old autogen.sh

	ignored (for svn) stuff

	ignored (for svn) stuff

	... hoping resovlong the conflicts after the copy and switch is the right thing to do.
	R    Type.h
	R    tests/dmr-test.cc
	R    DMR.cc
	R    DMR.h
	R    unit-tests/D4GroupTest.cc
	R    unit-tests/D4-xml/D4Group_with_scalars_and_stuff.xml
	R    unit-tests/D4-xml/D4Group_named_with_scalars_and_stuff.xml
	R    unit-tests/D4-xml/D4Group_with_scalars.xml
	R    unit-tests/D4-xml/D4Group_everything.xml
	R    unit-tests/D4-xml/D4Group_named_with_scalars.xml
	R    unit-tests/D4-xml/D4Group_empty.xml
	R    unit-tests/D4-xml/D4Group_named_empty.xml

	DAP4 development branch, third try...
	A    https://scm.opendap.org/svn/branch/libdap/dap4

2013-04-10  James Gallagher  <jgallagher@opendap.org>

	Made a branch for the dap4 development - replaces the old DAP4 branch
	A    https://scm.opendap.org/svn/branch/libdap/dap4

2013-04-03  James Gallagher  <jgallagher@opendap.org>

	distcheck works on linux now...
	A  + D4ParserSax2.cc
	M    Makefile.am
	D    D4ParserSAX2.cc

2013-04-02  James Gallagher  <jgallagher@opendap.org>

	Added climit include to fix 'UINT/INT_MAX missing' on Linux.
	M    util.cc

2013-04-01  James Gallagher  <jgallagher@opendap.org>

	Added unit tests for D4Dimensions and D4EnumDefs. Removed old code from the AttrTable tests.

	Added D4EnumDefs

2013-03-26  Nathan Potter  <ndp@opendap.org>

2013-03-25  Nathan Potter  <ndp@opendap.org>

	libdap: Disabling cruft code from earlier ugrid work.

2013-02-26  Nathan Potter  <ndp@opendap.org>

	libdap: Comments

2013-02-12  Nathan Potter  <ndp@opendap.org>

	libdap: comments

2013-02-08  Nathan Potter  <ndp@opendap.org>

	libdap: Updated ServerFunction API

2013-02-07  Nathan Potter  <ndp@opendap.org>

	libdap: Added methods to ServerFunctionsList to allow inspection of the list contents.

2013-02-06  Nathan Potter  <ndp@opendap.org>

	libdap: Moved AbstractFunction class to ServerFunction class

	libdap: Added the use of AbstractFunction class.

2013-02-05  Nathan Potter  <ndp@opendap.org>

	team sync

	team sync

2013-02-04  Nathan Potter  <ndp@opendap.org>

	libdap: Adding AbstractServerSideFunction

2013-01-31  James Gallagher  <jgallagher@opendap.org>

	Fixes for bes distcheck
	M    ServerFunctionsList.cc
	M    ServerFunctionsList.h
	M    ConstraintEvaluator.h

2013-01-30  James Gallagher  <jgallagher@opendap.org>

	Distcheck now works; removed more old server function code.
	_M   .
	M    configure.ac
	M    main_page.doxygen
	M    ConstraintEvaluator.cc
	_M   tests
	M    Makefile.am
	D    swath2grid
	D    ugridFunctions
	M    NEWS
	M    ConstraintEvaluator.h
	M    unit-tests/HTTPCacheTest.cc
	M    doxy.conf

	Added stuff to svn:ignore

2013-01-30  Nathan Potter  <ndp@opendap.org>

	libdap: Updating configre.ac for automake-1.13

2013-01-29  James Gallagher  <jgallagher@opendap.org>

	Changed the way functions are registered so that CE does not have to copy all the functions into every instance of the CE class. Now CE uses functions directly from a list in libdap.

	Changed the way functions are registered so that CE does not have to copy all the functions into every instance of the CE class. Now CE uses functions directly from a list in libdap.

	Fixed checkin - I checked in some code with debugging on

	Removing 'basic' server functions.
	_M   .
	M    Keywords2.cc
	M    ConstraintEvaluator.cc
	M    tests/TestArray.cc
	M    tests/EXPRTest.at
	M    Makefile.am
	M    swath2grid/reproj_functions.cc
	M    HTTPCache.cc
	M    util.h
	M    expr.h
	M    util.cc
	M    unit-tests/HTTPCacheTest.cc
	D    unit-tests/ArrayGeoConstraintTest.cc
	RM + unit-tests/ancT.cc
	M    unit-tests/ddsT.cc
	M    unit-tests/ResponseBuilderTest.cc
	D    unit-tests/CEFunctionsTest.cc
	D    unit-tests/GridGeoConstraintTest.cc
	M    unit-tests/Makefile.am
	M    unit-tests/Keywords2Test.cc

	Added stuff to svn:ignore

	Added stuff to svn:ignore

	Added stuff to svn:ignore

2013-01-25  Patrick West  <pwest@opendap.org>

	Removing dependency on DAP4 code for DAP3 responses M    ResponseBuilder.h M    ResponseBuilder.cc M    Int64.h

	Need autoconf 2.61, not 2.62 M    configure.ac

2013-01-18  James Gallagher  <jgallagher@opendap.org>

	Merge of the code from hyrax 1.8 release (version 3.11.7)
	_M   .
	A  + gridfields_functions.h
	M    configure.ac
	M    Connect.h
	M    ChangeLog
	A  + gridfields_functions.cc
	M    ResponseBuilder.h
	M    main_page.doxygen
	A  + DAPCache3.cc
	A  + DAPCache3.h
	_M   OSX_Resources
	M    ConstraintEvaluator.cc
	M    DDS.cc
	M    HTTPCacheTable.cc
	M    Array.cc
	_M   tests
	M    tests/TestGrid.cc
	M    tests/expr-test.cc
	M    tests/TestStructure.cc
	M    INSTALL
	M    DDXParserSAX2.cc
	M    libdap.spec
	M    ResponseBuilder.cc
	M    README
	M    BaseType.cc
	M    DDS.h
	_M   win32/gl
	M    Makefile.am
	AM + swath2grid
	M    DataDDS.cc
	M    ce_expr.y
	M    util.h
	AM + ugridFunctions
	M    XDRStreamUnMarshaller.cc
	M    NEWS
	A  + doxy.conf.in
	M    Vector.cc
	A  + main_page.doxygen.in
	_M   gl
	M    ce_functions.cc
	M    expr.h
	MM   mime_util.cc
	M    GridGeoConstraint.cc
	M    Vector.h
	M    util.cc
	M    Grid.cc
	M    Connect.cc
	_M   unit-tests
	MM   unit-tests/MIMEUtilTest.cc
	M    unit-tests/ResponseBuilderTest.cc
	M    Clause.cc
	M    Array.h
	M    doxy.conf
	M    ce_expr.lex

2012-12-28  James Gallagher  <jgallagher@opendap.org>

	Removed this generated file from SVN
	D    swath2grid/bes.conf

	Checkpoint.
	_M   .

2012-12-20  James Gallagher  <jgallagher@opendap.org>

	checkpoint; make check runs; the s2g test fails but will be fixed later.
	M    swath2grid/Makefile.am
	M    ugridFunctions/tests/ugr2-fvcom-full.bescmd

	Added a unit test (doesn't work yet) for swath2grid. Also some updates to the function.

	Added support for dimension projection 'wildcards' so that i[*], i[n:*] and i[n:m:*] are supported where those project all of the elements and all elements from n to the end of the array, respectively.

2012-12-13  Nathan Potter  <ndp@opendap.org>

	libdap: Adding new urgid function

2012-12-13  James Gallagher  <jgallagher@opendap.org>

	Swath2grid checkpoint and removal of the eclipse . files
	M    configure.ac
	D    .cproject
	M    swath2grid/reproj_functions.h
	D    swath2grid/airs.nc.0.bescmd
	M    swath2grid/DAP_Dataset.cpp
	M    swath2grid/bes.conf
	M    swath2grid/DAP_Dataset.h
	M    swath2grid/BoundingBox.cpp
	A  + swath2grid/airs.nc.0.data.bescmd
	M    swath2grid/bes.conf.in
	M    swath2grid/Makefile.am
	D    .project

	Checkpoint...

2012-12-13  Nathan Potter  <ndp@opendap.org>

	libdap: Incremental checkin of ugrid functions. Compiles but breaks at runtime with 'Symbol not found' error

	libdap: Incremental checkin of ugrid functions. Compiles but breaks at runtime with 'Symbol not found' error

	libdap: Incremental checkin of ugrid functions. Compiles but breaks at runtime with 'Symbol not found' error

	libdap: Incremental checkin of ugrid functions. Compiles but breaks at runtime with 'Symbol not found' error

	libdap: Incremental checkin of ugrid functions. Compiles but breaks at runtime with 'Symbol not found' error

2012-12-12  James Gallagher  <jgallagher@opendap.org>

	Fixed enum forward declaration.

	Changes t fix compile errors in the MeshData and MeshTopology classes.

2012-12-12  Nathan Potter  <ndp@opendap.org>

	libdap: incremental (emphasis on mental) checkin of ugrid functions

	libdap: incremental (emphasis on mental) checkin of ugrid functions

	libdap: incremental (emphasis on mental) checkin of ugrid functions

	libdap: incremental (emphasis on mental) checkin of ugrid functions

	libdap: incremental (emphasis on mental) checkin of ugrid functions

	libdap: Incremental check-in of ugrid functions. Compiles, but may not work.

2012-12-11  Nathan Potter  <ndp@opendap.org>

	libdap: Moved ugrid code to it's own directory

2012-12-10  Nathan Potter  <ndp@opendap.org>

2012-12-10  James Gallagher  <jgallagher@opendap.org>

	comments: questions for Bill

2012-12-10  Nathan Potter  <ndp@opendap.org>

2012-12-10  James Gallagher  <jgallagher@opendap.org>

	checkpoint for swath2grid

2012-12-09  James Gallagher  <jgallagher@opendap.org>

	Supports Swath to Grid - no testing, though.

2012-12-08  James Gallagher  <jgallagher@opendap.org>

	Checkpoint on the way to building a Grid variable from/for projected satellite data.

2012-12-07  Nathan Potter  <ndp@opendap.org>

	libdap: Incremental memory deallocation improvment.

2012-12-06  Nathan Potter  <ndp@opendap.org>

	libdap: Incremental memory deallocation improvment.

2012-12-05  Nathan Potter  <ndp@opendap.org>

	libdap: Incremental debugging check-in for ugrid_restrict (ugr2) code.

	libdap: Incremental debugging check-in for ugrid_restrict (ugr2) code.

	libdap: Incremental debugging check-in for ugrid_restrict (ugr2) code.

	libdap: Incremental debugging check-in for ugrid_restrict (ugr2) code.

	libdap: Incremental debugging check-in for ugrid_restrict (ugr2) code.

	libdap: Incremental debugging check-in for ugrid_restrict (ugr2) code.

	libdap: Incremental debugging check-in for ugrid_restrict (ugr2) code.

	libdap: Incremental debugging check-in for ugrid_restrict (ugr2) code.

	libdap: Incremental debugging check-in for ugrid_restrict (ugr2) code.

	libdap: Incremental debugging check-in for ugrid_restrict (ugr2) code.

	libdap: Incremental debugging check-in for ugrid_restrict (ugr2) code.

	libdap: Incremental debugging check-in for ugrid_restrict (ugr2) code.

	libdap: Incremental debugging check-in for ugrid_restrict (ugr2) code.

	libdap: Incremental debugging check-in for ugrid_restrict (ugr2) code.

	libdap: Incremental debugging check-in for ugrid_restrict (ugr2) code.

	libdap: Incremental debugging check-in for ugrid_restrict (ugr2) code.

	libdap: Incremental debugging check-in for ugrid_restrict (ugr2) code.

	libdap: Adding refactored ugrid_restrict that conforms to Ugrid specification.

	libdap: Adding refactored ugrid_restrict that conforms to Ugrid specification.

	libdap: Adding refactored ugrid_restrict that conforms to Ugrid specification.

	libdap: Adding refactored ugrid_restrict that conforms to Ugrid specification.

2012-12-03  Nathan Potter  <ndp@opendap.org>

	libdao: ugrid instrumentation

	libdao: ugrid instrumentation

	libdao: ugrid instrumentation

2012-11-30  Nathan Potter  <ndp@opendap.org>

	libdao: ugrid instrumentation

	libdap: adding ugrid tests

	libdap: adding ugrid tests

	libdao: ugrid instrumentation

2012-11-30  James Gallagher  <jgallagher@opendap.org>

	Added --with-gdal fixes to configure.ac and registered swath2grid when that option is defined (in ConstraintEvaluator.cc).

	Added some testing stuff for the swath2grid function

	Fixed - but minimal testing

2012-11-30  Nathan Potter  <ndp@opendap.org>

	libdap: incremental check of new ugrid_restrict code. Ready for AWS beta

	libdap: incremental check of new ugrid_restrict code. Removed \#if 0 blocks from new implementation.

2012-11-29  Nathan Potter  <ndp@opendap.org>

	libdap: incremental check of new ugrid_restrict code. Removed \#if 0 blocks from new implementation.

	libdap: incremental check of new ugrid_restrict code. Removed \#if 0 blocks from new implementation.

	libdap: incremental check of new ugrid_restrict code. New verion appears correct.

	libdap: incremental check of new ugrid_restrict code. Compiles but is incorrect.

2012-11-28  James Gallagher  <jgallagher@opendap.org>

	Remove NC_GOES code from swath2grid Makefile.am

2012-11-28  Nathan Potter  <ndp@opendap.org>

	libdap: Checking refactored ugrid_restrict that breaks the original code into more understandable functional blocks. Code works and correctly reproduces the output of the original implementation.

	libdap: Checking refactored ugrid_restrict that breaks the original code into more understandable functional blocks. Code works and correctly reproduces the output of the original implementation.

2012-11-28  James Gallagher  <jgallagher@opendap.org>

	function_swath2grid() can return an Array *. Untested/checkpoint.

	checkpoint for swath2grid...

2012-11-28  Nathan Potter  <ndp@opendap.org>

	libdap: Checking in partial ugrid restrict code. Compiles but may not run.

	libdap: Checking in partial ugrid restrict code. Compiles but may not run.

2012-11-27  James Gallagher  <jgallagher@opendap.org>

	Added the start of a swath2grid CE function for Hyrax - this code will be the interface between the constraint evaluator and the GDAL library. It will have to unpack a GDALDataseta and build a DAP Grid to hold the reprojected data.

	Changed svn ignore properties

2012-11-27  Nathan Potter  <ndp@opendap.org>

	libdap: First pass at new ugrid_restrit code. Check in for sharing (code compiles but may not yet work)

2012-11-27  James Gallagher  <jgallagher@opendap.org>

	Fixed teh build when --with-gdal is not used. Minor changes in swath2grid.
	M    .cproject
	M    Makefile.am
	M    swath2grid/DAP_Dataset.cpp

2012-11-26  James Gallagher  <jgallagher@opendap.org>

	checkpoint - swath2data is closer...

	Added comments to the gridfields_functions.cc code. It seems that the ugrid spec has move out from under this code over time and the code needs some tweaks to match the current version of the spec.

2012-11-23  James Gallagher  <jgallagher@opendap.org>

	Began modifying the swath2grid code so it can work with DAP objects.

	Added initial copy of GMU swath2grid lib - an edited copy of a library from their WCS 2.0 code.

2012-11-16  James Gallagher  <jgallagher@opendap.org>

	Removed errant reference to the ugrid tests - the tests are still in the netcdf handler code. There are also tests in the ncml module.

	Removed generated dirs in 'tests'.

	Removed some instrumentation from DDS.cc that was checked in by mistake. Fixed a problem in the gridfields_function.cc file where the code, that works only with arrays cast BaseTypes without testing that they were actually arrays. Now it simply ignores variables that are not arrays.

2012-11-15  James Gallagher  <jgallagher@opendap.org>

	Copied the gridfields code from netcdf handler. The code can register the ugrid_restrict() function here and that will enable its use with ncml handler.

2012-11-07  James Gallagher  <jgallagher@opendap.org>

	Source release for 3.11.7

	Changed svn ignore properties

	Changed svn ignore properties

	Changes for libdap 3.11.5 so that when the CE Function cache directory is not present, caching is off. Before the code was just crashing when a function was used. I also refactored ResponseBuilder (where the fix is) so that it's got less redundancy.

2012-11-02  James Gallagher  <jgallagher@opendap.org>

	Release 3.11.6
	M    configure.ac
	M    ChangeLog
	M    main_page.doxygen
	M    tests/package.m4
	M    INSTALL
	M    libdap.spec
	M    README
	M    NEWS
	M    doxy.conf

	Fixes for a respource leak in the server function cache code.
	M    ResponseBuilder.cc

2012-10-31  James Gallagher  <jgallagher@opendap.org>

	fixed an error in the include of DDXParserSAX2.h - OSX file system case issues

2012-10-24  James Gallagher  <jgallagher@opendap.org>

	Changed svn ignore properties

	Changes so that users - handlers primarily - of libdap don't have to change their link libraries even though ResponseBuilder has the new caching code. The first version used Connect, this version uses hacked copies of (tiny) parts of Connect. This keeps the handlers from needing libdapclient, libcurl and libuuid to link.
	M    ResponseBuilder.h
	M    ResponseBuilder.cc
	M    Makefile.am
	M    mime_util.cc

	Fixes both from a code review and to move Connect into libdap proper so that clients will link correctly (now that Connect is used both by clients and servers.
	M    HTTPCacheTable.cc
	M    ResponseBuilder.cc
	M    Makefile.am
	M    util.cc
	M    Connect.cc

	Changed svn ignore properties

	Added DAPCache3.

	Changed svn ignore properties

2012-10-23  James Gallagher  <jgallagher@opendap.org>

	These changes support server functions in DAP2 using the F-TDS/GDS 'in path' syntax. They aslo add support for retrieving the DDS and DAS from URLs with functions (both the F-TDS/GDS syntax and ours) and cache the results of function calls.
	M    Connect.h
	M    ResponseBuilder.h
	M    ConstraintEvaluator.cc
	M    DDS.cc
	M    tests/TestGrid.cc
	M    tests/expr-test.cc
	M    tests/TestStructure.cc
	M    DDXParserSAX2.cc
	M    ResponseBuilder.cc
	M    BaseType.cc
	M    DDS.h
	M    Makefile.am
	M    ce_expr.y
	M    XDRStreamUnMarshaller.cc
	M    Vector.cc
	M    ce_functions.cc
	M    mime_util.cc
	M    GridGeoConstraint.cc
	M    Connect.cc
	M    unit-tests/ResponseBuilderTest.cc
	M    Clause.cc

2012-10-16  James Gallagher  <jgallagher@opendap.org>

	Fixed case of DAP4StreamMarshaller.h - failed on linux
	M    ResponseBuilder.cc

	Fix for missing headers when --enable-dap4 is not used with configure. It's a temporary fix/hack.
	M    BaseType.h
	M    Makefile.am

	Complete - task : Write BaseTypeFactory for DAP4 Complete - task : New marshaller will be needed Refactor: Moved most of Structure up into Constructor, so it can be used by Group, too. Added a parser for DAP4 DMR documents, only just started. Tests pass both with and without --enable-dap4

2012-09-28  James Gallagher  <jgallagher@opendap.org>

	Changed to using named branches for the server release.
	A    https://scm.opendap.org/svn/branch/libdap/hyrax-1.8-release

2012-09-24  James Gallagher  <jgallagher@opendap.org>

	Added one test for the DMR response of DAP4.

	Checkpoint for changes that enable the library to return DAP4 response objects (DMR and Data). The changes are not complete, but the library builds and passes all tests when built using both the --enable-dap4 and without it.
	_M   .
	M    ResponseBuilder.h
	M    DDS.cc
	M    tests/dds-test.cc
	M    DAP4StreamMarshaller.cc
	M    HTTPCacheInterruptHandler.h
	M    ResponseBuilder.cc
	M    DDS.h
	M    DataDDS.cc
	M    Connect.cc
	M    unit-tests/DDSTest.cc
	M    unit-tests/AttrTableTest.cc
	M    unit-tests/ResponseBuilderTest.cc
	M    unit-tests/dds-testsuite/test.19b6.xml
	M    unit-tests/dds-testsuite/test.19b.xml
	M    unit-tests/dds-testsuite/test.19c.xml
	M    unit-tests/dds-testsuite/test.19d.xml
	M    unit-tests/dds-testsuite/test.19e.xml
	M    unit-tests/dds-testsuite/test.19f.xml
	M    unit-tests/testFile.cc
	M    unit-tests/testFile.h

2012-08-29  James Gallagher  <jgallagher@opendap.org>

	Updated comments
	M    Keywords2.cc

2012-07-26  James Gallagher  <jgallagher@opendap.org>

	Memory leak in XDRStreamMarshaller fixed.

	Found and fixed an error in the add_var_nocopy() method for DDS. I also added add_var_nocopy() methods to Vector and Array and noted that when a BaseType is passed to Array's ctor the add_var() method is used, thus making a copy. If the 'nocopy' behavior is desired, then pass null to the ctor and call add_var_nocopy() 'by hand.' I also changed two instances of dynamic_cast so that static_cast is used instead. These changes are backward compatible to the previous version of the library. Bumped the version up to 3.12.0

2012-07-11  James Gallagher  <jgallagher@opendap.org>

	Turned off DAP4 DDX Parser debugging

	Now the DAP4 DDX Parser should recognize the M-MIME boundary marker. Untested... Might not actually need this.

	Now DDS::print_xml_writer builds a DDX response that's correct for DAP4 - with the namespace and other stuff in there.

	Added a BasetypeFactory for DAP4 and cloned and modified a DDX parser for the same. The dds-test drive in tests can be used to test DDX documents for DAP4. The new - DAP4 - types supported are Int8, Int64 and UInt64 along with the faux types URL (Url) and UInt8 (Byte).

2012-07-09  James Gallagher  <jgallagher@opendap.org>

	Added Int8 type

2012-06-29  James Gallagher  <jgallagher@opendap.org>

	Checkpoint for DAP4 data types and supporting classes in libdap. This checkin includes atomic types - except Opaque.

2012-06-28  James Gallagher  <jgallagher@opendap.org>

	Testing commit after relocating to the https://scm... URL from inside Eclipse.

	Changes for DAP4 - fixed up operators. Testing checkin after relocating to the https://scm... URL.
	M    UInt16.h

2012-06-27  James Gallagher  <jgallagher@opendap.org>

	Removed errant instrumentation in serialize()

2012-06-22  James Gallagher  <jgallagher@opendap.org>

	DAP4 additions

	DAP4 new files

	Edits for DAP4 including Int64 and UInt64. Some tests/checks for constructor types to exclude types that should only be used for DAP4 when the software is clearly working with DAP2.

	more gnulib

	Added marcos
	A    m4/strings_h.m4
	A    m4/locale_h.m4
	A    m4/sys_types_h.m4
	A    m4/localeconv.m4
	A    m4/off_t.m4
	A    m4/mbtowc.m4
	A    m4/byteswap.m4

	gnulib update - forgotten file.

	Updated gnulib to include byteswap() functions. They are used by the DAP4StreamUnMarshaller code.

	Added some debugging output for/because of work on the GDAL handler.

2012-06-21  James Gallagher  <jgallagher@opendap.org>

	Moved c_md5_length into the DAP4Stream{Un}Marshaller classes.

2012-06-20  James Gallagher  <jgallagher@opendap.org>

	Added classes and tests for the DAP4 on-the-wire format as of the DAP4 draft specification from early June 2012. At the same time I fixed some memory problems I found in the XDRStream{Marshaller,UnMarshaller} classes - XDR objects were likely leaking memory. I also removed the checksum test feature from XDRStreamMarshaller since that is not a DAP2 feature. The DAP4 serializers support writing and reading checksums. The interfaces defined by Marshaller and UnMarshaller are unchanged although I did add methods.

2012-06-05  James Gallagher  <jgallagher@opendap.org>

	Fixed an error in the MIMEUtilTest code. The test failed when the time zone was to the east of the prime meridian. See ticket 1907.

2012-05-31  James Gallagher  <jgallagher@opendap.org>

	doxygen updates plus added an example function for the MIIC folks to ce_functions.cc.
	M    configure.ac
	M    main_page.doxygen
	M    ConstraintEvaluator.cc
	A    doxy.conf.in
	A    main_page.doxygen.in
	M    ce_functions.cc
	M    doxy.conf

2012-05-11  Nathan Potter  <ndp@opendap.org>

	libdap: updating version number

2012-05-01  Nathan Potter  <ndp@opendap.org>

	libdap: Added lib64 support to dap-config

2012-04-26  James Gallagher  <jgallagher@opendap.org>

	Removed the last of the OLD_FILE_METHODS implementations.

	Removed most of the OLD_*_METHODS - only those in the mime_util code remain.

2012-04-25  James Gallagher  <jgallagher@opendap.org>

	Refactor: coded all the libdap output methods so that the logic is written just once (in the XMLWriter for XML and ostream for the curl braces). Older code is just a wrapper for those methods. All of the FILE* methods calls the ostream methods using an instance of ostringstream; all of the FILE* ostream xml methods are wrappers for the XMLWriter methods.
	M    DODSFilter.cc
	M    XMLWriter.h
	M    Int16.cc
	M    XMLWriter.cc
	M    DDS.cc
	M    Array.cc
	M    tests/expr-test.cc
	M    tests/TestByte.cc
	M    tests/io_test.cc
	M    UInt16.cc
	M    Byte.cc
	M    ResponseBuilder.cc
	M    GNU/GetOpt.cc
	M    BaseType.cc
	M    Makefile.am
	M    Int32.cc
	M    Float32.cc
	M    AttrTable.cc
	D    grammarfiles
	M    Structure.cc
	M    Vector.cc
	M    getdap.cc
	M    Str.cc
	M    Sequence.cc
	M    mime_util.cc
	M    Constructor.cc
	M    XDRStreamMarshaller.h
	M    util.cc
	M    Float64.cc
	M    UInt32.cc
	M    XDRStreamMarshaller.cc
	M    Grid.cc
	M    Connect.cc
	M    unit-tests/MarshallerTest.cc

2012-04-24  James Gallagher  <jgallagher@opendap.org>

	Fixed lack of loop index init in setup().

2012-04-20  James Gallagher  <jgallagher@opendap.org>

	Found an uninitialize loop index variable; fixed and the test stopped faulting.
	M    unit-tests/MarshallerTest.cc

	Build fixes for OSX

	Patch to configure.ac - fixed the CHECKSUMS_DEFINED problem from yesterday's check in.

2012-04-19  James Gallagher  <jgallagher@opendap.org>

	Removed more of the ugrid function code.

	Removed an errant AC_OUPUT item related to ugrids.
	M    configure.ac

2012-04-18  James Gallagher  <jgallagher@opendap.org>

	Removed the ugrid function from libdap; it's now in the netcdf_handler
	M    configure.ac
	M    ce_functions.h
	M    ce_functions.cc
	M    dap-config.in

2012-04-17  James Gallagher  <jgallagher@opendap.org>

	Changes for the gridfields build.
	M    configure.ac
	M    Makefile.am

	Merge/version update
	_M   .
	_M   OSX_Resources/Info.plist.proto
	_M   tests/old_tests/grid-func-testsuite
	_M   tests/old_tests/server-testsuite
	_M   mime_util.h
	M    NEWS
	_M   mime_util.cc
	_M   unit-tests/MIMEUtilTest.cc
	_M   unit-tests/fdiostreamTest.cc
	_M   fdiostream.h

	Merge of ugrid code - I tried to merge from the branch, but I wound up merging files largely by hand.
	M    configure.ac
	M    ce_functions.cc
	M    dap-config.in

	Updated NEWS
	M    NEWS

2012-04-13  James Gallagher  <jgallagher@opendap.org>

	After merge with hyrax 1.8 release branch and full build w/o test failures.
	_M   .
	M    ChangeLog
	_M   OSX_Resources/Info.plist.proto
	M    HTTPCacheTable.cc
	_M   tests/old_tests/grid-func-testsuite
	_M   tests/old_tests/server-testsuite
	MM   mime_util.h
	MM   mime_util.cc
	M    XDRStreamMarshaller.cc
	_M   unit-tests/MIMEUtilTest.cc
	_M   unit-tests/fdiostreamTest.cc
	_M   fdiostream.h

2012-04-12  James Gallagher  <jgallagher@opendap.org>

	Result of merging changes from the trunk. This code was then merged to the trunk and tagged.
	_M   .
	M    configure.ac
	M    ChangeLog
	_M   OSX_Resources/Info.plist.proto
	M    HTTPCacheTable.cc
	_M   tests/old_tests/grid-func-testsuite
	_M   tests/old_tests/server-testsuite
	M    tests/TestArray.cc
	M    tests/package.m4
	M    ResponseBuilder.cc
	M    Makefile.am
	_M   mime_util.h
	M    Structure.cc
	M    Vector.cc
	_M   mime_util.cc
	M    XDRStreamMarshaller.h
	M    XDRStreamMarshaller.cc
	M    Grid.cc
	_M   unit-tests/MIMEUtilTest.cc
	_M   unit-tests/fdiostreamTest.cc
	M    unit-tests/Makefile.am
	M    unit-tests/MarshallerTest.cc
	M    HTTPConnect.h
	_M   fdiostream.h

	Repaired the MarshallerTest by removing the checksums tests when that feature is not compiled into the code.
	M    unit-tests/MarshallerTest.cc

	Removed; generated
	D    tests/package.m4

	tiny change to match the version number update on the h 1.8 branch
	M    configure.ac

	Merge of the hyrax 1.8 release branch version of libdap plus the new checksum code. The code on the hyrax 1.8 release branch will be bumped up to version 3.11.4 and tagged as such.
	_M   .
	M    Error.lex
	M    DODSFilter.cc
	A  + XMLWriter.h
	M    Structure.h
	M    Sequence.h
	M    SignalHandler.cc
	M    configure.ac
	M    COPYING
	M    ChangeLog
	M    Ancillary.cc
	_M   OSX_Resources/Info.plist.proto
	M    gse.lex
	A  + XMLWriter.cc
	M    DDS.cc
	A  + HTTPCacheMacros.h
	M    HTTPCacheTable.cc
	M    BaseType.h
	M    Array.cc
	M    tests/das-testsuite/test.34.das.base
	_M   tests/old_tests/grid-func-testsuite
	_M   tests/old_tests/server-testsuite
	M    tests/expr-testsuite/test.6b.base
	M    tests/expr-testsuite/test.5e.base
	M    tests/package.m4
	M    tests/Makefile.am
	M    tests/dds-test.cc
	M    INSTALL
	M    DDXParserSAX2.cc
	M    AlarmHandler.h
	M    libdap.spec
	M    ResponseBuilder.cc
	M    GNU/GetOpt.h
	M    README
	M    BaseType.cc
	M    DDS.h
	M    Makefile.am
	M    Constructor.h
	M    HTTPCache.cc
	M    ce_expr.y
	A  + getdap.man1
	M    dds.lex
	M    util.h
	M    AttrTable.cc
	_M   mime_util.h
	M    Grid.h
	M    NEWS
	M    HTTPConnect.cc
	M    Structure.cc
	M    Sequence.cc
	M    das.lex
	M    ce_functions.cc
	M    AttrTable.h
	_M   mime_util.cc
	M    GridGeoConstraint.cc
	M    Constructor.cc
	M    util.cc
	A  + dap-config.man1
	M    Grid.cc
	M    unit-tests/dasT.cc
	M    unit-tests/AISMergeTest.cc
	M    unit-tests/DODSFilterTest.cc
	M    unit-tests/HTTPCacheTest.cc
	M    unit-tests/DDSTest.cc
	M    unit-tests/AttrTableTest.cc
	MM   unit-tests/MIMEUtilTest.cc
	_M   unit-tests/fdiostreamTest.cc
	M    unit-tests/ddsT.cc
	M    unit-tests/ByteTest.cc
	M    unit-tests/ResponseBuilderTest.cc
	M    unit-tests/generalUtilTest.cc
	A  + unit-tests/dds-testsuite/test.19d1.xml
	A  + unit-tests/dds-testsuite/test.19b6.xml
	A  + unit-tests/dds-testsuite/test.19b.xml
	A  + unit-tests/dds-testsuite/test.19c.xml
	A  + unit-tests/dds-testsuite/test.19d.xml
	A  + unit-tests/dds-testsuite/test.19e.xml
	A  + unit-tests/dds-testsuite/test.19f.xml
	A  + unit-tests/dds-testsuite/test.19g.xml
	M    unit-tests/testFile.cc
	M    unit-tests/CEFunctionsTest.cc
	A  + unit-tests/testFile.h
	A  + unit-tests/ddx-testsuite/response_builder_send_data_ddx_test_3.xml
	A  + unit-tests/ddx-testsuite/response_builder_send_data_ddx_test.xml
	A  + unit-tests/ddx-testsuite/response_builder_send_ddx_test.xml
	M    unit-tests/Makefile.am
	M    unit-tests/MarshallerTest.cc
	M    dds.y
	_M   fdiostream.h
	M    GeoConstraint.cc
	M    Array.h
	M    ce_expr.lex
	M    dap-config.in

2012-04-11  James Gallagher  <jgallagher@opendap.org>

	Removed the 'override' file feature - it was never used and its implementaion was a problem.
	M    HTTPCacheTable.cc
	M    mime_util.h
	M    mime_util.cc
	M    XDRStreamMarshaller.cc

	Initial implementation of checksums using MD5. This shows that it is not going to trash performance to compute checksums/ The code to embed the checksums in the serialized data stream and then extract them in/on the client has not been added. Use configure --enable-checksums to get the feature in libdap.

	Indenting fixes.

	Fixed an error message to be a bit more intelligable.

2012-04-09  Patrick West  <pwest@opendap.org>

	If curl is not in a standard location then the makefiles need to know where it is to build tests. curl/types.h is no longer included. M    tests/Makefile.am M    unit-tests/Makefile.am M    HTTPConnect.h M    dap-config.in

2012-02-16  James Gallagher  <jgallagher@opendap.org>

	Added unistd .h to ResponseBuilder.cc

2012-02-07  James Gallagher  <jgallagher@opendap.org>

	Version 3.11.3

	Removed the static curl libs from dap-config.

2012-01-17  James Gallagher  <jgallagher@opendap.org>

	News was updated.
	M    NEWS

2012-01-10  James Gallagher  <jgallagher@opendap.org>

	Update for Hyrax 1.8 release.
	M    ChangeLog
	M    tests/package.m4
	M    INSTALL
	M    README
	M    NEWS

2012-01-04  James Gallagher  <jgallagher@opendap.org>

	version number bump in NEWS

2011-12-30  James Gallagher  <jgallagher@opendap.org>

	Bumped up the versions in libdap to 3.11.2. Not sure if this will be the version number we use for the release.

	Fixed the rpm build; included the man page stuff.
	M    libdap.spec

	Added HTTPCacheMacros.h

2011-12-29  James Gallagher  <jgallagher@opendap.org>

	Fixes for distcheck given the new man pages
	M    Makefile.am

	Added man pages for getdap and dap-config
	M    Makefile.am
	A    getdap.man1
	A    dap-config.man1

	Removed calls to exit(). Fixed the FSF address. Half of ticket 1868.

2011-12-19  James Gallagher  <jgallagher@opendap.org>

	comment fixes

2011-11-30  James Gallagher  <jgallagher@opendap.org>

	Formatting, Spelling and an error message's text fixed.

	Fix for Fedora builds; the extra newlines in these baseline files are likely breaking the tests
	M    tests/expr-testsuite/test.6b.base
	M    tests/expr-testsuite/test.5e.base

2011-11-23  Patrick West  <pwest@opendap.org>

	With HTTPConnect including CURL headers, added CURL_CFLAGS to the --cflags option M    dap-config.in

	CURL_CFLAGS was not being used when compiling tests. Added. M    unit-tests/Makefile.am

	curl includes were not being included properly. Works if in common place, but not if in custom location. M    tests/Makefile.am

	curl/types.h is deprecated and no longer needed M    HTTPConnect.h

2011-11-16  James Gallagher  <jgallagher@opendap.org>

	AttrTable was using id2www() to escape spaces and other characters in attribute names. This was done probably because of the spaces (spaces in the attribute names break the DAP2 DAS object parser), but no matter. It was breaking DAS and DDX objects because names with '%' characters in them were mangled. I replaced id2www and www2id with new functions that encode/decode only spaces. I have not fiddled with the find functions; it's fine to use names with spaces in them with the API, but the printed representation of the DAS will show those spaces as %20. Similarly, when the printed representation is parsed, those %20 escape codes are replaced with real spaces. This means that the names in the binary objects and XML representation are correct.

2011-11-15  James Gallagher  <jgallagher@opendap.org>

	Fix for ticket 1841 - the xml attribute 'base' in the Dataset root element should have been preceeded by the namespace 'xml'. It is now.

2011-11-13  James Gallagher  <jgallagher@opendap.org>

	Fixed, I hope, the problem with the xmlTextWriter code in version 2.6 of libxml. I think what was happening was really tripping over an odd feature of the xmlTextWriter API where the TextWriter object has to be freed before the pointer it has been writing to can be used. Actually, I suspect that freeing the object calls the buffer flush function, so calling that would probably work, too. I opted for the call sequence in the only example I can dig up...

	Fix for ticket 1837. The code libxml2 was escaping attributes with with OtherXML, turning them into useless goo. I switched from the ...WriteString to ...WriteRaw function for this type of attribute and order was restored.

2011-10-31  Patrick West  <pwest@opendap.org>

	The code was printing a blank line when certain conditions existed. Removed that code. M    DDS.cc

2011-10-27  James Gallagher  <jgallagher@opendap.org>

	Updates for the new DDX tests... nearly done

2011-10-24  Patrick West  <pwest@opendap.org>

	Forgot a quote M    dap-config.in

	Added xml2 includes to cflags M    dap-config.in

2011-10-24  James Gallagher  <jgallagher@opendap.org>

	some poking around regarding the DDX/XML bug (1829). Doesn't look like it's in libdap. Some cleanup, though.

	Fixed the distcheck target.
	M    unit-tests/dasT.cc
	M    unit-tests/AISMergeTest.cc
	M    unit-tests/MIMEUtilTest.cc
	M    unit-tests/ddsT.cc
	M    unit-tests/ByteTest.cc
	M    unit-tests/Makefile.am

2011-10-24  Nathan Potter  <ndp@opendap.org>

	libdap: Fixed problems with libxml dependencies.

2011-10-22  James Gallagher  <jgallagher@opendap.org>

	Added testFle.h in unit-tests

2011-10-21  James Gallagher  <jgallagher@opendap.org>

	Added libparsers_la_CPPFLAGS so that -I for libxml2 will be used when building the grammar files (really only needed for the DAS stuff?). Also fixed minor warning in HTTPCache where a File* could be used uninitialized.
	M    Makefile.am
	M    HTTPCache.cc

	I added a new method to DDS that can insert a variable anywhere in the DDS. I also added 'nocopy' versions of the new insert_var() method and the older ad_var() method. Once the ncml handler stabilizes, we can start using those methods to boost performance. Lastly, I forgot to add the new XMLWriter class on the last commit,

2011-10-12  James Gallagher  <jgallagher@opendap.org>

	I added a new method to BaseType, DDS and DAS: print_xml_writer() that takes a XMLWriter object and uses libxml2's xml writer API to build the DDX response. This should fix all of our woes WRT xml encoding. The new method is called by the DDS::print_xml method although it could be used in place of that method since it has the same parameters. I added tests and, in the course of that, modified the way some of the tests are done (using files instead of string variables for the regexs). I also tried adding some globbing functions to the util.cc file but those proved less than totally useful - I've left them there all the same.

2011-09-23  James Gallagher  <jgallagher@opendap.org>

	Fix for the unit test of get_request_size(). For this function, different compilers return different values for sizeof(string) so I made the unit test an OR of two values. Fixed here on the branch and on the trunk.
	M    unit-tests/DDSTest.cc

	Added a change to the DDS unit tests so that older compilers that report the sizeof(string) as 4 bytes will not bork the get_request_size unit test.
	M    unit-tests/DDSTest.cc

2011-09-21  James Gallagher  <jgallagher@opendap.org>

	Hyrax 1.8
	A    http://scm.opendap.org/svn/branch/libdap/3.11.2

2011-09-13  James Gallagher  <jgallagher@opendap.org>

	Refactor - no change to the ABI.

2011-08-24  James Gallagher  <jgallagher@opendap.org>

	Merge of Hyrax 1.7.1
	_M   .
	_M   OSX_Resources/Info.plist.proto
	M    DAS.h
	M    DDS.cc
	_M   tests/old_tests/grid-func-testsuite
	_M   tests/old_tests/server-testsuite
	M    tests/expr-testsuite/test.6b.base
	M    DDS.h
	M    BaseType.cc
	M    Constructor.h
	M    AttrTable.cc
	_M   mime_util.h
	_M   mime_util.cc
	M    Constructor.cc
	M    unit-tests/cache-testsuite/Makefile.am
	_M   unit-tests/MIMEUtilTest.cc
	_M   unit-tests/fdiostreamTest.cc
	_M   fdiostream.h

2011-08-17  James Gallagher  <jgallagher@opendap.org>

	Some minor changes to make the DBG() statements easier to decipher; some additions to error messages; and the removal of the old code used to merge hdf4 DAS and DDS objects.

2011-08-02  James Gallagher  <jgallagher@opendap.org>

	Hacked the Makefile.am so that distcheck works with older versions of automake. The distcheck target was failing due to a directory made by a unit test not being removed during distclean.
	M    unit-tests/cache-testsuite/Makefile.am

2011-07-15  James Gallagher  <jgallagher@opendap.org>

	Fixed an issues with the response too big error message - the sizes were returned in Bytes, but the units were listed as KB. Now the values are in KB (truncated, but good enough).

2011-06-30  Patrick West  <pwest@opendap.org>

	Merge hyrax 1.7 branch to trunk

2011-06-09  James Gallagher  <jgallagher@opendap.org>

	Added support for the first version of response size limits - does not do much for Sequences.

2011-05-30  James Gallagher  <jgallagher@opendap.org>

	Added get/set_response_limit() and get_request_size() (first version) to libdap:DDS.

2011-05-17  James Gallagher  <jgallagher@opendap.org>

	Errant char in Makefile.am
	M    unit-tests/Makefile.am

2011-05-10  James Gallagher  <jgallagher@opendap.org>

	Added --with-curl and --with-xml2 to configure.

2011-05-04  James Gallagher  <jgallagher@opendap.org>

	h 1.7 edits
	M    tests/package.m4

2011-04-25  James Gallagher  <jgallagher@opendap.org>

	3.9.1
	M    configure.ac
	M    ChangeLog
	M    Makefile.am
	M    NEWS

	3.11.1
	M    configure.ac
	M    ChangeLog
	M    INSTALL
	M    libdap.spec
	M    README
	M    NEWS

	Removed doc rpm - this breaks when the build hosts lacks dot or dot does not make inamges.
	M    libdap.spec

2011-04-20  James Gallagher  <jgallagher@opendap.org>

	Hyrax 1.7 releaseHyrax 1.7 release
	A    http://scm.opendap.org/svn/branch/libdap/3.11.1

2011-04-08  James Gallagher  <jgallagher@opendap.org>

	Build fixes for h 1.7 osx meta package
	M    Makefile.am

2011-03-28  James Gallagher  <jgallagher@opendap.org>

	Loop/Race-condition in HTTPCacheTable.h fixed

	1.7RC1

2011-03-17  Nathan Potter  <ndp@opendap.org>

	libdap: Automated change of version number for OSX package builds.

2011-03-08  James Gallagher  <jgallagher@opendap.org>

	Merge for hyrax	1.7 from the hyrax_1.6.2_release branch	of shrew to the	trunk
	_M   .
	M    RValue.cc
	M    DODSFilter.cc
	M    OSX_Resources/InstallationCheck
	M    OSX_Resources/update_mac_package_contents.pl
	R  + OSX_Resources/Info.plist
	A  + OSX_Resources/Info.plist.proto
	M    DDS.cc
	M    Array.cc
	_M   tests/old_tests/grid-func-testsuite
	_M   tests/old_tests/server-testsuite
	M    DDXParserSAX2.cc
	M    AlarmHandler.h
	M    libdap.spec
	M    BaseType.cc
	M    Makefile.am
	_M   mime_util.h
	M    Vector.cc
	M    ce_functions.cc
	MM   mime_util.cc
	M    GridGeoConstraint.cc
	M    Constructor.cc
	M    DAS.cc
	M    Grid.cc
	M    escaping.cc
	_M   unit-tests/MIMEUtilTest.cc
	_M   unit-tests/fdiostreamTest.cc
	_M   fdiostream.h
	M    Clause.cc

2011-03-03  Patrick West  <pwest@opendap.org>

	These files are generated D    gl/alloca.h D    gl/arg-nonnull.h D    gl/langinfo.h D    gl/stdint.h D    gl/c++defs.h D    gl/wctype.h D    gl/warn-on-use.h D    gl/wchar.h D    gl/unistd.h

2011-03-03  James Gallagher  <jgallagher@opendap.org>

	All tests back in.
	M    unit-tests/HTTPConnectTest.cc

	Fixed HTTPCache hack that provides access to the cached response body. Also fixed an error in Keywords that broke a gazillion tests.

	Eh - ctor fix for Keywords

	Keywords2 was modified so it'll build on older (4.1) gcc compilers (with an older stl implementation).

	Modified HTTPConnect to store the filename of the cached body when returning cached responses. Use the HTTPResponse::get_file() method to use this. Once the HTTPResponse is deleted, the name is no loner valid.

2011-03-01  James Gallagher  <jgallagher@opendap.org>

	Added Keywords to DDS and modified the behavior of set_dap_version so that '2' parses as '2.0' (really 'x' --> 'x.0').

2011-03-01  Patrick West  <pwest@opendap.org>

	Created from .in file. D    gl/stdlib.h

2011-02-28  Patrick West  <pwest@opendap.org>

	added include of cstring for strlen and strncpy M    ResponseBuilder.cc

2011-02-25  James Gallagher  <jgallagher@opendap.org>

	Removed old Keywords impl.

	Keywords2 now tests for legal values.

	Keywords2 works - this syntax looks like functions but is to be parsed before the CE is formally processed.

	Keywrods2Test.cc...

	Keywords2...

2011-02-24  James Gallagher  <jgallagher@opendap.org>

	new Keywords implementations started.

	Next version of Keywords - This implements the version where keywords are bound to a pair made up of a kind and a value. Probably won't use this because of potential problems with ambiguity - it's not possible to guarantee that 'dap3.2' won't be an identifier in a data set.

	g++ 4.? warnings about char* conversion in HTTPConnectTest

	New Keywords class first version working/tested

2011-02-23  James Gallagher  <jgallagher@opendap.org>

	Factored keywords out of ResponseBuilder and into their own class (Keywords).

2011-02-15  Patrick West  <pwest@opendap.org>

	This file is automatically generated D    gl/configmake.h

2011-02-08  James Gallagher  <jgallagher@opendap.org>

	Initial cut at support for Version information in the CE.

	I modified the documentation for mime_util and ResponseBuilder so that they describe a truer version of the world - most of the MIME header code is no longer used by libdap or the BES/handlers (instead the headers are added by the OLFS). Some of the mime_util code is used by the client side, however, and a tiny bit is used by the parts of ResponseBuilder I added so that the BES can use ResponseBuilder in those cases where there is no OLFS.

	Reverted to pre-DAP4 hack versions of these... The new features are implemented in ResponseBuilder.
	M    DODSFilter.cc
	M    DODSFilter.h

2011-02-07  James Gallagher  <jgallagher@opendap.org>

	ResponseBuilder now assumes that the default protocol for a response is the DAP_PROTOCOL_VERSION read from config.h. This can be overridden using a parameter to the various set_mime_*() methods it defines (which are different from those in mime_util.cc). NB: These are not used by Hyrax, but the BES might use these sometimes and I've got mods pending in the BES to use this code.

	Comments about ResponseBuilder

	Comments about ResponseBuilder

	Comments about ResponseBuilder

	Added comment about ResponseBuilder

	Added comment about ResponseBuilder

2011-02-03  James Gallagher  <jgallagher@opendap.org>

	These are templates needed by the code in 'gl.' I think ...
	A    conf/c++defs.h
	A    conf/warn-on-use.h
	A    conf/arg-nonnull.h

2011-02-02  James Gallagher  <jgallagher@opendap.org>

	Removed these files as a result of the massive commit
	D    gl/m4/wchar.m4
	D    gl/m4/ulonglong.m4
	D    gl/m4/absolute-header.m4
	D    gl/m4/wctype.m4
	D    gl/alloca_.h
	D    gl/wchar_.h
	D    gl/stdint_.h
	D    gl/stdbool_.h
	D    gl/unistd_.h
	D    gl/wctype_.h
	D    gl/stdlib_.h
	D    gl/alloca.c

	Added as part of the massive update.
	A    gl/m4/fcntl-o.m4
	A    gl/m4/configmake.m4
	A    gl/m4/btowc.m4
	A    gl/m4/00gnulib.m4
	A    gl/m4/locale-fr.m4
	A    gl/m4/langinfo_h.m4
	A    gl/m4/mbsinit.m4
	A    gl/m4/warn-on-use.m4
	A    gl/m4/wchar_h.m4
	A    gl/m4/wcrtomb.m4
	A    gl/m4/locale-zh.m4
	A    gl/m4/stddef_h.m4
	A    gl/m4/mbstate_t.m4
	A    gl/m4/wctype_h.m4
	A    gl/m4/nl_langinfo.m4
	A    gl/m4/locale-ja.m4
	A    gl/m4/wchar_t.m4
	A    gl/m4/multiarch.m4
	A    gl/alloca.h
	A    gl/arg-nonnull.h
	A    gl/langinfo.h
	A    gl/mbsinit.c
	A    gl/stdint.h
	A    gl/wcrtomb.c
	A    gl/btowc.c
	A    gl/c++defs.h
	A    gl/warn-on-use.h
	A    gl/wctype.h
	A    gl/streq.h
	A    gl/alloca.in.h
	A    gl/langinfo.in.h
	A    gl/configmake.h
	A    gl/verify.h
	A    gl/wchar.h
	A    gl/iswblank.c
	A    gl/mbrtowc.c
	A    gl/wchar.in.h
	A    gl/stdint.in.h
	A    gl/stdbool.in.h
	A    gl/unistd.in.h
	A    gl/stddef.in.h
	A    gl/wctype.in.h
	A    gl/nl_langinfo.c
	A    gl/stdlib.in.h

	Massive (and massively overdue) updates - this may be the fix for ticket #1702 But regardless, it's certainly needed.
	M    gl/m4/wint_t.m4
	M    gl/m4/localcharset.m4
	M    gl/m4/stdint.m4
	M    gl/m4/stdbool.m4
	M    gl/m4/gnulib-common.m4
	M    gl/m4/malloc.m4
	M    gl/m4/regex.m4
	M    gl/m4/gnulib-comp.m4
	M    gl/m4/mbrtowc.m4
	M    gl/m4/unistd_h.m4
	M    gl/m4/longlong.m4
	M    gl/m4/ssize_t.m4
	M    gl/m4/include_next.m4
	M    gl/m4/gnulib-cache.m4
	M    gl/m4/glibc21.m4
	M    gl/m4/codeset.m4
	M    gl/m4/stdlib_h.m4
	M    gl/m4/gnulib-tool.m4
	M    gl/m4/alloca.m4
	M    gl/m4/extensions.m4
	M    gl/localcharset.c
	M    gl/regex_internal.c
	M    gl/malloc.c
	M    gl/localcharset.h
	M    gl/regex_internal.h
	M    gl/regexec.c
	M    gl/ref-del.sin
	M    gl/stdlib.h
	M    gl/regcomp.c
	M    gl/ref-add.sin
	M    gl/regex.c
	M    gl/unistd.h
	M    gl/config.charset
	M    gl/regex.h
	M    gl/Makefile.am
	M    gl/gettext.h

	Corrected

2011-01-31  James Gallagher  <jgallagher@opendap.org>

	Expanded DDS so that it's easier to get the protocol version string; moved the relevant MIME header code into ResponseBuilder on the assumption that someone might be using this still (like CEDAR). Updated the unit tests.

2011-01-29  James Gallagher  <jgallagher@opendap.org>

	Leaner version of ResponseBuilder - the new replacement for DODSFilter.

2011-01-28  James Gallagher  <jgallagher@opendap.org>

	Commented out test code that got in SVN by mistake (in expr-test.cc)

	Changes/Additions for Version via Projection Functions and/or Keywords.

2010-10-28  Michael Johnson  <michael.patrick.johnson@gmail.com>

	Merge from Hyrax 1.6.2 Shrew Release Branch.
	Not clear what the property modifications are, the ones I checked seem the same.  I'm just letting them go since they seem harmless.

2010-09-14  James Gallagher  <jgallagher@opendap.org>

	Fixed a bug in the www2id() function of escaping.cc that was causing symbols that start with a percent sign to be mangled. It's not clear why the server was/is using this, but this fixes the function and we'll have to sort out whether using the function is correct later. It may be that the BES is routing the DAS through an unnecessary cycle of print/parse/print operations.

	Added tests for www2id() and the case where an attribute starts with a percent sign.

	Spelling errors in GeoConstraint.cc

	Fixed an error in calling long_to_string with doubles in exception handling code - found during testing.

	Updated for fixes to a problem foud in initial testing of the server for the 1.6.2 release.

	Added a second version of eval_function_clauses() that takes and returns a DataDDS instead of a DDS. This enables easier use of the method in handlers that are using subclasses of the types and building responses from DataDDS objects passed around in the BES. I also updated some of the library version information in configure.ac to match more closely the addition to ConstraintEvaluator's interface.

2010-09-13  James Gallagher  <jgallagher@opendap.org>

	Changes for 3.11.0 release
	M    configure.ac
	M    ChangeLog
	M    INSTALL
	M    libdap.spec
	M    README
	M    NEWS
	M    ce_functions.cc

2010-09-07  James Gallagher  <jgallagher@opendap.org>

	Added to doc comments

2010-09-03  James Gallagher  <jgallagher@opendap.org>

	Updated the version number for geogrid.

2010-09-02  James Gallagher  <jgallagher@opendap.org>

	Constraint expressions can now include multiple function calls. Two tests included. Some fixes were added to expr-test.cc which was looking a little long in the tooth...

	Added new functions to ConstraintEvaluator. Untested.

2010-09-01  Michael Johnson  <michael.patrick.johnson@gmail.com>

	o Fix for memory bug in ticket #1637.

2010-08-28  James Gallagher  <jgallagher@opendap.org>

	Grid now prints the XML declaration correctly when a constrained Grid variable's type decays to a Structure. The expr-test program now has an XML option (-x) for use with constrained DDS/DDX output.

2010-08-27  James Gallagher  <jgallagher@opendap.org>

	Fixed the Grid projection bug - should clean up the code a bit. The error was in projection yields grid which was not correctly testing that each Grid dimension had a matching Map vector that was in the current projection.

	Added regression tests for the new version of geogrid(). Removed some old stuff from the dejagnu days.

	Added more tests (unit tests) for GridGeoConstraint for the Grid, Array, Array, ..., version of the constructor.

	geogrid() now takes both (grid, <box points>) and (grid, lat array, lon array <box points>). This includes some minimal testing of the new code.

2010-08-26  James Gallagher  <jgallagher@opendap.org>

	Changes to the geogrid function so that it can take lat/lon maps as explicit arguments.

2010-07-16  James Gallagher  <jgallagher@opendap.org>

	I removed the AIS functions in libdap 3.8 but failed to correctly set the Age of the library in libdap 3.10. Fixed.

2010-06-17  Michael Johnson  <michael.patrick.johnson@gmail.com>

	Removed debug AM_CXXFLAGS entries.

2010-05-24  James Gallagher  <jgallagher@opendap.org>

	Updated tests given that the nph-dods alias is no longer supported by test.opendap.org
	M    unit-tests/HTTPCacheTest.cc
	M    unit-tests/generalUtilTest.cc

2010-05-19  Patrick West  <pwest@opendap.org>

	Seems to fix bug #1563. When adding an attribute table to the DAS when a container is currently set, set that new attribute table to not be global using set_is_global_attribute(false) M    DAS.cc

2010-05-12  James Gallagher  <jgallagher@opendap.org>

	Fixed etag for 304 response test - the etag changed when the server was updated.
	M    unit-tests/HTTPConnectTest.cc

2010-05-11  James Gallagher  <jgallagher@opendap.org>

	Merge from the shrew-1.6 branch (which was tagged 3.10.2)
	_M   .
	M    SignalHandler.cc
	M    configure.ac
	M    ChangeLog
	M    conf/libdap.m4
	M    DDS.cc
	M    BaseType.h
	_M   tests/old_tests/grid-func-testsuite
	_M   tests/old_tests/server-testsuite
	M    tests/das-test.cc
	M    tests/package.m4
	M    tests/DASTest.at
	M    tests/DDSTest.at
	M    tests/expr-test.cc
	M    tests/EXPRTest.at
	M    tests/Makefile.am
	M    tests/dds-test.cc
	M    INSTALL
	M    DDXParserSAX2.cc
	M    libdap.spec
	M    README
	M    DDS.h
	M    BaseType.cc
	M    Makefile.am
	M    Constructor.h
	M    RCReader.cc
	M    parser-util.cc
	M    AttrTable.cc
	_M   mime_util.h
	M    Grid.h
	M    NEWS
	M    ce_functions.cc
	M    AttrTable.h
	_M   mime_util.cc
	M    Constructor.cc
	M    Grid.cc
	M    Connect.cc
	M    escaping.cc
	M    unit-tests/DODSFilterTest.cc
	M    unit-tests/DDSTest.cc
	_M   unit-tests/MIMEUtilTest.cc
	MM   unit-tests/fdiostreamTest.cc
	M    unit-tests/generalUtilTest.cc
	M    unit-tests/dds-testsuite/test.19b.das
	M    unit-tests/dds-testsuite/test.19e.das
	M    unit-tests/dds-testsuite/test.19g.das
	A  + unit-tests/dds-testsuite/coads_climatology.nc.dds
	A  + unit-tests/dds-testsuite/coads_climatology.nc.das
	M    unit-tests/Makefile.am
	M    unit-tests/RCReaderTest.cc
	M    unit-tests/MarshallerTest.cc
	_M   fdiostream.h

	ci prior to merge
	M    tests/DASTest.at
	M    tests/DDSTest.at
	M    tests/EXPRTest.at

	Vesion update.
	M    tests/package.m4

2010-05-06  Patrick West  <pwest@opendap.org>

	Fixed problem with checking libdap version M    libdap.m4

2010-05-05  James Gallagher  <jgallagher@opendap.org>

	Added these test files.
	A    dds-testsuite/coads_climatology.nc.dds
	A    dds-testsuite/coads_climatology.nc.das

2010-05-04  James Gallagher  <jgallagher@opendap.org>

	Updated for hyrax 1.6 (libdap3.10.2) RC1
	M    configure.ac
	M    ChangeLog
	M    INSTALL
	M    libdap.spec
	M    README
	M    NEWS

2010-04-30  James Gallagher  <jgallagher@opendap.org>

	Fixed an error in AttrTable::is_global_attribute() where the function did not always return a value.
	M    AttrTable.cc

	Commented the fdiostreamTest stuff - automake was complaining. Removed a bunch of AIS-related things that are no longer needed.

2010-04-30  Michael Johnson  <michael.patrick.johnson@gmail.com>

	AttrTable.cc, AttrTable.h: Changes for #1544.  clone() wasn't preserving parent/child ptrs properly leading to dangling pointers.

2010-04-26  Patrick West  <pwest@opendap.org>

	Fixed version check when a (alpha) or b (beta) at the end of the version M    conf/libdap.m4

2010-04-23  James Gallagher  <jgallagher@opendap.org>

	Modified the transfer_attributes code so that it checks the is_global property for individual attributes and containers (before it was just containers). This entailed a change to AttrTable in both the way it tracks and sets that property. Fixed the unit tests. Several tests became invalid because they tested handler-specific features that are not delt with in the handlers themselves.

2010-04-22  Michael Johnson  <michael.patrick.johnson@gmail.com>

	Added version update to INSTALL as well for #1540

2010-04-22  Patrick West  <pwest@opendap.org>

	Requires libxml2 2.6.16 M    libdap.spec

2010-04-21  James Gallagher  <jgallagher@opendap.org>

	Initial check in of the new methods to handle the transfer (copy) of attributes from the DAS to the DDS object. The new approach includes a new set of methods that are defined in BaseType and Constructor that are designed to be subclassed by handlers that build odd DAS objects. The default methods handle merging a DAS the follows the DAP 2.0 and later specs. The method in DDS calls these 'type-based' methods. The old approach is commented out using #if 0 ... #endif.

2010-04-21  Michael Johnson  <michael.patrick.johnson@gmail.com>

	Added #include <cstdarg> for va_start and va_end    Some systems don't find it by default.

2010-04-16  Michael Johnson  <michael.patrick.johnson@gmail.com>

	Fixed invalid memory and broken invariant problem with using deleted copy in Grid::add_var().  Ticket #1530 revealed this.

2010-04-15  James Gallagher  <jgallagher@opendap.org>

	Added dits-hook target to remove the .svn subdirs that were being included in the dist files.
	M    libdap/Makefile.am
	M    bes/Makefile.am

	Added Requires: lines to the .spec files for libdap and bes.

2010-03-23  James Gallagher  <jgallagher@opendap.org>

	Fixes for distcheck build on 64-bit linux (FC 11)
	M    SignalHandler.cc
	M    RCReader.cc
	M    parser-util.cc
	M    unit-tests/MarshallerTest.cc

	Fixes from the 64-bit linux build. Includes fix for the DAS value issue where values larger than 32-bits were being allowed in int32 attributes.
	M    tests/das-test.cc
	M    tests/dds-test.cc
	M    libdap.spec
	M    Makefile.am
	M    parser-util.cc
	M    unit-tests/RCReaderTest.cc

	Removed fdiostream from libdap and from the tests. Changed generalUtilTest to match the new version of id2xml()

2010-03-19  James Gallagher  <jgallagher@opendap.org>

	More changes for ticket 1521. Modified the id2xml() function so that it no longer encodes the stuff in an octal escape sequence. However, the value of the <value> element in the DDX _is_ encoded so that things like '<' will be escaped for the XML parser. Also, bumped the version in configure.ac to 3.10.1b. One unit test fails - this is a stop-gap fix so we can come back to that test and this fix later.

	MOdified Connect.cc so that the FILE_METHODS aere used, whcih effectively removed the fdiostream.h header from the cmpilation. Also, the DAP version has been bumped to 3.3 - a fix since libdap included in the hyrax 1.6 beta release said 3.2 by mistake.

	Fixes for ticket 1512. The function id2xml() was being used to encode String (DAP) Attribute values and this was causing problems when those values were not valid UTF-8 characters (e.g., when they were less than 0x20). As a fix we dropped the encoding altogether and fell back to the same encoding used by the DAS for the values (that encoding represents all non ASCII values using octal escape codes). I also fixed one of the unit tests that was explicitly testing for the XDAP header to be 3.2 and made it accept any value.

2010-02-10  Patrick West  <pwest@opendap.org>

	fdiostreamtest.txt file added to EXTRA_DIST M    unit-tests/Makefile.am

2010-02-08  Patrick West  <pwest@opendap.org>

	EXPRTest.at wasn't included in EXTRA_DIST M    tests/Makefile.am

2010-02-05  Patrick West  <pwest@opendap.org>

	Added DISTCLEANFILES to both of these to clean up unit-tests and tests files left around. M    tests/Makefile.am M    unit-tests/Makefile.am

	Including test_config.h, which has the local definition of abs_srcdir and can be used to find files to load. M    fdiostreamTest.cc

	Using abs_srcdir instead of just srcdir. This fixes this part of the distcheck problem. M    tests/DASTest.at M    tests/DDSTest.at M    tests/EXPRTest.at

	README.AIS has been removed M    libdap.spec

2010-02-03  James Gallagher  <jgallagher@opendap.org>

	Fixes for autotest that I forgot to check in to the branch. $srcdir/<tool> --> $abs_builddir/<tool>

2010-02-01  James Gallagher  <jgallagher@opendap.org>

	Branch for Hyrax 1.6
	A    http://scm.opendap.org/svn/branch/libdap/3.10.0

	Chnages for version 3.10.0
	M    configure.ac
	M    ChangeLog
	M    INSTALL
	M    libdap.spec
	M    README
	M    NEWS

	Modified the way errors in attribute values are tested for. Now we test errno first, then for values of 0.0 with ptr values non-null. This matches the man page more closely then the old tests.

2010-01-12  James Gallagher  <jgallagher@opendap.org>

	Fixed potential read beyond bounds in XDRStreamUnMarshaller::get_vector.

	Fixed return type in Vector::set_value_slice_from_row_major_vector (changed to unsigned int).

	Fixed a comment

2010-01-08  Patrick West  <pwest@opendap.org>

	--clean to clean build and src files for rpmbuild M    Makefile.am

2010-01-07  James Gallagher  <jgallagher@opendap.org>

	Changed the documentation for server-side functions so that the bulk of the documentation is now on the web.

	Fixes to geogrid() so that the longitude wrapping feature works and so that if latitude is upsidedown in the data, it's returned as 'north up' data.

2009-12-29  James Gallagher  <jgallagher@opendap.org>

	Shrew build changes that will hopefully lead to a version that we can build using NMI's B&T system. Also, I added 'cccc' targets so that we can take a 'metrics snapshot' without undue pain.

2009-12-23  Rikki Duncan  <rduncan@opendap.org>

	changes for win32 build

	changes for win32 build

	changes for win32 build

	changes for win32 build

	changes for win32 build

2009-12-03  James Gallagher  <jgallagher@opendap.org>

	Added chmod of InstallationCheck script which seems to be needed when buidling on osx 10.5.8.
	M    update_mac_package_contents.pl

2009-12-01  Michael Johnson  <michael.patrick.johnson@gmail.com>

	o Needed to add explicit #include <cstring> in order to find memcpy for Red Hat Enterprise 5 using gcc-4.3.2.  Seems they cleaned up headers and you need to be explicit about the include now.

2009-11-30  Michael Johnson  <michael.patrick.johnson@gmail.com>

	Fix for link bug on some platforms:  initializing variables in a switch without declaring a local scope block is an error.

	Fix for link bug on some platforms:  initializing variables in a switch without declaring a local scope block is an error.

2009-11-24  Michael Johnson  <michael.patrick.johnson@gmail.com>

	DDS.cc: fixed minor memory leak
	Array.cc, Array.h: added prepend_dim function for adding outer dimensions.

	Grid.h, Grid.cc: added function to set the array part explicitly without copying it.  fixed potential memory leaks.  added a few extra checks on proper types being set.  added function to add maps to (to beginning or end of map vector to support new outer dimensions).  made _duplicate protected for subclasses to be able to call it.

2009-11-19  James Gallagher  <jgallagher@opendap.org>

	ticket 1399 - Grids that have only one member after projection still must be wrapped in a Structure (because there might be two Grids so projected and they might have members with the same names - this is a real case). The Structures provide for unique FQN as the DAP requires.

	Added Dap4SharedDimension class

	Added unit tests for Dap4Dataset and Dap4Group

	Dap4Dataset and Dap4Group are mostly working and DDS is now a child or Structure (but is not using any of its parents methods). Dap4Dataset is a DDS, so it can be passed to the various methods already defined for a DDS & or *. TODO: refactor DDS so that it uses the methods/storage of Structure, then refactor Grid and Sequence so they are children of Structure, not Constructor. Then remove Constructor from Structure.

2009-11-13  James Gallagher  <jgallagher@opendap.org>

	removed old classes for the AIS; Added Dap4Dataset and Dap4Group; updated s number of tests; and merged from the trunk.

2009-11-10  James Gallagher  <jgallagher@opendap.org>

	Removed libdapserver from the getdap link.

	Branch for the DAP4 development effort.
	A    http://scm.opendap.org/svn/branch/libdap/DAP4

2009-11-05  James Gallagher  <jgallagher@opendap.org>

	I changed how the FILE_METHODS compile-time switch was defined, Now it's defined in the headers and not, directly in the config.h or *.cc files. That was a bug. All tests pass now. I'm going to check this in and then run tests on the entire shrew project.

2009-11-04  James Gallagher  <jgallagher@opendap.org>

	Removed lots of accumulated 'old code' and reinstated the FILE_METHODS compilation flag.

	Likely fixes for the win32 build. Test these on a vm.

	tweaks to get the ddx and dataddx responses working with the trunk BES. See getdap's -x (ddx) and -X (DataDDX) responses. These work using the -p x.y switch to set the DAP Accept version to x.y. Alos added the -t option to turn on HTTP protocol tracing. The new parser DDXParserSXA2 reads the dapVersion XML attribute and sets the value in the DDS instance. I also modified the Connect class to recognize the dods_ddx and dods-ddx values for Content-Description.

2009-10-22  Michael Johnson  <michael.patrick.johnson@gmail.com>

	Ticket #1442:
	o Fixed several potential memory leaks.

	o set_value now sets length.

	o Refactored cut & pasted sections to use helper funcs.

2009-10-07  Michael Johnson  <michael.patrick.johnson@gmail.com>

	Made simple_find() and simple_find_container() public for callers that require non-recursing lookups.

2009-10-06  James Gallagher  <jgallagher@opendap.org>

	I fixed problems with two sets of tests. First, the "Array of structures with child arrays" test was failing because the TestCommon and TestArray classes were not generating valid output in the case where intern_data() was used. Second, the test for String regexes where nothing matched was botched because when a selection is applied to anything other than a Sequence and nothing is selected the response from the server is broken. This will be an issue for DAP4. In place of the test that used a Structure and selected nothing, I added two tests of Sequences with strings and tried both selections that return and don't return values. Both cases work.

2009-10-05  Michael Johnson  <michael.patrick.johnson@gmail.com>

	Vector.h, Vector.cc: Cleaned up and moved doxygen comments to impl file.

2009-10-02  Patrick West  <pwest@opendap.org>

	This funciton is no longer used in libdap and is specific to usage in dap-server. Moved the function. M    mime_util.h

2009-10-02  James Gallagher  <jgallagher@opendap.org>

	Regarding the previous commit: On the IOOS branch I removed a 'bad fix' added at some point where includes within util.h supplied the class definitions for Byte, ..., Grid. So it looked like the .cc files were not including must at all, but in fact not only were they (and they need those includes) but _everything_ that used util.cc/h was too. So here are the includes, back in the .cc files where they belong.

	Merged code from ioos/src/libdap rev 20393 that contained the 'OtherXML' attribute implementation. This was apparently lost when that branch was updated between the commit of that revision and now. In addition to changes in AttrTable and the DAS and DDX parsers, there are changes in tests/ and unit-tests/. There's also a new function for converting octal escapes codes that is in escaping.cc/h. I updated the DDX parser to use the SAX2 interface and it now correctly processes namespaces and as a result, it's in a new file 'DDXParserSAX2.cc/h'. Oddly, when I performed the merge, an old 'feature' of the Type (Byte, ...) classes reemerged, the 'include the world' feature. In testing I could not get a good compile without these includes after the merge (but before the merge it was fine). I'm going to leave those changes out of this commit and see if the resulting code is OK. If not, I'l commit those changes, too.

2009-10-02  Michael Johnson  <michael.patrick.johnson@gmail.com>

	Vector.cc, Vector.h: Added support for reserving data buffer storage in advance, clearing out data buffers, and for copying a Vector into a subset of the value buffer of another Vector.  In support of aggregation to allow Vector's to be combined into a larger Vector.  Ticket #1427 has more information.  This was a monotonic interface addition and code change only --- no interfaces removed or changed.

2009-09-25  James Gallagher  <jgallagher@opendap.org>

	Removed XDRFileMarshaller.h from DODSFilter.cc

	It just seem right to save things at this point. Most of the configure.ac files have been updated. The libdap software has had a number of the FILE* methods/functions commented out using #if FILE_METHODS and then #undef FILE_METHODS. We'll see how much of the redundant code can be removed before the next Hyrax 1.6 release.

	Added fdiostream to the library because it seems we might be using it someday soon. Modified expr-test to use temp. files and the methods in DODSFilter and Connect - this is a better test of the library. I modified XDRStreamUnMarshaller a fair amount but it's still not work 100% and needs more error checking. This code still uses XDRFileUnMarshaller.
	M    DODSFilter.cc
	A    fdiostream.cc
	M    tests/expr-test.cc
	M    tests/TestByte.cc
	M    tests/Makefile.am
	M    Marshaller.h
	D    GNU/fdiostream_test.cc
	D    GNU/fdiostream.h
	M    Makefile.am
	M    DODSFilter.h
	M    XDRStreamUnMarshaller.cc
	M    HTTPConnect.cc
	M    XDRStreamMarshaller.cc
	M    Connect.cc
	A  + unit-tests/fdiostreamTest.cc
	M    unit-tests/Makefile.am
	M    unit-tests/MarshallerTest.cc
	AM + fdiostream.h

2009-09-22  James Gallagher  <jgallagher@opendap.org>

	Removed the xstream code - if we need this it's available on the web.

	Fixed a bug in fdiostream and added support for a istream that reads from a FILE* (ugh).

2009-09-18  James Gallagher  <jgallagher@opendap.org>

	Uses the new file descriptor stream classes - that is, it tests both input and output.

	Added XDRStreamUnMarshaller to the Makefile.am

	Added XDRStreamUnMarshaller

	Minor fixes to the XDRStreamMarshaller class

2009-09-17  James Gallagher  <jgallagher@opendap.org>

	Now includes the newly revamped stream buffer classes (fdiostream.h)

	Added input stream buf for file descriptors and renamed the files. Updated the README.

2009-09-11  Michael Johnson  <michael.patrick.johnson@gmail.com>

	Grid.cc: Made Grid add it's array and map vectors to the Constructor _vars list so they get iterated by the superclass Vars_Iter calls.  For ticket #1406

2009-09-02  Nathan Potter  <ndp@opendap.org>

	libdap: tweaked configure.ac to fix uuid lib problem

2009-09-02  James Gallagher  <jgallagher@opendap.org>

	Updated the pkg-config and dap-config scripts so they contain the UUID library when needed.
	M    libdap.pc.in
	M    libdapserver.pc.in
	M    dap-config.in

	Build fixes for linux. Linux uses libuuid for the uuid functions while OSX does not - I added a test for that library to configure.ac and the corrsponding changes to the Makefile.am. I also found and fixed two other errors that were not showing up on the OSX platform.
	M    DODSFilter.cc
	M    configure.ac
	M    tests/Makefile.am
	M    Makefile.am

2009-09-02  Michael Johnson  <michael.patrick.johnson@gmail.com>

	o Fixed typo causing build error.

2009-08-31  James Gallagher  <jgallagher@opendap.org>

	Replace fgetln with fgets in DDXParser.cc.  oddly package.m4 in tests has the version number for the library. I changed that to 3.10.0 (we should have something for the trunk better than a version number that looks like a release number) since I didn't think 3.9.2 was a good value...

	Configure fixes.
	M    configure.ac

	Updates for make dist.
	M    tests/Makefile.am
	M    INSTALL
	M    Makefile.am

	Added

	Added.

2009-08-28  James Gallagher  <jgallagher@opendap.org>

	Refactor of libdap: AIS removed from build. In addition, bug tickets addressed for Array, DDS, Vector and parser-util.cc

2009-08-27  James Gallagher  <jgallagher@opendap.org>

	Moved mime_util to libdap from libdapserver.

	Removed unnecessary libdapserver use for the unit-tests after moving cgi_util to mime_util and putting the latter in libdap.

	Added code to build and read the DataDDX response for DAP4. Connect has request_data_ddx() and request_data_ddx_url() methods that will ask a server for the DataDDX and parse the returned response. Connect::read_data() can read a DataDDX response from a file; getdap -M - can read the DataDDX returned by besstandalone when it's asked to return a DataDDX. DODSFilter now has a send_data_ddx() method and appropriate functions are now in mime_util.cc/h to build and parse the multipart MIME response. I also refactored the code somewhat renaming cgi_util to mime_util and removing redundant MIME parsing code in Connect and HTTPConnect - now all the MIME header parsing is done by functions in mime_util. Since these are used by both client and server operations, that should be moved to libdap (from libdapserver).

2009-08-21  James Gallagher  <jgallagher@opendap.org>

	Changed ID to Id to match the RFCs in the set_mime...() functions.. Also removed the set_client_dap_version() method and the matching get methods - These were causing more confusion than anything else. Use set_dap_version() and the matching get methods.
	M    cgi_util.cc
	M    DDS.cc
	M    DDS.h

	Changed ID to Id in the set_mime...() code to match the RFCs; fixed here in tests.
	M    unit-tests/DODSFilterTest.cc

	Fixed an error where getdomainname() can return nothing and not indicate and error. Now the default domain name is opendap.org in that case.

2009-08-20  James Gallagher  <jgallagher@opendap.org>

	Updates for the DataDDX response. New values were added to the ObjectType and and EncodingType enums. DODSFilter now has a send_data_ddx method that can either supply just the body (as needed by the OLFS) or the complete message. Unit tests added in unit-tests.DODSFilterTest. In HTTPConnect, get_description_type() and get_object() were also updated. Lastly, I change the values of Content-Description slightly so they were a little less clunky and made the dap4 prefixed values use dashes instead of underscores.

2009-08-19  James Gallagher  <jgallagher@opendap.org>

	Interim version of autogen.sh for our projects - fix the --force option.
	M    autogen.sh

	Removed generated files.
	D    conf/mkinstalldirs
	D    conf/depcomp
	D    conf/compile
	D    conf/missing
	D    conf/config.guess
	D    conf/config.sub
	D    conf/ltmain.sh
	D    conf/install-sh

2009-08-18  Nathan Potter  <ndp@opendap.org>

	libdap: Repaired bad string syntax and formatting.

2009-08-18  Michael Johnson  <michael.patrick.johnson@gmail.com>

	Added set_name() override to set the name of the template var() as well since this is what is output in a DDS and they didn't match.  Ticket #1346.

2009-08-18  Tom Sgouros  <tsgouros@gmail.com>

	Changes to documentation only.  Formatted ce function documentation to be easier to read and removed a bad paragraph from the main doxygen docs.

2009-08-04  James Gallagher  <jgallagher@opendap.org>

	Added autogen.sh which is probably better than always running autoreconf.
	AM   autogen.sh

	Changes for gcc 4.4: Removed warnings about misplaced or missing const qualifiers and logic issues. Also fixed a missing header under FC 11 (util_mit.cc needs <cstdio> for sprintf).
	M    Int16.cc
	M    conf/mkinstalldirs
	M    conf/depcomp
	M    conf/missing
	M    conf/config.guess
	M    conf/config.sub
	M    conf/ltmain.sh
	M    conf/install-sh
	M    INSTALL
	M    UInt16.cc
	M    Byte.cc
	M    parser-util.cc
	M    Float32.cc
	M    HTTPConnect.cc
	M    Str.cc
	M    ce_functions.cc
	M    das.y
	M    UInt32.cc
	M    util_mit.cc
	M    dds.y
	M    RCReader.h

2009-07-28  James Gallagher  <jgallagher@opendap.org>

	Modified AISDataBaseParser.cc so that the library will build with the --enable-debug=2 configure option. ticket 1318

